"use strict";
(() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __esm = (fn, res) => function __init() {
    return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
  };
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
    mod
  ));

  // node_modules/p-finally/index.js
  var require_p_finally = __commonJS({
    "node_modules/p-finally/index.js"(exports, module) {
      "use strict";
      module.exports = (promise, onFinally) => {
        onFinally = onFinally || (() => {
        });
        return promise.then(
          (val) => new Promise((resolve) => {
            resolve(onFinally());
          }).then(() => val),
          (err) => new Promise((resolve) => {
            resolve(onFinally());
          }).then(() => {
            throw err;
          })
        );
      };
    }
  });

  // node_modules/p-timeout/index.js
  var require_p_timeout = __commonJS({
    "node_modules/p-timeout/index.js"(exports, module) {
      "use strict";
      var pFinally = require_p_finally();
      var TimeoutError = class extends Error {
        constructor(message) {
          super(message);
          this.name = "TimeoutError";
        }
      };
      var pTimeout = (promise, milliseconds, fallback) => new Promise((resolve, reject) => {
        if (typeof milliseconds !== "number" || milliseconds < 0) {
          throw new TypeError("Expected `milliseconds` to be a positive number");
        }
        if (milliseconds === Infinity) {
          resolve(promise);
          return;
        }
        const timer = setTimeout(() => {
          if (typeof fallback === "function") {
            try {
              resolve(fallback());
            } catch (error) {
              reject(error);
            }
            return;
          }
          const message = typeof fallback === "string" ? fallback : `Promise timed out after ${milliseconds} milliseconds`;
          const timeoutError = fallback instanceof Error ? fallback : new TimeoutError(message);
          if (typeof promise.cancel === "function") {
            promise.cancel();
          }
          reject(timeoutError);
        }, milliseconds);
        pFinally(
          promise.then(resolve, reject),
          () => {
            clearTimeout(timer);
          }
        );
      });
      module.exports = pTimeout;
      module.exports.default = pTimeout;
      module.exports.TimeoutError = TimeoutError;
    }
  });

  // node_modules/p-wait-for/index.js
  var require_p_wait_for = __commonJS({
    "node_modules/p-wait-for/index.js"(exports, module) {
      "use strict";
      var pTimeout = require_p_timeout();
      var pWaitFor2 = async (condition, options) => {
        options = {
          interval: 20,
          timeout: Infinity,
          leadingCheck: true,
          ...options
        };
        let retryTimeout;
        const promise = new Promise((resolve, reject) => {
          const check = async () => {
            try {
              const value = await condition();
              if (typeof value !== "boolean") {
                throw new TypeError("Expected condition to return a boolean");
              }
              if (value === true) {
                resolve();
              } else {
                retryTimeout = setTimeout(check, options.interval);
              }
            } catch (error) {
              reject(error);
            }
          };
          if (options.leadingCheck) {
            check();
          } else {
            retryTimeout = setTimeout(check, options.interval);
          }
        });
        if (options.timeout !== Infinity) {
          try {
            return await pTimeout(promise, options.timeout);
          } catch (error) {
            if (retryTimeout) {
              clearTimeout(retryTimeout);
            }
            throw error;
          }
        }
        return promise;
      };
      module.exports = pWaitFor2;
      module.exports.default = pWaitFor2;
    }
  });

  // node_modules/serialize-error/error-constructors.js
  var list, errorConstructors, error_constructors_default;
  var init_error_constructors = __esm({
    "node_modules/serialize-error/error-constructors.js"() {
      list = [
        EvalError,
        RangeError,
        ReferenceError,
        SyntaxError,
        TypeError,
        URIError,
        globalThis.DOMException,
        globalThis.AssertionError,
        globalThis.SystemError
      ].filter(Boolean).map(
        (constructor) => [constructor.name, constructor]
      );
      errorConstructors = new Map(list);
      error_constructors_default = errorConstructors;
    }
  });

  // node_modules/serialize-error/index.js
  var serialize_error_exports = {};
  __export(serialize_error_exports, {
    NonError: () => NonError,
    deserializeError: () => deserializeError,
    errorConstructors: () => error_constructors_default,
    isErrorLike: () => isErrorLike,
    serializeError: () => serializeError
  });
  function serializeError(value, options = {}) {
    const {
      maxDepth = Number.POSITIVE_INFINITY,
      useToJSON = true
    } = options;
    if (typeof value === "object" && value !== null) {
      return destroyCircular({
        from: value,
        seen: [],
        forceEnumerable: true,
        maxDepth,
        depth: 0,
        useToJSON,
        serialize: true
      });
    }
    if (typeof value === "function") {
      return `[Function: ${value.name ?? "anonymous"}]`;
    }
    return value;
  }
  function deserializeError(value, options = {}) {
    const { maxDepth = Number.POSITIVE_INFINITY } = options;
    if (value instanceof Error) {
      return value;
    }
    if (isMinimumViableSerializedError(value)) {
      const Error2 = getErrorConstructor(value.name);
      return destroyCircular({
        from: value,
        seen: [],
        to: new Error2(),
        maxDepth,
        depth: 0,
        serialize: false
      });
    }
    return new NonError(value);
  }
  function isErrorLike(value) {
    return Boolean(value) && typeof value === "object" && "name" in value && "message" in value && "stack" in value;
  }
  function isMinimumViableSerializedError(value) {
    return Boolean(value) && typeof value === "object" && "message" in value && !Array.isArray(value);
  }
  var NonError, commonProperties, toJsonWasCalled, toJSON, getErrorConstructor, destroyCircular;
  var init_serialize_error = __esm({
    "node_modules/serialize-error/index.js"() {
      init_error_constructors();
      init_error_constructors();
      NonError = class extends Error {
        name = "NonError";
        constructor(message) {
          super(NonError._prepareSuperMessage(message));
        }
        static _prepareSuperMessage(message) {
          try {
            return JSON.stringify(message);
          } catch {
            return String(message);
          }
        }
      };
      commonProperties = [
        {
          property: "name",
          enumerable: false
        },
        {
          property: "message",
          enumerable: false
        },
        {
          property: "stack",
          enumerable: false
        },
        {
          property: "code",
          enumerable: true
        },
        {
          property: "cause",
          enumerable: false
        }
      ];
      toJsonWasCalled = Symbol(".toJSON was called");
      toJSON = (from) => {
        from[toJsonWasCalled] = true;
        const json = from.toJSON();
        delete from[toJsonWasCalled];
        return json;
      };
      getErrorConstructor = (name) => error_constructors_default.get(name) ?? Error;
      destroyCircular = ({
        from,
        seen,
        to,
        forceEnumerable,
        maxDepth,
        depth,
        useToJSON,
        serialize
      }) => {
        if (!to) {
          if (Array.isArray(from)) {
            to = [];
          } else if (!serialize && isErrorLike(from)) {
            const Error2 = getErrorConstructor(from.name);
            to = new Error2();
          } else {
            to = {};
          }
        }
        seen.push(from);
        if (depth >= maxDepth) {
          return to;
        }
        if (useToJSON && typeof from.toJSON === "function" && from[toJsonWasCalled] !== true) {
          return toJSON(from);
        }
        const continueDestroyCircular = (value) => destroyCircular({
          from: value,
          seen: [...seen],
          forceEnumerable,
          maxDepth,
          depth,
          useToJSON,
          serialize
        });
        for (const [key, value] of Object.entries(from)) {
          if (typeof Buffer === "function" && Buffer.isBuffer(value)) {
            to[key] = "[object Buffer]";
            continue;
          }
          if (value !== null && typeof value === "object" && typeof value.pipe === "function") {
            to[key] = "[object Stream]";
            continue;
          }
          if (typeof value === "function") {
            continue;
          }
          if (!value || typeof value !== "object") {
            to[key] = value;
            continue;
          }
          if (!seen.includes(from[key])) {
            depth++;
            to[key] = continueDestroyCircular(from[key]);
            continue;
          }
          to[key] = "[Circular]";
        }
        for (const { property, enumerable } of commonProperties) {
          if (typeof from[property] !== "undefined" && from[property] !== null) {
            Object.defineProperty(to, property, {
              value: isErrorLike(from[property]) ? continueDestroyCircular(from[property]) : from[property],
              enumerable: forceEnumerable ? true : enumerable,
              configurable: true,
              writable: true
            });
          }
        }
        return to;
      };
    }
  });

  // node_modules/p-retry/node_modules/retry/lib/retry_operation.js
  var require_retry_operation = __commonJS({
    "node_modules/p-retry/node_modules/retry/lib/retry_operation.js"(exports, module) {
      function RetryOperation(timeouts, options) {
        if (typeof options === "boolean") {
          options = { forever: options };
        }
        this._originalTimeouts = JSON.parse(JSON.stringify(timeouts));
        this._timeouts = timeouts;
        this._options = options || {};
        this._maxRetryTime = options && options.maxRetryTime || Infinity;
        this._fn = null;
        this._errors = [];
        this._attempts = 1;
        this._operationTimeout = null;
        this._operationTimeoutCb = null;
        this._timeout = null;
        this._operationStart = null;
        this._timer = null;
        if (this._options.forever) {
          this._cachedTimeouts = this._timeouts.slice(0);
        }
      }
      module.exports = RetryOperation;
      RetryOperation.prototype.reset = function() {
        this._attempts = 1;
        this._timeouts = this._originalTimeouts.slice(0);
      };
      RetryOperation.prototype.stop = function() {
        if (this._timeout) {
          clearTimeout(this._timeout);
        }
        if (this._timer) {
          clearTimeout(this._timer);
        }
        this._timeouts = [];
        this._cachedTimeouts = null;
      };
      RetryOperation.prototype.retry = function(err) {
        if (this._timeout) {
          clearTimeout(this._timeout);
        }
        if (!err) {
          return false;
        }
        var currentTime = new Date().getTime();
        if (err && currentTime - this._operationStart >= this._maxRetryTime) {
          this._errors.push(err);
          this._errors.unshift(new Error("RetryOperation timeout occurred"));
          return false;
        }
        this._errors.push(err);
        var timeout = this._timeouts.shift();
        if (timeout === void 0) {
          if (this._cachedTimeouts) {
            this._errors.splice(0, this._errors.length - 1);
            timeout = this._cachedTimeouts.slice(-1);
          } else {
            return false;
          }
        }
        var self2 = this;
        this._timer = setTimeout(function() {
          self2._attempts++;
          if (self2._operationTimeoutCb) {
            self2._timeout = setTimeout(function() {
              self2._operationTimeoutCb(self2._attempts);
            }, self2._operationTimeout);
            if (self2._options.unref) {
              self2._timeout.unref();
            }
          }
          self2._fn(self2._attempts);
        }, timeout);
        if (this._options.unref) {
          this._timer.unref();
        }
        return true;
      };
      RetryOperation.prototype.attempt = function(fn, timeoutOps) {
        this._fn = fn;
        if (timeoutOps) {
          if (timeoutOps.timeout) {
            this._operationTimeout = timeoutOps.timeout;
          }
          if (timeoutOps.cb) {
            this._operationTimeoutCb = timeoutOps.cb;
          }
        }
        var self2 = this;
        if (this._operationTimeoutCb) {
          this._timeout = setTimeout(function() {
            self2._operationTimeoutCb();
          }, self2._operationTimeout);
        }
        this._operationStart = new Date().getTime();
        this._fn(this._attempts);
      };
      RetryOperation.prototype.try = function(fn) {
        console.log("Using RetryOperation.try() is deprecated");
        this.attempt(fn);
      };
      RetryOperation.prototype.start = function(fn) {
        console.log("Using RetryOperation.start() is deprecated");
        this.attempt(fn);
      };
      RetryOperation.prototype.start = RetryOperation.prototype.try;
      RetryOperation.prototype.errors = function() {
        return this._errors;
      };
      RetryOperation.prototype.attempts = function() {
        return this._attempts;
      };
      RetryOperation.prototype.mainError = function() {
        if (this._errors.length === 0) {
          return null;
        }
        var counts = {};
        var mainError = null;
        var mainErrorCount = 0;
        for (var i = 0; i < this._errors.length; i++) {
          var error = this._errors[i];
          var message = error.message;
          var count = (counts[message] || 0) + 1;
          counts[message] = count;
          if (count >= mainErrorCount) {
            mainError = error;
            mainErrorCount = count;
          }
        }
        return mainError;
      };
    }
  });

  // node_modules/p-retry/node_modules/retry/lib/retry.js
  var require_retry = __commonJS({
    "node_modules/p-retry/node_modules/retry/lib/retry.js"(exports) {
      var RetryOperation = require_retry_operation();
      exports.operation = function(options) {
        var timeouts = exports.timeouts(options);
        return new RetryOperation(timeouts, {
          forever: options && (options.forever || options.retries === Infinity),
          unref: options && options.unref,
          maxRetryTime: options && options.maxRetryTime
        });
      };
      exports.timeouts = function(options) {
        if (options instanceof Array) {
          return [].concat(options);
        }
        var opts = {
          retries: 10,
          factor: 2,
          minTimeout: 1 * 1e3,
          maxTimeout: Infinity,
          randomize: false
        };
        for (var key in options) {
          opts[key] = options[key];
        }
        if (opts.minTimeout > opts.maxTimeout) {
          throw new Error("minTimeout is greater than maxTimeout");
        }
        var timeouts = [];
        for (var i = 0; i < opts.retries; i++) {
          timeouts.push(this.createTimeout(i, opts));
        }
        if (options && options.forever && !timeouts.length) {
          timeouts.push(this.createTimeout(i, opts));
        }
        timeouts.sort(function(a, b) {
          return a - b;
        });
        return timeouts;
      };
      exports.createTimeout = function(attempt, opts) {
        var random = opts.randomize ? Math.random() + 1 : 1;
        var timeout = Math.round(random * Math.max(opts.minTimeout, 1) * Math.pow(opts.factor, attempt));
        timeout = Math.min(timeout, opts.maxTimeout);
        return timeout;
      };
      exports.wrap = function(obj, options, methods) {
        if (options instanceof Array) {
          methods = options;
          options = null;
        }
        if (!methods) {
          methods = [];
          for (var key in obj) {
            if (typeof obj[key] === "function") {
              methods.push(key);
            }
          }
        }
        for (var i = 0; i < methods.length; i++) {
          var method = methods[i];
          var original = obj[method];
          obj[method] = function retryWrapper(original2) {
            var op = exports.operation(options);
            var args = Array.prototype.slice.call(arguments, 1);
            var callback = args.pop();
            args.push(function(err) {
              if (op.retry(err)) {
                return;
              }
              if (err) {
                arguments[0] = op.mainError();
              }
              callback.apply(this, arguments);
            });
            op.attempt(function() {
              original2.apply(obj, args);
            });
          }.bind(obj, original);
          obj[method].options = options;
        }
      };
    }
  });

  // node_modules/p-retry/node_modules/retry/index.js
  var require_retry2 = __commonJS({
    "node_modules/p-retry/node_modules/retry/index.js"(exports, module) {
      module.exports = require_retry();
    }
  });

  // node_modules/lodash/isObject.js
  var require_isObject = __commonJS({
    "node_modules/lodash/isObject.js"(exports, module) {
      function isObject(value) {
        var type = typeof value;
        return value != null && (type == "object" || type == "function");
      }
      module.exports = isObject;
    }
  });

  // node_modules/lodash/_freeGlobal.js
  var require_freeGlobal = __commonJS({
    "node_modules/lodash/_freeGlobal.js"(exports, module) {
      var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
      module.exports = freeGlobal;
    }
  });

  // node_modules/lodash/_root.js
  var require_root = __commonJS({
    "node_modules/lodash/_root.js"(exports, module) {
      var freeGlobal = require_freeGlobal();
      var freeSelf = typeof self == "object" && self && self.Object === Object && self;
      var root = freeGlobal || freeSelf || Function("return this")();
      module.exports = root;
    }
  });

  // node_modules/lodash/now.js
  var require_now = __commonJS({
    "node_modules/lodash/now.js"(exports, module) {
      var root = require_root();
      var now = function() {
        return root.Date.now();
      };
      module.exports = now;
    }
  });

  // node_modules/lodash/_trimmedEndIndex.js
  var require_trimmedEndIndex = __commonJS({
    "node_modules/lodash/_trimmedEndIndex.js"(exports, module) {
      var reWhitespace = /\s/;
      function trimmedEndIndex(string) {
        var index = string.length;
        while (index-- && reWhitespace.test(string.charAt(index))) {
        }
        return index;
      }
      module.exports = trimmedEndIndex;
    }
  });

  // node_modules/lodash/_baseTrim.js
  var require_baseTrim = __commonJS({
    "node_modules/lodash/_baseTrim.js"(exports, module) {
      var trimmedEndIndex = require_trimmedEndIndex();
      var reTrimStart = /^\s+/;
      function baseTrim(string) {
        return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
      }
      module.exports = baseTrim;
    }
  });

  // node_modules/lodash/_Symbol.js
  var require_Symbol = __commonJS({
    "node_modules/lodash/_Symbol.js"(exports, module) {
      var root = require_root();
      var Symbol2 = root.Symbol;
      module.exports = Symbol2;
    }
  });

  // node_modules/lodash/_getRawTag.js
  var require_getRawTag = __commonJS({
    "node_modules/lodash/_getRawTag.js"(exports, module) {
      var Symbol2 = require_Symbol();
      var objectProto = Object.prototype;
      var hasOwnProperty = objectProto.hasOwnProperty;
      var nativeObjectToString = objectProto.toString;
      var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
      function getRawTag(value) {
        var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
        try {
          value[symToStringTag] = void 0;
          var unmasked = true;
        } catch (e) {
        }
        var result = nativeObjectToString.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag] = tag;
          } else {
            delete value[symToStringTag];
          }
        }
        return result;
      }
      module.exports = getRawTag;
    }
  });

  // node_modules/lodash/_objectToString.js
  var require_objectToString = __commonJS({
    "node_modules/lodash/_objectToString.js"(exports, module) {
      var objectProto = Object.prototype;
      var nativeObjectToString = objectProto.toString;
      function objectToString(value) {
        return nativeObjectToString.call(value);
      }
      module.exports = objectToString;
    }
  });

  // node_modules/lodash/_baseGetTag.js
  var require_baseGetTag = __commonJS({
    "node_modules/lodash/_baseGetTag.js"(exports, module) {
      var Symbol2 = require_Symbol();
      var getRawTag = require_getRawTag();
      var objectToString = require_objectToString();
      var nullTag = "[object Null]";
      var undefinedTag = "[object Undefined]";
      var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
      function baseGetTag(value) {
        if (value == null) {
          return value === void 0 ? undefinedTag : nullTag;
        }
        return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
      }
      module.exports = baseGetTag;
    }
  });

  // node_modules/lodash/isObjectLike.js
  var require_isObjectLike = __commonJS({
    "node_modules/lodash/isObjectLike.js"(exports, module) {
      function isObjectLike(value) {
        return value != null && typeof value == "object";
      }
      module.exports = isObjectLike;
    }
  });

  // node_modules/lodash/isSymbol.js
  var require_isSymbol = __commonJS({
    "node_modules/lodash/isSymbol.js"(exports, module) {
      var baseGetTag = require_baseGetTag();
      var isObjectLike = require_isObjectLike();
      var symbolTag = "[object Symbol]";
      function isSymbol(value) {
        return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
      }
      module.exports = isSymbol;
    }
  });

  // node_modules/lodash/toNumber.js
  var require_toNumber = __commonJS({
    "node_modules/lodash/toNumber.js"(exports, module) {
      var baseTrim = require_baseTrim();
      var isObject = require_isObject();
      var isSymbol = require_isSymbol();
      var NAN = 0 / 0;
      var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
      var reIsBinary = /^0b[01]+$/i;
      var reIsOctal = /^0o[0-7]+$/i;
      var freeParseInt = parseInt;
      function toNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol(value)) {
          return NAN;
        }
        if (isObject(value)) {
          var other = typeof value.valueOf == "function" ? value.valueOf() : value;
          value = isObject(other) ? other + "" : other;
        }
        if (typeof value != "string") {
          return value === 0 ? value : +value;
        }
        value = baseTrim(value);
        var isBinary = reIsBinary.test(value);
        return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
      }
      module.exports = toNumber;
    }
  });

  // node_modules/lodash/debounce.js
  var require_debounce = __commonJS({
    "node_modules/lodash/debounce.js"(exports, module) {
      var isObject = require_isObject();
      var now = require_now();
      var toNumber = require_toNumber();
      var FUNC_ERROR_TEXT = "Expected a function";
      var nativeMax = Math.max;
      var nativeMin = Math.min;
      function debounce(func, wait, options) {
        var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != "function") {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        wait = toNumber(wait) || 0;
        if (isObject(options)) {
          leading = !!options.leading;
          maxing = "maxWait" in options;
          maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = void 0;
          lastInvokeTime = time;
          result = func.apply(thisArg, args);
          return result;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout(timerExpired, wait);
          return leading ? invokeFunc(time) : result;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = void 0;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = void 0;
          return result;
        }
        function cancel() {
          if (timerId !== void 0) {
            clearTimeout(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = void 0;
        }
        function flush() {
          return timerId === void 0 ? result : trailingEdge(now());
        }
        function debounced() {
          var time = now(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === void 0) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout(timerId);
              timerId = setTimeout(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === void 0) {
            timerId = setTimeout(timerExpired, wait);
          }
          return result;
        }
        debounced.cancel = cancel;
        debounced.flush = flush;
        return debounced;
      }
      module.exports = debounce;
    }
  });

  // node_modules/lodash/throttle.js
  var require_throttle = __commonJS({
    "node_modules/lodash/throttle.js"(exports, module) {
      var debounce = require_debounce();
      var isObject = require_isObject();
      var FUNC_ERROR_TEXT = "Expected a function";
      function throttle2(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != "function") {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        if (isObject(options)) {
          leading = "leading" in options ? !!options.leading : leading;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        return debounce(func, wait, {
          "leading": leading,
          "maxWait": wait,
          "trailing": trailing
        });
      }
      module.exports = throttle2;
    }
  });

  // web-extension/constants.ts
  var isFirefox = navigator.userAgent.toLowerCase().indexOf("firefox") > -1;
  var MESSAGES = {
    QR_EXCHANGE: "QR_EXCHANGE",
    QR_TRIGGER: "QR_TRIGGER",
    ICON_CLICK: "ICON_CLICK",
    SAVE_CONTENT: "SAVE",
    OPEN_READER_VIEW: "OPEN_READER_VIEW",
    COMMAND_OPEN_READER_VIEW: "COMMAND_OPEN_READER_VIEW",
    COMMAND_SAVE: "COMMAND_SAVE",
    COMMAND_TOGGLE_THEME: "COMMAND_TOGGLE_THEME",
    OPEN_SHORTCUTS_PAGE: "OPEN_SHORTCUTS_PAGE",
    CONTEXT_MENU_REQUEST_SAVE: "CONTEXT_MENU_REQUEST_SAVE",
    CONTEXT_MENU_TOGGLE_READER_VIEW: "CONTEXT_MENU_TOGGLE_READER_VIEW",
    SESSION_TOKEN: "SESSION_TOKEN",
    STOP_QR_POLL: "STOP_QR_POLL",
    UNSAVE_CONTENT: "UNSAVE_CONTENT",
    INVALID_AUTH: "INVALID_AUTH",
    AUTH_REFRESH: "AUTH_REFRESH",
    READER_VIEW_READY: "READER_VIEW_READY",
    REMOVE_READER_DATA: "REMOVE_READER_DATA",
    POPUP_IS_CLOSED: "POPUP_IS_CLOSED"
  };
  var CONTEXT_MENUS = {
    SAVE_ARTICLE: "SAVE_ARTICLE",
    TOGGLE_READER_VIEW: "TOGGLE_READER_VIEW",
    HELP: "HELP",
    VISIT_WEB_APP: "VISIT_WEB_APP",
    FEEDBACK: "FEEDBACK"
  };
  var AnalyticsEventNames = {
    loginSucceeded: "Webext. login succeeded",
    loginFailed: "Webext. login failed",
    readerFromContextMenu: "Webext. reader from context menu",
    saveSucceeded: "Webext. save succeeded",
    saveFailed: "Webext. save failed",
    install: "Webext. install",
    highlight: "Webext. highlight",
    highlightNote: "Webext. highlight note",
    highlightDeleted: "Webext. highlight deleted",
    sendToKindleSucceeded: "Webext. send to kindle succeeded",
    kindleSetupSucceeded: "Webext. kindle setup succeeded"
  };
  var ApiEndpoints = {
    INTEGRATIONS_KINDLE_ACCOUNTS: "/integrations/kindle_accounts/",
    PROFILE: "/profile/",
    READER_VIEW: "/reader_view/",
    REFRESH_TOKEN_EXCHANGE: "/token/refresh/",
    SAVE: "/save/",
    KINDLE_UPLOADS: "/kindle_uploads/",
    TRACK: "/track/",
    TAGS: "/tags/"
  };
  var webappDomainNew = ".getmatter.com";
  var webappUrlNew = "https://web.getmatter.com";

  // web-extension/utils/utils.ts
  var import_p_wait_for = __toESM(require_p_wait_for(), 1);

  // utils/constants.ts
  var ApiEndpoints2 = {
    ANNOTATIONS_BY_ID: "/annotations/:id/",
    ANNOTATIONS: "/annotations/",
    APPLE_SIGN_IN: "/apple_sign_in/",
    ARCHIVE_FEED: "/library_items/archive_feed/",
    AUTHORS_FEED: "/feed/authors/",
    BUG_REPORTS: "/bug_reports/",
    CLIENT_ERROR: "/_client/error",
    CLIENT_LOG: "/_client/log",
    CONTENTS_MY_ANNOTATIONS: "/contents/:id/my_annotations/",
    CONTENTS_TAGS: "/contents/tags/",
    CONTENTS: "/contents/:id/",
    FAVORITES_FEED: "/library_items/favorites_feed/",
    FEEDBACK: "/feedback/",
    HANDLES_CHECK: "/handles/check_available/",
    HANDLES_CLAIM: "/handles/claim/",
    HIGHLIGHTS_FEED: "/library_items/highlights_feed/",
    HISTORY_ENTRIES: "/history_entries/",
    INTEGRATIONS_KINDLE_ACCOUNTS: "/integrations/kindle_accounts/",
    KINDLE_UPLOADS: "/kindle_uploads/",
    LIBRARY_ENTRIES: "/library_entries/",
    LIKES: "/likes/",
    MAGIC_LOGIN_TRIGGER: "/magic_login/trigger/",
    MAGIC_LOGIN_EXCHANGE: "/magic_login/exchange/",
    NOTES: "/notes/",
    NOTE: "/notes/:id/",
    PROFILE: "/profile/",
    QR_EXCHANGE: "/qr_login/exchange/",
    QR_TRIGGER: "/qr_login/trigger/",
    QUEUE_FEED: "/library_items/queue_feed/",
    READER_VIEW: "/reader_view/",
    RECENT_FEED: "/library_items/recent_feed/",
    REFRESH_TOKEN_EXCHANGE: "/token/refresh/",
    SAVE: "/save/",
    SAVE_BY_ID: "/save/:id/",
    SEARCH: "/search/",
    SOURCES: "/sources/",
    SUBSCRIPTION_FEED: "/profile/:profile_id/author_feed/",
    SUBSCRIPTIONS_FEED: "/feed/inbox/",
    SPEECH: "/speech/",
    STAFF_PICKS_FEED: "/feed/discover_split/",
    TAGS: "/tags/",
    TAGS_FEED: "/library_items/tags_feed/",
    TRACK: "/track/",
    UPDATES_FEED: "/library_items/updates_feed/"
  };
  var queryParams = {
    noHighlights: "noHighlights",
    refreshFailed: "refreshFailed"
  };

  // node_modules/js-cookie/dist/js.cookie.mjs
  function assign(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        target[key] = source[key];
      }
    }
    return target;
  }
  var defaultConverter = {
    read: function(value) {
      if (value[0] === '"') {
        value = value.slice(1, -1);
      }
      return value.replace(/(%[\dA-F]{2})+/gi, decodeURIComponent);
    },
    write: function(value) {
      return encodeURIComponent(value).replace(
        /%(2[346BF]|3[AC-F]|40|5[BDE]|60|7[BCD])/g,
        decodeURIComponent
      );
    }
  };
  function init(converter, defaultAttributes) {
    function set(key, value, attributes) {
      if (typeof document === "undefined") {
        return;
      }
      attributes = assign({}, defaultAttributes, attributes);
      if (typeof attributes.expires === "number") {
        attributes.expires = new Date(Date.now() + attributes.expires * 864e5);
      }
      if (attributes.expires) {
        attributes.expires = attributes.expires.toUTCString();
      }
      key = encodeURIComponent(key).replace(/%(2[346B]|5E|60|7C)/g, decodeURIComponent).replace(/[()]/g, escape);
      var stringifiedAttributes = "";
      for (var attributeName in attributes) {
        if (!attributes[attributeName]) {
          continue;
        }
        stringifiedAttributes += "; " + attributeName;
        if (attributes[attributeName] === true) {
          continue;
        }
        stringifiedAttributes += "=" + attributes[attributeName].split(";")[0];
      }
      return document.cookie = key + "=" + converter.write(value, key) + stringifiedAttributes;
    }
    function get(key) {
      if (typeof document === "undefined" || arguments.length && !key) {
        return;
      }
      var cookies = document.cookie ? document.cookie.split("; ") : [];
      var jar = {};
      for (var i = 0; i < cookies.length; i++) {
        var parts = cookies[i].split("=");
        var value = parts.slice(1).join("=");
        try {
          var foundKey = decodeURIComponent(parts[0]);
          jar[foundKey] = converter.read(value, foundKey);
          if (key === foundKey) {
            break;
          }
        } catch (e) {
        }
      }
      return key ? jar[key] : jar;
    }
    return Object.create(
      {
        set,
        get,
        remove: function(key, attributes) {
          set(
            key,
            "",
            assign({}, attributes, {
              expires: -1
            })
          );
        },
        withAttributes: function(attributes) {
          return init(this.converter, assign({}, this.attributes, attributes));
        },
        withConverter: function(converter2) {
          return init(assign({}, this.converter, converter2), this.attributes);
        }
      },
      {
        attributes: { value: Object.freeze(defaultAttributes) },
        converter: { value: Object.freeze(converter) }
      }
    );
  }
  var api = init(defaultConverter, { path: "/" });

  // utils/typeGuards.ts
  var isValidApiVersion = (str) => {
    return str !== void 0 && ["v10", "v11", "v12", "v13", "v14", "v15"].includes(str);
  };

  // utils/utils.ts
  var defaultVersion = isValidApiVersion(
    ""
  ) ? "" : "v15";

  // web-extension/utils/utils.ts
  if (globalThis.browser?.runtime.getURL("").startsWith("moz-extension")) {
    globalThis.chrome = globalThis.browser;
  }
  var manifest = chrome.runtime.getManifest();
  var isValidOrigin2 = (str) => {
    return str === "https://api.getmatter.app" || str === "https://api.getmatter.com" || str === "https://api.winnotest.com" || str === "http://localhost:8000/api";
  };
  var defaultApiOrigin = (() => {
    const matterApiUrl = "";
    if (isValidOrigin2(matterApiUrl)) {
      return matterApiUrl;
    }
    return "https://api.getmatter.com";
  })();
  var matterApiEndpoint = (endpoint, origin = defaultApiOrigin, version = defaultVersion) => {
    if (!endpoint) {
      throw new Error(`\`endpoint\` is required by \`apiRequest\``);
    }
    return `${origin}/api/${version}${version === "" && endpoint.startsWith("/") ? endpoint.slice(1) : endpoint}`;
  };
  var authCookieExpiryDate = () => {
    const thirtyDays = 2592e6;
    const oneMonthFromNow = new Date(Date.now() + thirtyDays);
    return oneMonthFromNow.getTime() / 1e3;
  };
  var setAuthCookie = (name, value) => {
    const expirationDate = authCookieExpiryDate();
    const cookiePromise = () => new Promise((resolve) => {
      chrome.cookies.set(
        {
          name,
          value,
          expirationDate,
          domain: webappDomainNew,
          url: webappUrlNew,
          secure: true,
          path: "/"
        },
        (result) => {
          return resolve(result);
        }
      );
    });
    return cookiePromise();
  };
  var isValidRefreshResponse = (response) => {
    return typeof response === "object" && response !== null && response.hasOwnProperty("access_token") && response.hasOwnProperty("refresh_token");
  };
  var getCookie = (name, url) => {
    return new Promise((resolve) => {
      chrome.cookies.get(
        {
          name,
          url: url || "https://web.getmatter.com"
        },
        (result) => {
          return resolve(result);
        }
      );
    });
  };
  var storageGet = (keys) => {
    return new Promise((resolve) => {
      chrome.storage.local.get(keys, (result) => {
        return resolve(result);
      });
    });
  };
  var getCookieValue = async (name) => {
    const cookie = await getCookie(name);
    if (cookie?.value) {
      return cookie.value;
    }
    return null;
  };
  var isStringRecord = (obj) => {
    return Object.values(obj).every((val) => typeof val === "string");
  };
  var authedMatterApiFetch = async (endpoint, fetchArgs) => {
    const version = manifest?.version || "";
    const headers = new Headers(fetchArgs?.headers);
    let authCookies = await Promise.all([
      getCookieValue("extension_access_token"),
      getCookieValue("extension_refresh_token")
    ]);
    if (!authCookies.every(Boolean)) {
      authCookies = await Promise.all([
        getCookieValue("access_token"),
        getCookieValue("refresh_token")
      ]);
    }
    if (!authCookies.every(Boolean)) {
      const storage = await storageGet(["accessToken", "refreshToken"]);
      if (storage !== null && typeof storage === "object" && Object.keys(storage).length === 2 && isStringRecord(storage)) {
        const values = Object.values(storage);
        authCookies[0] = values[0];
        authCookies[1] = values[1];
      }
    }
    if (authCookies.filter(Boolean).length < 2) {
      throw new Error("Auth tokens are missing");
    }
    const [access_token, refresh_token] = authCookies;
    headers.set("Authorization", `Bearer ${access_token}`);
    headers.set("X-Matter-Extension-Version", version);
    if (fetchArgs?.method === "POST" || fetchArgs?.method === "PUT") {
      headers.set("Content-Type", "application/json");
    }
    const initialFetchArgs = { ...fetchArgs, headers };
    let response = await fetch(matterApiEndpoint(endpoint), initialFetchArgs);
    if (refresh_token && (response.status == 401 || response.status === 403)) {
      const refreshResponse = await fetch(
        matterApiEndpoint(
          ApiEndpoints.REFRESH_TOKEN_EXCHANGE,
          defaultApiOrigin,
          ""
        ),
        {
          headers: new Headers({
            "Content-Type": "application/json",
            "X-Matter-Extension-Version": version
          }),
          method: "POST",
          body: JSON.stringify({ refresh_token })
        }
      ).then((r) => r.json());
      if (isValidRefreshResponse(refreshResponse)) {
        setAuthCookie("extension_access_token", refreshResponse.access_token);
        setAuthCookie("extension_refresh_token", refreshResponse.refresh_token);
        chrome.storage.local.set({
          accessToken: refreshResponse.access_token,
          refreshToken: refreshResponse.refresh_token
        });
        const refreshHeaders = new Headers(headers);
        refreshHeaders.set(
          "Authorization",
          `Bearer ${refreshResponse.access_token}`
        );
        const refreshFetchArgs = { ...initialFetchArgs, headers: refreshHeaders };
        response = await fetch(matterApiEndpoint(endpoint), refreshFetchArgs);
      } else {
        console.error(new Error("Invalid auth refresh response"));
        if (endpoint === ApiEndpoints.SAVE || endpoint === ApiEndpoints.READER_VIEW) {
          chrome.tabs.create({
            active: true,
            url: `${"https://web.getmatter.com"}?from=${queryParams.refreshFailed}`
          });
        }
      }
    }
    let json = {};
    try {
      json = await response.json();
    } catch (err) {
    }
    return {
      status: response.status,
      json
    };
  };
  var readerViewDataStorageKey = (url) => `ReaderViewData:${encodeURIComponent(url)}`;
  var isTabWithId = (tab) => {
    return tab.id !== void 0;
  };
  var getActiveTab = () => {
    return new Promise((resolve, reject) => {
      chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
        const tab = tabs.length > 0 && tabs[0];
        if (tab && isTabWithId(tab)) {
          return resolve(tab);
        } else {
          return reject(new Error("No active tab"));
        }
      });
    });
  };
  var waitForReaderData = async (tabId, key) => {
    let data = null;
    await (0, import_p_wait_for.default)(
      async () => {
        data = await storageGet([key]);
        if (data !== null && typeof data === "object" && data && Object.keys(data).length > 0) {
          return true;
        }
        return false;
      },
      { timeout: 1e3 * 10 }
    );
    return { data, tabId };
  };
  var reportError = (error, status, json) => {
    if (true) {
      return;
    }
    storageGet(["account_id"]).then((storage) => {
      const body = { error, account_id: null };
      if (storage?.account_id) {
        body.account_id = storage.account_id;
      }
      if (status) {
        body.status = status;
      }
      if (json) {
        body.json = json;
      }
      fetch(`${webappUrlNew}/api/_client/error/extension`, {
        method: "POST",
        body: JSON.stringify(body),
        headers: {
          "Content-Type": "application/json"
        }
      });
    });
  };
  var trackingEvent = async (event_name, data = {}) => {
    const storage = await storageGet(["account_id"]);
    if (storage && storage.account_id) {
      chrome.runtime.getPlatformInfo((platformInfo) => {
        authedMatterApiFetch(ApiEndpoints.TRACK, {
          method: "POST",
          body: JSON.stringify({
            distict_id: storage.account_id,
            event_name,
            event_params: { ...data, platformInfo }
          })
        });
      });
    } else {
      let profile = null;
      try {
        profile = await authedMatterApiFetch(ApiEndpoints.PROFILE, {
          method: "GET"
        }).then(({ status, json }) => {
          if (status < 400 && json.account_id) {
            chrome.storage.local.set({ account_id: json.account_id });
            return json;
          }
        });
      } catch (err) {
      }
      const accountId = profile && profile?.account_id;
      if (accountId) {
        chrome.runtime.getPlatformInfo((platformInfo) => {
          authedMatterApiFetch(ApiEndpoints.TRACK, {
            method: "POST",
            body: JSON.stringify({
              distict_id: accountId,
              event_name,
              event_params: { ...data, platformInfo }
            })
          });
        });
      }
    }
  };
  var isUserLoggedIn = async () => {
    const webappAuthCreds = await Promise.all([
      getCookie("access_token"),
      getCookie("refresh_token")
    ]);
    const extensionCookieAuthCreds = await Promise.all([
      getCookie("extension_access_token"),
      getCookie("extension_refresh_token")
    ]);
    let hasValidAuth = webappAuthCreds.every(Boolean) || extensionCookieAuthCreds.every(Boolean);
    const storageTokens = await storageGet(["accessToken", "refreshToken"]);
    if (webappAuthCreds.every(Boolean) && storageTokens && Object.keys(storageTokens).length < 2) {
      chrome.storage.local.set({
        accessToken: webappAuthCreds[0]?.value,
        refreshToken: webappAuthCreds[1]?.value
      });
    } else if (!hasValidAuth) {
      if (storageTokens !== null && typeof storageTokens === "object" && Object.keys(storageTokens).length === 2) {
        let cookiesSet = false;
        try {
          const result = await Promise.all([
            setAuthCookie("extension_access_token", storageTokens.accessToken),
            setAuthCookie("extension_refresh_token", storageTokens.refreshToken)
          ]);
          if (result.every(Boolean)) {
            cookiesSet = true;
          }
        } catch (err) {
        }
        if (cookiesSet) {
          hasValidAuth = true;
        }
      }
    }
    return hasValidAuth;
  };

  // utils/nodeLogger.ts
  init_serialize_error();
  var nodeLogger = async (data, {
    shouldSerializeError = true,
    readWindowData = true,
    shouldConsoleLog = false
  } = {}) => {
    let log = typeof data === "string" ? { msg: data } : data;
    log.level = log.level || "info";
    log.time = Date.now();
    const error = log.error;
    if (error && error instanceof Error) {
      log.level = "error";
      log.msg = error.message;
      if (!shouldSerializeError) {
        log.error = JSON.stringify(error, Object.getOwnPropertyNames(error));
      } else {
        log.error = serializeError(error);
      }
    }
    if (log.info?.error) {
      log.info.error = serializeError(log.info.error);
    }
    if (typeof window !== "undefined" && readWindowData) {
      log = {
        ...log,
        pathname: window.location.pathname,
        userAgent: window.navigator.userAgent,
        language: window.navigator.language,
        languages: window.navigator.languages,
        cookieEnabled: window.navigator.cookieEnabled
      };
    }
    if (shouldConsoleLog && typeof window !== "undefined" && true) {
      console[log.level || "log"](log);
    } else if (true) {
      fetch("https://web.getmatter.com/api/_client/log", {
        method: "POST",
        body: JSON.stringify(log),
        headers: {
          "Content-Type": "application/json"
        }
      }).catch(console.error);
    }
    return log;
  };

  // util/api.ts
  var clientApiEndpoint = (endpoint, queryParams2, replacements) => {
    const params = new URLSearchParams(queryParams2);
    params.forEach((value, key) => {
      if (value === "") {
        params.delete(key);
      }
    });
    const searchString = params.toString().length > 0 ? `?${params.toString()}` : "";
    let pathname = endpoint;
    if (replacements && Object.keys(replacements).length > 0) {
      Object.entries(replacements).forEach(([key, value]) => {
        pathname = pathname.replace(`:${key}`, value);
      });
    }
    return pathname.endsWith("/") ? `/api${pathname.slice(0, -1)}${searchString}` : `/api${pathname}${searchString}`;
  };

  // node_modules/p-retry/index.js
  var import_retry = __toESM(require_retry2(), 1);

  // utils/error.ts
  var import_throttle = __toESM(require_throttle());
  var reportError2 = (0, import_throttle.default)(
    async (error, info, shouldSerializeError = true) => {
      if (shouldSerializeError) {
        const { serializeError: serializeError2 } = await Promise.resolve().then(() => (init_serialize_error(), serialize_error_exports));
        const blob = new Blob(
          [JSON.stringify({ error: serializeError2(error), info })],
          {
            type: "application/json; charset=UTF-8"
          }
        );
        navigator.sendBeacon(clientApiEndpoint(ApiEndpoints2.CLIENT_ERROR), blob);
      } else {
        const blob = new Blob(
          [
            JSON.stringify({
              error: { name: error.name, message: error.message },
              info
            })
          ],
          {
            type: "application/json; charset=UTF-8"
          }
        );
        navigator.sendBeacon(clientApiEndpoint(ApiEndpoints2.CLIENT_ERROR), blob);
      }
    },
    500
  );

  // hooks/useHighlighter/selectionAnnotation.ts
  var whiteSpace = /[ \r\n\t\u2029\u3000\uFFFC\u200B\u00A0]/gu;
  var eqTextsByNonWhitepsace = (a, b, regexModifications = "") => {
    const text = a.replaceAll(
      new RegExp(whiteSpace.source + regexModifications, whiteSpace.flags),
      " "
    );
    const annotationText = b.replaceAll(
      new RegExp(whiteSpace.source + regexModifications, whiteSpace.flags),
      " "
    );
    return text === annotationText;
  };

  // web-extension/background.ts
  var isFirefox2 = globalThis.browser?.runtime.getURL("").startsWith("moz-extension");
  var isSafari2 = globalThis.browser?.runtime.getURL("").startsWith("safari-web-extension");
  if (globalThis.browser?.runtime.getURL("").startsWith("moz-extension")) {
    globalThis.chrome = globalThis.browser;
  }
  var logMeta = {
    account_id: -1,
    info: {
      from: "BROWSER_EXTENSION",
      version: manifest.version
    }
  };
  var logger2 = async (log, options) => {
    const initialLog = logMeta;
    try {
      if (!initialLog.account_id || initialLog.account_id < 0) {
        const storage = await storageGet(["account_id"]);
        initialLog.account_id = storage?.account_id || -1;
      }
    } catch (err) {
      console.error(err);
    }
    return nodeLogger(
      {
        ...initialLog,
        ...log,
        info: { ...initialLog.info, ...log.info }
      },
      options
    );
  };
  chrome.runtime.onInstalled.addListener((details) => {
    if (details.reason === "install") {
      chrome.storage.local.clear();
      return;
    }
    const script = manifest?.content_scripts?.[0].js?.[0];
    if (!script) {
      return;
    }
    chrome.tabs.query({}, (tabs) => {
      tabs.forEach((tab) => {
        if (tab.id !== void 0 && tab.url?.startsWith("http")) {
          chrome.tabs.executeScript(tab.id, { file: script });
        }
      });
    });
  });
  storageGet(["account_id"]).then((response) => {
    if (!response?.account_id) {
      authedMatterApiFetch(ApiEndpoints.PROFILE, { method: "GET" }).then(({ status, json }) => {
        if (status < 400 && json.account_id) {
          chrome.storage.local.set({ account_id: json.account_id });
          chrome.storage.local.set({ profile: json });
          logMeta.account_id = json.account_id;
        }
      }).catch((err) => {
      });
    } else {
      logMeta.account_id = response.account_id;
    }
  });
  var actionName = manifest.manifest_version === 3 ? "action" : "browserAction";
  chrome[actionName].onClicked.addListener(function(tab) {
    if (!tab.url?.startsWith("http")) {
      chrome.tabs.create({
        active: true,
        url: webappUrlNew
      });
    } else {
      const tabId = tab.id;
      if (tabId) {
        chrome.tabs.sendMessage(tabId, {
          type: MESSAGES.ICON_CLICK,
          payload: tab
        });
      }
    }
  });
  var onMessageListener = async (msg, sendResponse) => {
    switch (msg.type) {
      case "ADD_ANNOTATION":
        logger2({
          msg: "browser-extension: \u2699\uFE0F Adding annotation...",
          info: {
            postedAnnotation: msg.payload.annotation,
            url: msg.payload.pageUrl
          }
        });
        authedMatterApiFetch("/annotations/", {
          method: "POST",
          body: JSON.stringify(msg.payload.annotation)
        }).then((data) => {
          if (data.status < 300) {
            trackingEvent(AnalyticsEventNames.highlight);
            const annotations = data.json;
            sessionStorage.setItem(
              `annotations:${msg.payload.pageUrl}`,
              JSON.stringify(annotations)
            );
            const match = annotations.find(
              (item) => eqTextsByNonWhitepsace(
                item.text.trim(),
                msg.payload.annotation.text.trim(),
                "+"
              )
            );
            if (match && match.word_start !== null && match.word_end !== null) {
              logger2({
                msg: `browser-extension: \u2705 Successfully matched open web highlight`,
                info: {
                  postedAnnotation: msg.payload.annotation,
                  url: msg.payload.pageUrl
                }
              });
            } else {
              const error2 = new Error(
                `browser-extension: \u274C Failed to match open web highlight`
              );
              logger2({
                error: error2,
                info: {
                  postedAnnotation: msg.payload.annotation,
                  url: msg.payload.pageUrl
                }
              });
            }
          } else {
            const error2 = new Error(
              `browser-extension: \u274C Failed to match open web highlight`
            );
            logger2({
              error: error2,
              info: {
                postedAnnotation: msg.payload.annotation,
                url: msg.payload.pageUrl
              }
            });
          }
          sendResponse(data);
        }).catch((err) => {
          const error2 = new Error(
            `browser-extension: \u274C Failed to add annotation`
          );
          logger2({
            error: error2,
            info: {
              postedAnnotation: msg.payload.annotation,
              url: msg.payload.pageUrl,
              error: err
            }
          });
          sendResponse(error2);
        });
        break;
      case "ANNOTATION_NOTE": {
        const annotations = JSON.parse(
          sessionStorage.getItem(`annotations:${msg.payload.url}`) || "[]"
        );
        const match = annotations?.find(
          (item) => eqTextsByNonWhitepsace(item.text.trim(), msg.payload.text.trim(), "+")
        );
        if (!match) {
          const error2 = new Error(
            `browser-extension: \u274C Failed to find matching annotation when attempting to set note`
          );
          logger2({ error: error2, info: { annotations, msgPayload: msg.payload } });
          sendResponse(error2);
        } else {
          logger2({
            msg: "browser-extension: \u2699\uFE0F Adding annotation note...",
            info: {
              annotation: { ...match, note: msg.payload.note },
              msgPayload: msg.payload
            }
          });
          authedMatterApiFetch(`/annotations/`, {
            method: "POST",
            body: JSON.stringify({ ...match, note: msg.payload.note })
          }).then((response) => {
            if (response.status < 300) {
              trackingEvent(AnalyticsEventNames.highlightNote);
              logger2({
                msg: `browser-extension: \u2705 Successfully set annotation note`,
                info: {
                  annotation: match,
                  msgPayload: msg.payload
                }
              });
            } else {
              const error2 = new Error(
                `browser-extension: \u274C Failed to set annotation note`
              );
              logger2({
                error: error2,
                info: {
                  annotation: match,
                  msgPayload: msg.payload
                }
              });
            }
            sendResponse(response);
          }).catch((err) => {
            const error2 = new Error(
              `browser-extension: \u274C Failed to set annotation note`
            );
            logger2({
              error: error2,
              info: {
                error: err,
                msgPayload: msg.payload
              }
            });
            sendResponse(error2);
          });
        }
        break;
      }
      case "DELETE_ANNOTATION": {
        const annotations = JSON.parse(
          sessionStorage.getItem(`annotations:${msg.payload.url}`) || "[]"
        );
        const match = annotations?.find(
          (item) => eqTextsByNonWhitepsace(item.text.trim(), msg.payload.text.trim(), "+")
        );
        if (match) {
          logger2({
            msg: "browser-extension: \u2699\uFE0F Deleting annotation...",
            info: {
              annotation: match,
              url: msg.payload.url
            }
          });
          authedMatterApiFetch(`/annotations/${match.id}/`, {
            method: "DELETE"
          }).then(() => {
            trackingEvent(AnalyticsEventNames.highlightDeleted);
            logger2({
              msg: `browser-extension: \u2705 Successfully deleted annotation`,
              info: {
                annotation: match,
                url: msg.payload.url
              }
            });
          }).catch((err) => {
            const error2 = new Error(
              `browser-extension: \u274C Failed to set annotation note`
            );
            logger2({
              error: error2,
              info: {
                error: err,
                annotation: match,
                url: msg.payload.url
              }
            });
          });
        } else {
          const error2 = new Error(
            `browser-extension: \u274C Failed to set annotation note`
          );
          logger2({
            error: error2
          });
        }
        sendResponse(null);
        break;
      }
      case "ERROR": {
        const error2 = new Error(msg.payload);
        logger2({ error: error2, info: { msgPayload: msg.payload } });
        reportError(msg.payload);
        sendResponse(null);
        break;
      }
      case "OPEN_FIREFOX_SHORTCUTS_HELP":
        chrome.tabs.create({
          active: true,
          url: `https://mzl.la/3Qwp5QQ`
        });
        break;
      case "OPEN_SHORTCUTS_PAGE":
        chrome.tabs.create({
          active: true,
          url: `chrome://extensions/shortcuts`
        });
        break;
      case "OPEN_LOGIN":
        chrome.tabs.create({
          active: true,
          url: `${webappUrlNew}?from=ext`
        });
        sendResponse(null);
        break;
      case "GET_READER_DATA":
        authedMatterApiFetch(ApiEndpoints.READER_VIEW, {
          method: "POST",
          body: JSON.stringify(msg.payload.pageData)
        }).then(({ json, status }) => {
          const logMsg = `HTTP POST ${ApiEndpoints.READER_VIEW} ${status}`;
          if (status >= 400) {
            const error2 = new Error(logMsg);
            reportError(logMsg, status, json);
            logger2({ error: error2, info: { status, json } });
          } else {
            logger2({ msg: logMsg });
          }
          sendResponse(json);
        }).catch((err) => {
          const errorMessage = `HTTP POST ${ApiEndpoints.READER_VIEW}`;
          const error2 = new Error(errorMessage);
          reportError(errorMessage);
          logger2({ error: error2, info: { error: err } });
          sendResponse(null);
        });
        break;
      case "OPEN_READER":
        const url = new URL(msg.payload.url);
        url.searchParams.set("v", manifest.version);
        chrome.tabs.create({
          active: true,
          url: url.toString()
        });
        authedMatterApiFetch(ApiEndpoints.READER_VIEW, {
          method: "POST",
          body: JSON.stringify(msg.payload.pageData)
        }).then(({ json, status }) => {
          const logMsg = `HTTP POST ${ApiEndpoints.READER_VIEW} ${status}`;
          if (status >= 400) {
            const error2 = new Error(logMsg);
            reportError(logMsg, status, json);
            logger2({ error: error2, info: { status, json } });
          } else {
            logger2({ msg: logMsg });
          }
          chrome.storage.local.set({
            [readerViewDataStorageKey(msg.payload.pageData.url)]: {
              json,
              status
            }
          });
        }).catch((err) => {
          const errorMessage = `HTTP POST ${ApiEndpoints.READER_VIEW}`;
          const error2 = new Error(errorMessage);
          reportError(errorMessage);
          logger2({ error: error2, info: { error: err } });
          chrome.storage.local.set({
            [readerViewDataStorageKey(msg.payload.pageData.url)]: {
              error: error2
            }
          });
        });
        break;
      case "READER_VIEW_READY":
        getActiveTab().then((tab) => {
          waitForReaderData(tab.id, readerViewDataStorageKey(msg.payload.url)).then(({ tabId, data }) => {
            if (data) {
              const [payload] = Object.values(data);
              sendResponse(payload);
            }
          }).catch((error2) => {
            console.error(error2);
            getActiveTab().then((tab2) => {
              chrome.tabs.sendMessage(tab2.id, {
                type: "READER_VIEW_DATA",
                payload: {
                  error: error2
                }
              });
            });
          });
        });
        break;
      case "SAVE_PAGE":
        try {
          const response = await authedMatterApiFetch(ApiEndpoints.SAVE, {
            method: "POST",
            body: JSON.stringify(msg.payload.pageData)
          });
          const logMsg = `HTTP POST ${ApiEndpoints.SAVE} ${response.status}`;
          if (response.status >= 400) {
            const error2 = new Error(logMsg);
            reportError(logMsg, response.status, response.json);
            logger2({ error: error2, info: { ...response } });
          } else {
            logger2({ msg: logMsg });
            trackingEvent(AnalyticsEventNames.saveSucceeded);
          }
          const tab = await getActiveTab();
          chrome.tabs.sendMessage(tab.id, {
            type: "SAVE_PAGE_RESULT",
            payload: response
          });
        } catch (err) {
          const errorMessage = `HTTP POST ${ApiEndpoints.SAVE}`;
          const error2 = new Error(errorMessage);
          reportError(errorMessage);
          logger2({ error: error2, info: { error: err } });
          sendResponse(err);
        }
        break;
      case "SEND_TO_KINDLE": {
        logger2({
          msg: `browser-extension: \u2699\uFE0F fetching reader view for send to kindle...`,
          info: {
            pageData: msg.payload.pageData
          }
        });
        try {
          const readerResponse = await authedMatterApiFetch(
            ApiEndpoints.READER_VIEW,
            {
              method: "POST",
              body: JSON.stringify(msg.payload.pageData)
            }
          );
          if (readerResponse.status < 300) {
            logger2({
              msg: `browser-extension: \u2705 fetched reader view for send to kindle successfully`,
              info: {
                pageData: msg.payload.pageData
              }
            });
            logger2({
              msg: `browser-extension: \u2699\uFE0F sending kindle upload...`,
              info: {
                pageData: msg.payload.pageData
              }
            });
            const response = await authedMatterApiFetch(
              ApiEndpoints.KINDLE_UPLOADS,
              {
                method: "POST",
                body: JSON.stringify({
                  content_ids: [readerResponse.json.content.id]
                })
              }
            );
            if (response.status < 300) {
              logger2({
                msg: `browser-extension: \u2705 uploaded to kindle successfully`,
                info: {
                  pageData: msg.payload.pageData
                }
              });
              trackingEvent(AnalyticsEventNames.sendToKindleSucceeded);
              sendResponse({ type: "SEND_TO_KINDLE_SUCCESS" });
              return;
            } else if (response.json?.errors && Array.isArray(response.json.errors) && response.json.errors.includes(
              "Kindle upload requires a kindle account."
            )) {
              logger2({
                msg: `browser-extension: \u2699\uFE0F user has no kindle account, beginning setup...`,
                info: {
                  response
                }
              });
              await authedMatterApiFetch(ApiEndpoints.PROFILE, { method: "GET" }).then(({ status, json }) => {
                if (status < 400 && json.account_id) {
                  logger2({
                    msg: `browser-extension: \u2705 user profile updated successfully`
                  });
                  chrome.storage.local.set({ account_id: json.account_id });
                  chrome.storage.local.set({ profile: json });
                  logMeta.account_id = json.account_id;
                } else {
                  const error2 = new Error(
                    `browser-extension: \u274C failed to update user profile`
                  );
                  logger2({ error: error2, info: { status, json } });
                }
              }).catch((err) => {
                const error2 = new Error(
                  `browser-extension: \u274C failed to update user profile`
                );
                logger2({ error: error2, info: { error: err } });
              });
              sendResponse({ type: "NO_KINDLE_ACCOUNT" });
              return;
            } else {
              const error2 = new Error(
                `browser-extension: \u274C failed to upload to kindle`
              );
              logger2({
                error: error2,
                info: {
                  pageData: msg.payload.pageData
                }
              });
            }
          } else {
            const error2 = new Error(
              `browser-extension: \u274C failed to fetch reader view for send to kindle`
            );
            logger2({
              error: error2,
              info: {
                pageData: msg.payload.pageData
              }
            });
          }
        } catch (err) {
          const error2 = new Error(
            `browser-extension: \u274C failed to upload to kindle`
          );
          logger2({
            error: error2,
            info: {
              error: err,
              pageData: msg.payload.pageData
            }
          });
        }
        sendResponse({ type: "SEND_TO_KINDLE_FAIL" });
        break;
      }
      case "SET_ENTRY_ATTRIBUTES": {
        try {
          const response = await authedMatterApiFetch(
            ApiEndpoints.SAVE + `${msg.payload.id}/`,
            {
              method: "PUT",
              body: JSON.stringify(msg.payload.attributes)
            }
          );
          const logMsg = `HTTP PUT ${ApiEndpoints.SAVE + `${msg.payload.id}/`} ${response.status}`;
          if (response.status >= 400) {
            const error2 = new Error(logMsg);
            reportError(logMsg, response.status, response.json);
            logger2({ error: error2, info: { ...response } });
          } else {
            logger2({ msg: logMsg });
          }
          if (msg.payload.msgId) {
            sendResponse({
              msgId: msg.payload.msgId,
              status: response.status >= 200 && response.status < 300 ? "SUCCEEDED" : "FAILED"
            });
          }
        } catch (err) {
          const errorMessage = `HTTP POST ${ApiEndpoints.SAVE + `${msg.payload.id}/`}`;
          const error2 = new Error(errorMessage);
          reportError(errorMessage);
          logger2({ error: error2, info: { error: err } });
          sendResponse({ msgId: msg.payload.id, status: "FAILED" });
        }
        break;
      }
      case "SET_KINDLE_EMAIL": {
        logger2({ msg: `browser-extension: \u2699\uFE0F setting kindle email...` });
        try {
          await authedMatterApiFetch(ApiEndpoints.INTEGRATIONS_KINDLE_ACCOUNTS, {
            method: "PUT",
            body: JSON.stringify({
              kindle_email: msg.payload.kindle_email.toString().trim(),
              from_address_version: 3
            })
          });
          logger2({ msg: `browser-extension: \u2705 kindle email set successfully` });
          trackingEvent(AnalyticsEventNames.kindleSetupSucceeded);
          logger2({ msg: `browser-extension: \u2699\uFE0F updating user profile...` });
          authedMatterApiFetch(ApiEndpoints.PROFILE, { method: "GET" }).then(({ status, json }) => {
            if (status < 400 && json.account_id) {
              logger2({
                msg: `browser-extension: \u2705 user profile updated successfully`
              });
              chrome.storage.local.set({ account_id: json.account_id });
              chrome.storage.local.set({ profile: json });
              logMeta.account_id = json.account_id;
            } else {
              const error2 = new Error(
                `browser-extension: \u274C failed to update user profile`
              );
              logger2({ error: error2, info: { status, json } });
            }
          }).catch((err) => {
            const error2 = new Error(
              `browser-extension: \u274C failed to update user profile`
            );
            logger2({ error: error2, info: { error: err } });
          });
          const contentId = msg.payload.contentId && parseInt(msg.payload.contentId);
          if (contentId < 0) {
            const error2 = new Error(
              `browser-extension: \u274C SendToKindle contentId is invalid`
            );
            logger2({ error: error2, info: { contentId } });
          }
          logger2({
            msg: `browser-extension: \u2699\uFE0F sending kindle upload...`,
            info: { contentId }
          });
          await authedMatterApiFetch(ApiEndpoints.KINDLE_UPLOADS, {
            method: "POST",
            body: JSON.stringify({ content_ids: [contentId] })
          });
          logger2({
            msg: `browser-extension: \u2705 sent kindle upload successfully`,
            info: { contentId }
          });
          trackingEvent(AnalyticsEventNames.sendToKindleSucceeded);
          sendResponse({ type: "SET_KINDLE_EMAIL_SUCCESS" });
        } catch (err) {
          const error2 = new Error(
            "browser-extension: \u274C Failed to set kindle email and send kindle upload"
          );
          logger2({
            error: error2,
            info: { error: err, contentId: msg.payload.contentId }
          });
        }
        break;
      }
      case "SET_TAGS": {
        const response = await authedMatterApiFetch(ApiEndpoints.TAGS, {
          method: "GET"
        });
        if (response.status >= 200 && response.status < 300) {
          chrome.storage.local.set({ "/api/tags": response.json.tags });
          sendResponse(response.json.tags);
        } else {
          sendResponse(null);
        }
        break;
      }
      case "IS_USER_LOGGED_IN": {
        const hasValidAuth = await isUserLoggedIn();
        sendResponse({
          type: "IS_USER_LOGGED_IN",
          payload: hasValidAuth
        });
        break;
      }
      case "WORDS_SELECTION_ERROR":
        const error = new Error(`browser-extension: \u274C wordsSelection error`);
        logger2({ error, info: msg.payload });
        sendResponse(null);
        break;
    }
  };
  chrome.runtime.onMessage.addListener(
    (msg, _, sendResponse) => {
      onMessageListener(msg, sendResponse);
      return true;
    }
  );
  chrome.contextMenus.onClicked.addListener(({ menuItemId, linkUrl }, tab) => {
    switch (menuItemId) {
      case CONTEXT_MENUS.SAVE_ARTICLE:
        chrome.tabs.query({ active: true, currentWindow: true }, function(tabs) {
          const tabId = tabs[0].id;
          if (tabId) {
            chrome.tabs.sendMessage(tabId, {
              type: MESSAGES.CONTEXT_MENU_REQUEST_SAVE,
              payload: menuItemId
            });
          }
        });
        break;
      case CONTEXT_MENUS.TOGGLE_READER_VIEW:
        if (tab && tab.id) {
          chrome.tabs.sendMessage(tab.id, {
            type: MESSAGES.CONTEXT_MENU_TOGGLE_READER_VIEW,
            payload: menuItemId
          });
        }
        break;
      case CONTEXT_MENUS.HELP:
        chrome.tabs.create({
          active: true,
          url: `${webappUrlNew}/extension/help`
        });
        break;
      case CONTEXT_MENUS.VISIT_WEB_APP:
        chrome.tabs.create({
          active: true,
          url: `${webappUrlNew}/list/queue`
        });
        break;
      case CONTEXT_MENUS.FEEDBACK:
        chrome.tabs.create({
          active: true,
          url: `${webappUrlNew}/feedback?for=ext&v=${encodeURIComponent(
            manifest.version
          )}`
        });
        break;
      case "SAVE_LINK_TO_MATTER":
        getActiveTab().then((tab2) => {
          chrome.tabs.sendMessage(tab2.id, {
            type: "SAVE_LINK_TO_MATTER",
            payload: linkUrl
          });
        });
        break;
      case "HIGHLIGHT_TEXT":
        getActiveTab().then((tab2) => {
          chrome.tabs.sendMessage(tab2.id, {
            type: "HIGHLIGHT_TEXT"
          });
        });
        break;
    }
    return true;
  });
  chrome.contextMenus.removeAll();
  var contextName = manifest.manifest_version === 3 ? "action" : "browser_action";
  chrome.contextMenus.create({
    id: CONTEXT_MENUS.SAVE_ARTICLE,
    title: "Save Article",
    contexts: ["page"]
  });
  chrome.contextMenus.create({
    id: CONTEXT_MENUS.TOGGLE_READER_VIEW,
    title: "Toggle Reader View",
    contexts: ["page"]
  });
  chrome.contextMenus.create({
    id: CONTEXT_MENUS.HELP,
    title: "Help",
    contexts: [contextName]
  });
  chrome.contextMenus.create({
    id: CONTEXT_MENUS.FEEDBACK,
    title: "Feedback",
    contexts: [contextName]
  });
  chrome.contextMenus.create({
    id: CONTEXT_MENUS.VISIT_WEB_APP,
    title: "Visit web app",
    contexts: [contextName]
  });
  chrome.contextMenus.create({
    id: "SAVE_LINK_TO_MATTER",
    title: "Save link to Matter",
    contexts: ["link"]
  });
  chrome.contextMenus.create({
    id: "HIGHLIGHT_TEXT",
    title: "Highlight",
    contexts: ["selection"]
  });
  chrome.runtime.setUninstallURL(
    `${webappUrlNew}/extension/feedback/uninstall?v=${encodeURIComponent(
      manifest.version
    )}`
  );
  chrome.commands.onCommand.addListener((command) => {
    getActiveTab().then(async (tab) => {
      if (tab.url?.startsWith("https://web.getmatter.com") || tab.url?.startsWith(webappUrlNew)) {
        return;
      }
      if (isSafari2) {
        const { safariKbdShortcutsEnabled } = await storageGet([
          "safariKbdShortcutsEnabled"
        ]);
        if (safariKbdShortcutsEnabled === false) {
          return;
        }
      }
      switch (command) {
        case "reader":
          chrome.tabs.sendMessage(tab.id, {
            type: MESSAGES.COMMAND_OPEN_READER_VIEW
          });
          break;
        case "save":
          chrome.tabs.sendMessage(tab.id, {
            type: MESSAGES.COMMAND_SAVE
          });
          break;
        case "saveAndTag":
          chrome.tabs.sendMessage(tab.id, {
            type: "COMMAND_SAVE_AND_TAG"
          });
          break;
        case "saveAndNote":
          chrome.tabs.sendMessage(tab.id, {
            type: "COMMAND_SAVE_AND_NOTE"
          });
          break;
      }
    });
  });
})();
/*! js-cookie v3.0.1 | MIT */
