"use strict";
(() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __esm = (fn, res) => function __init() {
    return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
  };
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
    mod
  ));

  // node_modules/p-finally/index.js
  var require_p_finally = __commonJS({
    "node_modules/p-finally/index.js"(exports, module) {
      "use strict";
      module.exports = (promise, onFinally) => {
        onFinally = onFinally || (() => {
        });
        return promise.then(
          (val) => new Promise((resolve) => {
            resolve(onFinally());
          }).then(() => val),
          (err) => new Promise((resolve) => {
            resolve(onFinally());
          }).then(() => {
            throw err;
          })
        );
      };
    }
  });

  // node_modules/p-timeout/index.js
  var require_p_timeout = __commonJS({
    "node_modules/p-timeout/index.js"(exports, module) {
      "use strict";
      var pFinally = require_p_finally();
      var TimeoutError = class extends Error {
        constructor(message) {
          super(message);
          this.name = "TimeoutError";
        }
      };
      var pTimeout = (promise, milliseconds, fallback) => new Promise((resolve, reject) => {
        if (typeof milliseconds !== "number" || milliseconds < 0) {
          throw new TypeError("Expected `milliseconds` to be a positive number");
        }
        if (milliseconds === Infinity) {
          resolve(promise);
          return;
        }
        const timer = setTimeout(() => {
          if (typeof fallback === "function") {
            try {
              resolve(fallback());
            } catch (error) {
              reject(error);
            }
            return;
          }
          const message = typeof fallback === "string" ? fallback : `Promise timed out after ${milliseconds} milliseconds`;
          const timeoutError = fallback instanceof Error ? fallback : new TimeoutError(message);
          if (typeof promise.cancel === "function") {
            promise.cancel();
          }
          reject(timeoutError);
        }, milliseconds);
        pFinally(
          promise.then(resolve, reject),
          () => {
            clearTimeout(timer);
          }
        );
      });
      module.exports = pTimeout;
      module.exports.default = pTimeout;
      module.exports.TimeoutError = TimeoutError;
    }
  });

  // node_modules/p-wait-for/index.js
  var require_p_wait_for = __commonJS({
    "node_modules/p-wait-for/index.js"(exports, module) {
      "use strict";
      var pTimeout = require_p_timeout();
      var pWaitFor3 = async (condition, options) => {
        options = {
          interval: 20,
          timeout: Infinity,
          leadingCheck: true,
          ...options
        };
        let retryTimeout;
        const promise = new Promise((resolve, reject) => {
          const check = async () => {
            try {
              const value = await condition();
              if (typeof value !== "boolean") {
                throw new TypeError("Expected condition to return a boolean");
              }
              if (value === true) {
                resolve();
              } else {
                retryTimeout = setTimeout(check, options.interval);
              }
            } catch (error) {
              reject(error);
            }
          };
          if (options.leadingCheck) {
            check();
          } else {
            retryTimeout = setTimeout(check, options.interval);
          }
        });
        if (options.timeout !== Infinity) {
          try {
            return await pTimeout(promise, options.timeout);
          } catch (error) {
            if (retryTimeout) {
              clearTimeout(retryTimeout);
            }
            throw error;
          }
        }
        return promise;
      };
      module.exports = pWaitFor3;
      module.exports.default = pWaitFor3;
    }
  });

  // node_modules/p-retry/node_modules/retry/lib/retry_operation.js
  var require_retry_operation = __commonJS({
    "node_modules/p-retry/node_modules/retry/lib/retry_operation.js"(exports, module) {
      function RetryOperation(timeouts, options) {
        if (typeof options === "boolean") {
          options = { forever: options };
        }
        this._originalTimeouts = JSON.parse(JSON.stringify(timeouts));
        this._timeouts = timeouts;
        this._options = options || {};
        this._maxRetryTime = options && options.maxRetryTime || Infinity;
        this._fn = null;
        this._errors = [];
        this._attempts = 1;
        this._operationTimeout = null;
        this._operationTimeoutCb = null;
        this._timeout = null;
        this._operationStart = null;
        this._timer = null;
        if (this._options.forever) {
          this._cachedTimeouts = this._timeouts.slice(0);
        }
      }
      module.exports = RetryOperation;
      RetryOperation.prototype.reset = function() {
        this._attempts = 1;
        this._timeouts = this._originalTimeouts.slice(0);
      };
      RetryOperation.prototype.stop = function() {
        if (this._timeout) {
          clearTimeout(this._timeout);
        }
        if (this._timer) {
          clearTimeout(this._timer);
        }
        this._timeouts = [];
        this._cachedTimeouts = null;
      };
      RetryOperation.prototype.retry = function(err) {
        if (this._timeout) {
          clearTimeout(this._timeout);
        }
        if (!err) {
          return false;
        }
        var currentTime = new Date().getTime();
        if (err && currentTime - this._operationStart >= this._maxRetryTime) {
          this._errors.push(err);
          this._errors.unshift(new Error("RetryOperation timeout occurred"));
          return false;
        }
        this._errors.push(err);
        var timeout = this._timeouts.shift();
        if (timeout === void 0) {
          if (this._cachedTimeouts) {
            this._errors.splice(0, this._errors.length - 1);
            timeout = this._cachedTimeouts.slice(-1);
          } else {
            return false;
          }
        }
        var self2 = this;
        this._timer = setTimeout(function() {
          self2._attempts++;
          if (self2._operationTimeoutCb) {
            self2._timeout = setTimeout(function() {
              self2._operationTimeoutCb(self2._attempts);
            }, self2._operationTimeout);
            if (self2._options.unref) {
              self2._timeout.unref();
            }
          }
          self2._fn(self2._attempts);
        }, timeout);
        if (this._options.unref) {
          this._timer.unref();
        }
        return true;
      };
      RetryOperation.prototype.attempt = function(fn, timeoutOps) {
        this._fn = fn;
        if (timeoutOps) {
          if (timeoutOps.timeout) {
            this._operationTimeout = timeoutOps.timeout;
          }
          if (timeoutOps.cb) {
            this._operationTimeoutCb = timeoutOps.cb;
          }
        }
        var self2 = this;
        if (this._operationTimeoutCb) {
          this._timeout = setTimeout(function() {
            self2._operationTimeoutCb();
          }, self2._operationTimeout);
        }
        this._operationStart = new Date().getTime();
        this._fn(this._attempts);
      };
      RetryOperation.prototype.try = function(fn) {
        console.log("Using RetryOperation.try() is deprecated");
        this.attempt(fn);
      };
      RetryOperation.prototype.start = function(fn) {
        console.log("Using RetryOperation.start() is deprecated");
        this.attempt(fn);
      };
      RetryOperation.prototype.start = RetryOperation.prototype.try;
      RetryOperation.prototype.errors = function() {
        return this._errors;
      };
      RetryOperation.prototype.attempts = function() {
        return this._attempts;
      };
      RetryOperation.prototype.mainError = function() {
        if (this._errors.length === 0) {
          return null;
        }
        var counts = {};
        var mainError = null;
        var mainErrorCount = 0;
        for (var i = 0; i < this._errors.length; i++) {
          var error = this._errors[i];
          var message = error.message;
          var count = (counts[message] || 0) + 1;
          counts[message] = count;
          if (count >= mainErrorCount) {
            mainError = error;
            mainErrorCount = count;
          }
        }
        return mainError;
      };
    }
  });

  // node_modules/p-retry/node_modules/retry/lib/retry.js
  var require_retry = __commonJS({
    "node_modules/p-retry/node_modules/retry/lib/retry.js"(exports) {
      var RetryOperation = require_retry_operation();
      exports.operation = function(options) {
        var timeouts = exports.timeouts(options);
        return new RetryOperation(timeouts, {
          forever: options && (options.forever || options.retries === Infinity),
          unref: options && options.unref,
          maxRetryTime: options && options.maxRetryTime
        });
      };
      exports.timeouts = function(options) {
        if (options instanceof Array) {
          return [].concat(options);
        }
        var opts = {
          retries: 10,
          factor: 2,
          minTimeout: 1 * 1e3,
          maxTimeout: Infinity,
          randomize: false
        };
        for (var key in options) {
          opts[key] = options[key];
        }
        if (opts.minTimeout > opts.maxTimeout) {
          throw new Error("minTimeout is greater than maxTimeout");
        }
        var timeouts = [];
        for (var i = 0; i < opts.retries; i++) {
          timeouts.push(this.createTimeout(i, opts));
        }
        if (options && options.forever && !timeouts.length) {
          timeouts.push(this.createTimeout(i, opts));
        }
        timeouts.sort(function(a, b) {
          return a - b;
        });
        return timeouts;
      };
      exports.createTimeout = function(attempt, opts) {
        var random = opts.randomize ? Math.random() + 1 : 1;
        var timeout = Math.round(random * Math.max(opts.minTimeout, 1) * Math.pow(opts.factor, attempt));
        timeout = Math.min(timeout, opts.maxTimeout);
        return timeout;
      };
      exports.wrap = function(obj, options, methods) {
        if (options instanceof Array) {
          methods = options;
          options = null;
        }
        if (!methods) {
          methods = [];
          for (var key in obj) {
            if (typeof obj[key] === "function") {
              methods.push(key);
            }
          }
        }
        for (var i = 0; i < methods.length; i++) {
          var method = methods[i];
          var original = obj[method];
          obj[method] = function retryWrapper(original2) {
            var op = exports.operation(options);
            var args = Array.prototype.slice.call(arguments, 1);
            var callback = args.pop();
            args.push(function(err) {
              if (op.retry(err)) {
                return;
              }
              if (err) {
                arguments[0] = op.mainError();
              }
              callback.apply(this, arguments);
            });
            op.attempt(function() {
              original2.apply(obj, args);
            });
          }.bind(obj, original);
          obj[method].options = options;
        }
      };
    }
  });

  // node_modules/p-retry/node_modules/retry/index.js
  var require_retry2 = __commonJS({
    "node_modules/p-retry/node_modules/retry/index.js"(exports, module) {
      module.exports = require_retry();
    }
  });

  // node_modules/serialize-error/error-constructors.js
  var list, errorConstructors, error_constructors_default;
  var init_error_constructors = __esm({
    "node_modules/serialize-error/error-constructors.js"() {
      list = [
        EvalError,
        RangeError,
        ReferenceError,
        SyntaxError,
        TypeError,
        URIError,
        globalThis.DOMException,
        globalThis.AssertionError,
        globalThis.SystemError
      ].filter(Boolean).map(
        (constructor) => [constructor.name, constructor]
      );
      errorConstructors = new Map(list);
      error_constructors_default = errorConstructors;
    }
  });

  // node_modules/serialize-error/index.js
  var serialize_error_exports = {};
  __export(serialize_error_exports, {
    NonError: () => NonError,
    deserializeError: () => deserializeError,
    errorConstructors: () => error_constructors_default,
    isErrorLike: () => isErrorLike,
    serializeError: () => serializeError
  });
  function serializeError(value, options = {}) {
    const {
      maxDepth = Number.POSITIVE_INFINITY,
      useToJSON = true
    } = options;
    if (typeof value === "object" && value !== null) {
      return destroyCircular({
        from: value,
        seen: [],
        forceEnumerable: true,
        maxDepth,
        depth: 0,
        useToJSON,
        serialize: true
      });
    }
    if (typeof value === "function") {
      return `[Function: ${value.name ?? "anonymous"}]`;
    }
    return value;
  }
  function deserializeError(value, options = {}) {
    const { maxDepth = Number.POSITIVE_INFINITY } = options;
    if (value instanceof Error) {
      return value;
    }
    if (isMinimumViableSerializedError(value)) {
      const Error2 = getErrorConstructor(value.name);
      return destroyCircular({
        from: value,
        seen: [],
        to: new Error2(),
        maxDepth,
        depth: 0,
        serialize: false
      });
    }
    return new NonError(value);
  }
  function isErrorLike(value) {
    return Boolean(value) && typeof value === "object" && "name" in value && "message" in value && "stack" in value;
  }
  function isMinimumViableSerializedError(value) {
    return Boolean(value) && typeof value === "object" && "message" in value && !Array.isArray(value);
  }
  var NonError, commonProperties, toJsonWasCalled, toJSON, getErrorConstructor, destroyCircular;
  var init_serialize_error = __esm({
    "node_modules/serialize-error/index.js"() {
      init_error_constructors();
      init_error_constructors();
      NonError = class extends Error {
        name = "NonError";
        constructor(message) {
          super(NonError._prepareSuperMessage(message));
        }
        static _prepareSuperMessage(message) {
          try {
            return JSON.stringify(message);
          } catch {
            return String(message);
          }
        }
      };
      commonProperties = [
        {
          property: "name",
          enumerable: false
        },
        {
          property: "message",
          enumerable: false
        },
        {
          property: "stack",
          enumerable: false
        },
        {
          property: "code",
          enumerable: true
        },
        {
          property: "cause",
          enumerable: false
        }
      ];
      toJsonWasCalled = Symbol(".toJSON was called");
      toJSON = (from) => {
        from[toJsonWasCalled] = true;
        const json = from.toJSON();
        delete from[toJsonWasCalled];
        return json;
      };
      getErrorConstructor = (name) => error_constructors_default.get(name) ?? Error;
      destroyCircular = ({
        from,
        seen,
        to,
        forceEnumerable,
        maxDepth,
        depth,
        useToJSON,
        serialize
      }) => {
        if (!to) {
          if (Array.isArray(from)) {
            to = [];
          } else if (!serialize && isErrorLike(from)) {
            const Error2 = getErrorConstructor(from.name);
            to = new Error2();
          } else {
            to = {};
          }
        }
        seen.push(from);
        if (depth >= maxDepth) {
          return to;
        }
        if (useToJSON && typeof from.toJSON === "function" && from[toJsonWasCalled] !== true) {
          return toJSON(from);
        }
        const continueDestroyCircular = (value) => destroyCircular({
          from: value,
          seen: [...seen],
          forceEnumerable,
          maxDepth,
          depth,
          useToJSON,
          serialize
        });
        for (const [key, value] of Object.entries(from)) {
          if (typeof Buffer === "function" && Buffer.isBuffer(value)) {
            to[key] = "[object Buffer]";
            continue;
          }
          if (value !== null && typeof value === "object" && typeof value.pipe === "function") {
            to[key] = "[object Stream]";
            continue;
          }
          if (typeof value === "function") {
            continue;
          }
          if (!value || typeof value !== "object") {
            to[key] = value;
            continue;
          }
          if (!seen.includes(from[key])) {
            depth++;
            to[key] = continueDestroyCircular(from[key]);
            continue;
          }
          to[key] = "[Circular]";
        }
        for (const { property, enumerable } of commonProperties) {
          if (typeof from[property] !== "undefined" && from[property] !== null) {
            Object.defineProperty(to, property, {
              value: isErrorLike(from[property]) ? continueDestroyCircular(from[property]) : from[property],
              enumerable: forceEnumerable ? true : enumerable,
              configurable: true,
              writable: true
            });
          }
        }
        return to;
      };
    }
  });

  // node_modules/lodash/isObject.js
  var require_isObject = __commonJS({
    "node_modules/lodash/isObject.js"(exports, module) {
      function isObject(value) {
        var type = typeof value;
        return value != null && (type == "object" || type == "function");
      }
      module.exports = isObject;
    }
  });

  // node_modules/lodash/_freeGlobal.js
  var require_freeGlobal = __commonJS({
    "node_modules/lodash/_freeGlobal.js"(exports, module) {
      var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
      module.exports = freeGlobal;
    }
  });

  // node_modules/lodash/_root.js
  var require_root = __commonJS({
    "node_modules/lodash/_root.js"(exports, module) {
      var freeGlobal = require_freeGlobal();
      var freeSelf = typeof self == "object" && self && self.Object === Object && self;
      var root = freeGlobal || freeSelf || Function("return this")();
      module.exports = root;
    }
  });

  // node_modules/lodash/now.js
  var require_now = __commonJS({
    "node_modules/lodash/now.js"(exports, module) {
      var root = require_root();
      var now = function() {
        return root.Date.now();
      };
      module.exports = now;
    }
  });

  // node_modules/lodash/_trimmedEndIndex.js
  var require_trimmedEndIndex = __commonJS({
    "node_modules/lodash/_trimmedEndIndex.js"(exports, module) {
      var reWhitespace = /\s/;
      function trimmedEndIndex(string3) {
        var index = string3.length;
        while (index-- && reWhitespace.test(string3.charAt(index))) {
        }
        return index;
      }
      module.exports = trimmedEndIndex;
    }
  });

  // node_modules/lodash/_baseTrim.js
  var require_baseTrim = __commonJS({
    "node_modules/lodash/_baseTrim.js"(exports, module) {
      var trimmedEndIndex = require_trimmedEndIndex();
      var reTrimStart = /^\s+/;
      function baseTrim(string3) {
        return string3 ? string3.slice(0, trimmedEndIndex(string3) + 1).replace(reTrimStart, "") : string3;
      }
      module.exports = baseTrim;
    }
  });

  // node_modules/lodash/_Symbol.js
  var require_Symbol = __commonJS({
    "node_modules/lodash/_Symbol.js"(exports, module) {
      var root = require_root();
      var Symbol2 = root.Symbol;
      module.exports = Symbol2;
    }
  });

  // node_modules/lodash/_getRawTag.js
  var require_getRawTag = __commonJS({
    "node_modules/lodash/_getRawTag.js"(exports, module) {
      var Symbol2 = require_Symbol();
      var objectProto = Object.prototype;
      var hasOwnProperty3 = objectProto.hasOwnProperty;
      var nativeObjectToString = objectProto.toString;
      var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
      function getRawTag(value) {
        var isOwn = hasOwnProperty3.call(value, symToStringTag), tag = value[symToStringTag];
        try {
          value[symToStringTag] = void 0;
          var unmasked = true;
        } catch (e) {
        }
        var result = nativeObjectToString.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag] = tag;
          } else {
            delete value[symToStringTag];
          }
        }
        return result;
      }
      module.exports = getRawTag;
    }
  });

  // node_modules/lodash/_objectToString.js
  var require_objectToString = __commonJS({
    "node_modules/lodash/_objectToString.js"(exports, module) {
      var objectProto = Object.prototype;
      var nativeObjectToString = objectProto.toString;
      function objectToString(value) {
        return nativeObjectToString.call(value);
      }
      module.exports = objectToString;
    }
  });

  // node_modules/lodash/_baseGetTag.js
  var require_baseGetTag = __commonJS({
    "node_modules/lodash/_baseGetTag.js"(exports, module) {
      var Symbol2 = require_Symbol();
      var getRawTag = require_getRawTag();
      var objectToString = require_objectToString();
      var nullTag = "[object Null]";
      var undefinedTag = "[object Undefined]";
      var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
      function baseGetTag(value) {
        if (value == null) {
          return value === void 0 ? undefinedTag : nullTag;
        }
        return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
      }
      module.exports = baseGetTag;
    }
  });

  // node_modules/lodash/isObjectLike.js
  var require_isObjectLike = __commonJS({
    "node_modules/lodash/isObjectLike.js"(exports, module) {
      function isObjectLike(value) {
        return value != null && typeof value == "object";
      }
      module.exports = isObjectLike;
    }
  });

  // node_modules/lodash/isSymbol.js
  var require_isSymbol = __commonJS({
    "node_modules/lodash/isSymbol.js"(exports, module) {
      var baseGetTag = require_baseGetTag();
      var isObjectLike = require_isObjectLike();
      var symbolTag = "[object Symbol]";
      function isSymbol(value) {
        return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
      }
      module.exports = isSymbol;
    }
  });

  // node_modules/lodash/toNumber.js
  var require_toNumber = __commonJS({
    "node_modules/lodash/toNumber.js"(exports, module) {
      var baseTrim = require_baseTrim();
      var isObject = require_isObject();
      var isSymbol = require_isSymbol();
      var NAN = 0 / 0;
      var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
      var reIsBinary = /^0b[01]+$/i;
      var reIsOctal = /^0o[0-7]+$/i;
      var freeParseInt = parseInt;
      function toNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol(value)) {
          return NAN;
        }
        if (isObject(value)) {
          var other = typeof value.valueOf == "function" ? value.valueOf() : value;
          value = isObject(other) ? other + "" : other;
        }
        if (typeof value != "string") {
          return value === 0 ? value : +value;
        }
        value = baseTrim(value);
        var isBinary = reIsBinary.test(value);
        return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
      }
      module.exports = toNumber;
    }
  });

  // node_modules/lodash/debounce.js
  var require_debounce = __commonJS({
    "node_modules/lodash/debounce.js"(exports, module) {
      var isObject = require_isObject();
      var now = require_now();
      var toNumber = require_toNumber();
      var FUNC_ERROR_TEXT = "Expected a function";
      var nativeMax = Math.max;
      var nativeMin = Math.min;
      function debounce(func, wait, options) {
        var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != "function") {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        wait = toNumber(wait) || 0;
        if (isObject(options)) {
          leading = !!options.leading;
          maxing = "maxWait" in options;
          maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = void 0;
          lastInvokeTime = time;
          result = func.apply(thisArg, args);
          return result;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout(timerExpired, wait);
          return leading ? invokeFunc(time) : result;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = void 0;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = void 0;
          return result;
        }
        function cancel() {
          if (timerId !== void 0) {
            clearTimeout(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = void 0;
        }
        function flush() {
          return timerId === void 0 ? result : trailingEdge(now());
        }
        function debounced() {
          var time = now(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === void 0) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout(timerId);
              timerId = setTimeout(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === void 0) {
            timerId = setTimeout(timerExpired, wait);
          }
          return result;
        }
        debounced.cancel = cancel;
        debounced.flush = flush;
        return debounced;
      }
      module.exports = debounce;
    }
  });

  // node_modules/lodash/throttle.js
  var require_throttle = __commonJS({
    "node_modules/lodash/throttle.js"(exports, module) {
      var debounce = require_debounce();
      var isObject = require_isObject();
      var FUNC_ERROR_TEXT = "Expected a function";
      function throttle2(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != "function") {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        if (isObject(options)) {
          leading = "leading" in options ? !!options.leading : leading;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        return debounce(func, wait, {
          "leading": leading,
          "maxWait": wait,
          "trailing": trailing
        });
      }
      module.exports = throttle2;
    }
  });

  // web-extension/popup/popup.ts
  var import_p_wait_for2 = __toESM(require_p_wait_for(), 1);

  // utils/constants.ts
  var ApiEndpoints = {
    ANNOTATIONS_BY_ID: "/annotations/:id/",
    ANNOTATIONS: "/annotations/",
    APPLE_SIGN_IN: "/apple_sign_in/",
    ARCHIVE_FEED: "/library_items/archive_feed/",
    AUTHORS_FEED: "/feed/authors/",
    BUG_REPORTS: "/bug_reports/",
    CLIENT_ERROR: "/_client/error",
    CLIENT_LOG: "/_client/log",
    CONTENTS_MY_ANNOTATIONS: "/contents/:id/my_annotations/",
    CONTENTS_TAGS: "/contents/tags/",
    CONTENTS: "/contents/:id/",
    FAVORITES_FEED: "/library_items/favorites_feed/",
    FEEDBACK: "/feedback/",
    HANDLES_CHECK: "/handles/check_available/",
    HANDLES_CLAIM: "/handles/claim/",
    HIGHLIGHTS_FEED: "/library_items/highlights_feed/",
    HISTORY_ENTRIES: "/history_entries/",
    INTEGRATIONS_KINDLE_ACCOUNTS: "/integrations/kindle_accounts/",
    KINDLE_UPLOADS: "/kindle_uploads/",
    LIBRARY_ENTRIES: "/library_entries/",
    LIKES: "/likes/",
    MAGIC_LOGIN_TRIGGER: "/magic_login/trigger/",
    MAGIC_LOGIN_EXCHANGE: "/magic_login/exchange/",
    NOTES: "/notes/",
    NOTE: "/notes/:id/",
    PROFILE: "/profile/",
    QR_EXCHANGE: "/qr_login/exchange/",
    QR_TRIGGER: "/qr_login/trigger/",
    QUEUE_FEED: "/library_items/queue_feed/",
    READER_VIEW: "/reader_view/",
    RECENT_FEED: "/library_items/recent_feed/",
    REFRESH_TOKEN_EXCHANGE: "/token/refresh/",
    SAVE: "/save/",
    SAVE_BY_ID: "/save/:id/",
    SEARCH: "/search/",
    SOURCES: "/sources/",
    SUBSCRIPTION_FEED: "/profile/:profile_id/author_feed/",
    SUBSCRIPTIONS_FEED: "/feed/inbox/",
    SPEECH: "/speech/",
    STAFF_PICKS_FEED: "/feed/discover_split/",
    TAGS: "/tags/",
    TAGS_FEED: "/library_items/tags_feed/",
    TRACK: "/track/",
    UPDATES_FEED: "/library_items/updates_feed/"
  };
  var CookieNames = {
    access_token: "access_token",
    refresh_token: "refresh_token",
    session_token: "session_token",
    extension_access_token: "extension_access_token",
    extension_refresh_token: "extension_refresh_token",
    mrProfileAccountId: "mrProfileAccountId",
    mrVersion: "mrVersion"
  };
  var libraryState = {
    LIBRARY_STATE_UNSAVED: 0,
    LIBRARY_STATE_SAVED: 1,
    LIBRARY_STATE_ARCHIVED: 2,
    LIBRARY_STATE_DELETED: 3
  };

  // web-extension/constants.ts
  var isFirefox = navigator.userAgent.toLowerCase().indexOf("firefox") > -1;
  var webappUrlNew = "https://web.getmatter.com";

  // web-extension/utils/clientAndServer.ts
  var hashStrToInt = (str) => {
    let hash = 0;
    for (let i = 0, len = str.length; i < len; i++) {
      let chr = str.charCodeAt(i);
      hash = (hash << 5) - hash + chr;
      hash |= 0;
    }
    if (hash < 0) {
      return hash * -1;
    }
    return hash;
  };

  // web-extension/utils/utils.ts
  var import_p_wait_for = __toESM(require_p_wait_for(), 1);

  // node_modules/js-cookie/dist/js.cookie.mjs
  function assign(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        target[key] = source[key];
      }
    }
    return target;
  }
  var defaultConverter = {
    read: function(value) {
      if (value[0] === '"') {
        value = value.slice(1, -1);
      }
      return value.replace(/(%[\dA-F]{2})+/gi, decodeURIComponent);
    },
    write: function(value) {
      return encodeURIComponent(value).replace(
        /%(2[346BF]|3[AC-F]|40|5[BDE]|60|7[BCD])/g,
        decodeURIComponent
      );
    }
  };
  function init(converter, defaultAttributes) {
    function set(key, value, attributes) {
      if (typeof document === "undefined") {
        return;
      }
      attributes = assign({}, defaultAttributes, attributes);
      if (typeof attributes.expires === "number") {
        attributes.expires = new Date(Date.now() + attributes.expires * 864e5);
      }
      if (attributes.expires) {
        attributes.expires = attributes.expires.toUTCString();
      }
      key = encodeURIComponent(key).replace(/%(2[346B]|5E|60|7C)/g, decodeURIComponent).replace(/[()]/g, escape);
      var stringifiedAttributes = "";
      for (var attributeName in attributes) {
        if (!attributes[attributeName]) {
          continue;
        }
        stringifiedAttributes += "; " + attributeName;
        if (attributes[attributeName] === true) {
          continue;
        }
        stringifiedAttributes += "=" + attributes[attributeName].split(";")[0];
      }
      return document.cookie = key + "=" + converter.write(value, key) + stringifiedAttributes;
    }
    function get(key) {
      if (typeof document === "undefined" || arguments.length && !key) {
        return;
      }
      var cookies = document.cookie ? document.cookie.split("; ") : [];
      var jar = {};
      for (var i = 0; i < cookies.length; i++) {
        var parts = cookies[i].split("=");
        var value = parts.slice(1).join("=");
        try {
          var foundKey = decodeURIComponent(parts[0]);
          jar[foundKey] = converter.read(value, foundKey);
          if (key === foundKey) {
            break;
          }
        } catch (e) {
        }
      }
      return key ? jar[key] : jar;
    }
    return Object.create(
      {
        set,
        get,
        remove: function(key, attributes) {
          set(
            key,
            "",
            assign({}, attributes, {
              expires: -1
            })
          );
        },
        withAttributes: function(attributes) {
          return init(this.converter, assign({}, this.attributes, attributes));
        },
        withConverter: function(converter2) {
          return init(assign({}, this.converter, converter2), this.attributes);
        }
      },
      {
        attributes: { value: Object.freeze(defaultAttributes) },
        converter: { value: Object.freeze(converter) }
      }
    );
  }
  var api = init(defaultConverter, { path: "/" });
  var js_cookie_default = api;

  // utils/typeGuards.ts
  var isValidApiVersion = (str) => {
    return str !== void 0 && ["v10", "v11", "v12", "v13", "v14", "v15"].includes(str);
  };
  function isHTMLElement(target) {
    return target instanceof HTMLElement;
  }

  // utils/utils.ts
  var isSafari = () => typeof window !== "undefined" && /^((?!chrome|android).)*safari/i.test(window.navigator.userAgent);
  var defaultVersion = isValidApiVersion(
    ""
  ) ? "" : "v15";

  // web-extension/utils/utils.ts
  if (globalThis.browser?.runtime.getURL("").startsWith("moz-extension")) {
    globalThis.chrome = globalThis.browser;
  }
  var manifest = chrome.runtime.getManifest();
  var isValidOrigin2 = (str) => {
    return str === "https://api.getmatter.app" || str === "https://api.getmatter.com" || str === "https://api.winnotest.com" || str === "http://localhost:8000/api";
  };
  var defaultApiOrigin = (() => {
    const matterApiUrl = "";
    if (isValidOrigin2(matterApiUrl)) {
      return matterApiUrl;
    }
    return "https://api.getmatter.com";
  })();
  var storageGet = (keys) => {
    return new Promise((resolve) => {
      chrome.storage.local.get(keys, (result) => {
        return resolve(result);
      });
    });
  };
  var matterSessionStorage = () => {
    try {
      const storage = JSON.parse(
        sessionStorage.getItem("mrExtData") || "{}"
      );
      return {
        get: (key) => storage[key],
        set: (key, value) => {
          storage[key] = value;
          sessionStorage.setItem("mrExtData", JSON.stringify(storage));
        },
        delete: (key) => {
          delete storage[key];
          sessionStorage.setItem("mrExtData", JSON.stringify(storage));
        },
        keys: () => Object.keys(storage)
      };
    } catch (err) {
      return /* @__PURE__ */ new Map();
    }
  };
  var getMatterSessionStorageValByUrl = (url) => {
    const urlKey = hashStrToInt(url).toString();
    const { get } = matterSessionStorage();
    return get(urlKey);
  };
  var deleteMatterSessionStorageValByUrl = (url) => {
    const urlKey = hashStrToInt(url).toString();
    const storage = matterSessionStorage();
    return storage.delete(urlKey);
  };
  var setMatterSessionStorageByUrl = (url, payload) => {
    const urlKey = hashStrToInt(url).toString();
    const { get } = matterSessionStorage();
    const stored = get(urlKey);
    if (payload.key === "readerData") {
      const current = stored?.[payload.key] || {};
      const update = {
        ...stored,
        [payload.key]: {
          ...current,
          [url]: payload.value
        }
      };
      matterSessionStorage().set(urlKey, update);
    } else if (payload.key === "attributes") {
      const update = {
        ...stored,
        ...payload.value
      };
      matterSessionStorage().set(urlKey, update);
    } else {
      const update = {
        ...stored,
        [payload.key]: payload.value
      };
      matterSessionStorage().set(urlKey, update);
    }
  };

  // util/api.ts
  var clientApiEndpoint = (endpoint, queryParams2, replacements) => {
    const params = new URLSearchParams(queryParams2);
    params.forEach((value, key) => {
      if (value === "") {
        params.delete(key);
      }
    });
    const searchString = params.toString().length > 0 ? `?${params.toString()}` : "";
    let pathname = endpoint;
    if (replacements && Object.keys(replacements).length > 0) {
      Object.entries(replacements).forEach(([key, value]) => {
        pathname = pathname.replace(`:${key}`, value);
      });
    }
    return pathname.endsWith("/") ? `/api${pathname.slice(0, -1)}${searchString}` : `/api${pathname}${searchString}`;
  };

  // node_modules/p-retry/index.js
  var import_retry = __toESM(require_retry2(), 1);

  // utils/logger.ts
  var logger = async (data, {
    shouldSerializeError = true,
    readWindowData = true,
    shouldConsoleLog = false
  } = {}) => {
    let log = typeof data === "string" ? { msg: data } : data;
    log.level = log.level || "info";
    log.time = Date.now();
    const error = log.error;
    if (error && error instanceof Error) {
      log.level = "error";
      log.msg = error.message;
      if (!shouldSerializeError) {
        log.error = JSON.stringify(error, Object.getOwnPropertyNames(error));
      } else {
        const { serializeError: serializeError2 } = await Promise.resolve().then(() => (init_serialize_error(), serialize_error_exports));
        log.error = serializeError2(error);
      }
    }
    if (typeof window !== "undefined" && readWindowData) {
      const cookieAccountId = js_cookie_default.get(CookieNames.mrProfileAccountId);
      log = {
        ...log,
        pathname: window.location.pathname,
        userAgent: window.navigator.userAgent,
        language: window.navigator.language,
        languages: window.navigator.languages,
        cookieEnabled: window.navigator.cookieEnabled,
        account_id: cookieAccountId ? parseInt(cookieAccountId) : -1
      };
    }
    if (shouldConsoleLog && typeof window !== "undefined" && true) {
    } else if (true) {
      const blob = new Blob([JSON.stringify(log)], {
        type: "application/json; charset=UTF-8"
      });
      navigator.sendBeacon(clientApiEndpoint(ApiEndpoints.CLIENT_LOG), blob);
    }
    return log;
  };

  // utils/error.ts
  var import_throttle = __toESM(require_throttle());
  var reportError = (0, import_throttle.default)(
    async (error, info, shouldSerializeError = true) => {
      if (shouldSerializeError) {
        const { serializeError: serializeError2 } = await Promise.resolve().then(() => (init_serialize_error(), serialize_error_exports));
        const blob = new Blob(
          [JSON.stringify({ error: serializeError2(error), info })],
          {
            type: "application/json; charset=UTF-8"
          }
        );
        navigator.sendBeacon(clientApiEndpoint(ApiEndpoints.CLIENT_ERROR), blob);
      } else {
        const blob = new Blob(
          [
            JSON.stringify({
              error: { name: error.name, message: error.message },
              info
            })
          ],
          {
            type: "application/json; charset=UTF-8"
          }
        );
        navigator.sendBeacon(clientApiEndpoint(ApiEndpoints.CLIENT_ERROR), blob);
      }
    },
    500
  );

  // hooks/useHighlighter/selectionAnnotation.ts
  var whiteSpace = /[ \r\n\t\u2029\u3000\uFFFC\u200B\u00A0]/gu;
  var textChunkAttr = "data-text-chunk";
  var setIsTextChunk = (el) => {
    el.setAttribute(textChunkAttr, "true");
    return el;
  };
  var isTextChunk = (el) => {
    return el.getAttribute(textChunkAttr) === "true";
  };
  var wordsSelection = (range, chunkSelector2, selectionStringInitial) => {
    const selection = window.getSelection();
    const selectionString = selectionStringInitial || selection?.toString().trim();
    if (range.collapsed || !selectionString) {
      return;
    }
    if (range.commonAncestorContainer.nodeName === "P" && selectionString === range.commonAncestorContainer.textContent?.trim()) {
      logger(
        { msg: "Matched text selection to a <p> text" },
        { shouldConsoleLog: true }
      );
      return range;
    }
    const closestChunk = closestTextChunk(range.startContainer, chunkSelector2);
    if (closestChunk && selectionString === closestChunk.textContent?.trim()) {
      logger(
        { msg: "Matched text selection to a text chunk" },
        { shouldConsoleLog: true }
      );
      range.selectNodeContents(closestChunk);
      return range;
    }
    const chunkMatch = range.commonAncestorContainer instanceof HTMLElement && [...range.commonAncestorContainer.querySelectorAll("*")].find(
      (node) => node.textContent?.trim() === selectionString
    );
    if (chunkMatch) {
      logger(
        { msg: "Matched text selection a single element's text" },
        { shouldConsoleLog: true }
      );
      range.selectNodeContents(chunkMatch);
      return range;
    }
    const closestLi = range.startContainer.parentElement?.closest("li");
    if (isHTMLElement(closestLi) && (range.toString().trim() === closestLi.textContent || `* ${selectionString}` === closestLi.textContent)) {
      logger(
        { msg: "Matched text selection to a <li> element" },
        { shouldConsoleLog: true }
      );
      range.selectNodeContents(closestLi);
      return range;
    }
    const anchorNodeText = selection?.anchorNode?.textContent?.trim().replaceAll(/\s+(?=\n)/gm, "").replaceAll("\n", " ") || "";
    if (selection?.anchorNode && selection.anchorNode.nodeType === Node.TEXT_NODE && selection.toString().trim() === anchorNodeText) {
      logger(
        {
          msg: "wordsSelection: \u2705 Matched text selection to an entire single text node"
        },
        { shouldConsoleLog: true }
      );
      range.selectNode(selection.anchorNode);
      return range;
    }
    const anchorNodeAndNextText = selection?.anchorNode?.nextSibling ? `${anchorNodeText} ${selection.anchorNode.nextSibling.textContent}`.trim().replaceAll(/\s{2,}/gm, " ") : "";
    if (selection?.anchorNode && selection.anchorNode.nextSibling && anchorNodeAndNextText && anchorNodeAndNextText === selectionString) {
      logger(
        {
          msg: "wordsSelection: \u2705 Matched text selection to full text node and its next sibling"
        },
        { shouldConsoleLog: true }
      );
      const nextSibling = selection.anchorNode.nextSibling;
      range.selectNode(selection.anchorNode);
      range.setEndAfter(nextSibling);
      return range;
    }
    if (window.location.origin.endsWith(".paulgraham.com") && window.getSelection()?.toString().endsWith("\n")) {
      return range;
    }
    logger(
      {
        msg: "`wordsSelection` exhausted simple string equality checks. Begin TreeWalker analysis..."
      },
      { shouldConsoleLog: true }
    );
    const twStartRoot = closestTextChunk(range.startContainer, chunkSelector2);
    if (!twStartRoot) {
      throw new Error("Failed to find closest start text chunk.");
    }
    const twStart = document.createTreeWalker(twStartRoot, NodeFilter.SHOW_TEXT);
    let twStartNode = twStart.nextNode();
    while (twStartNode && twStartNode !== range.startContainer) {
      twStartNode = twStart.nextNode();
    }
    const twEndRoot = closestTextChunk(range.endContainer, chunkSelector2);
    if (!twEndRoot) {
      throw new Error("Failed to find closest end text chunk.");
    }
    const twEnd = document.createTreeWalker(twEndRoot, NodeFilter.SHOW_TEXT);
    let twEndNode = twEnd.currentNode;
    while (twEndNode && twEndNode !== range.endContainer) {
      twEndNode = twEnd.nextNode();
    }
    const firstCharIsSpace = (r) => whiteSpace.test(r.toString()[0]);
    const lastCharIsWhitespace = (r) => whiteSpace.test(r.toString()[r.toString().length - 1]);
    while (!firstCharIsSpace(range)) {
      if (range.startOffset > 0) {
        range.setStart(range.startContainer, range.startOffset - 1);
      } else {
        const prev = twStart.previousNode();
        if (prev?.previousSibling?.nodeName === "BR" || prev?.previousSibling?.nodeName === "FONT") {
          range.setStart(range.startContainer, 0);
          break;
        }
        if (prev && prev.textContent) {
          range.setStart(prev, prev.textContent?.length);
        } else {
          range.setStart(range.startContainer, 0);
          break;
        }
      }
    }
    while (!lastCharIsWhitespace(range)) {
      if (range.endContainer.textContent && range.endOffset < range.endContainer.textContent.length) {
        range.setEnd(range.endContainer, range.endOffset + 1);
      } else {
        const next = twEnd.nextNode();
        if (next?.nextSibling?.nodeName === "BR" || next?.nextSibling?.nodeName === "FONT") {
          range.setEnd(
            range.endContainer,
            range.endContainer.textContent?.length || range.endOffset
          );
          break;
        }
        if (next && next.textContent) {
          range.setEnd(next, 0);
        } else {
          range.setEnd(
            range.endContainer,
            range.endContainer.textContent?.length || range.endOffset
          );
          break;
        }
      }
    }
    if (range.toString()[0].match(whiteSpace)) {
      range.setStart(range.startContainer, range.startOffset + 1);
    }
    if (range.toString()[range.toString().length - 1].match(whiteSpace)) {
      range.setEnd(range.endContainer, range.endOffset - 1);
    }
    return range;
  };
  function getCurrentSelection(targetNode, chunkSelector2) {
    const userSelection = targetNode.ownerDocument?.getSelection();
    if (!userSelection || userSelection.isCollapsed || userSelection.anchorNode?.parentElement?.nodeName === "PRE" || userSelection.anchorNode?.parentElement?.closest("pre") || userSelection.focusNode?.parentElement?.nodeName === "PRE" || userSelection.focusNode?.parentElement?.closest("pre")) {
      return false;
    }
    let range = userSelection.getRangeAt(0);
    logger(`initial text selection: ${range.cloneRange().toString()}`, {
      shouldConsoleLog: true
    });
    wordsSelection(range, chunkSelector2);
    logger(`wordsSelection: ${range.cloneRange().toString()}`, {
      shouldConsoleLog: true
    });
    return range;
  }
  var unwrapElement = (element3) => {
    element3?.querySelectorAll("mark").forEach((mark) => {
      mark.removeEventListener("mouseenter", handleMarkMouseenter);
      mark.removeEventListener("mouseleave", handleMarkMouseLeave);
    });
    if (element3) {
      element3.outerHTML = element3.innerHTML;
    }
  };
  var handleMarkMouseenter = (e) => {
    window.dispatchEvent(
      new CustomEvent("markMouseEnter", {
        detail: e.target
      })
    );
  };
  var handleMarkMouseLeave = (e) => {
    window.dispatchEvent(
      new CustomEvent("markMouseLeave", {
        detail: e.target
      })
    );
  };
  var closestTextChunk = (node, chunkSelector2 = "[data-text-chunk]") => {
    let el = node;
    if (!isHTMLElement(el) && el.parentElement) {
      el = el.parentElement;
    }
    if (!isHTMLElement(el)) {
      console.error(
        "Failed to match closest text chunk. Element is not an HTML element."
      );
      return null;
    }
    if (isHTMLElement(el) && el.getAttribute("data-text-chunk")) {
      return el;
    }
    const closest = el.closest(chunkSelector2);
    if (isHTMLElement(closest)) {
      return closest;
    }
    console.error(
      "Failed to match closest text chunk. There is no closest text chunk."
    );
    return null;
  };
  var safariHandleMutatedRange = (range) => {
    if (isSafari()) {
      const sel = document.getSelection();
      sel?.removeAllRanges();
      sel?.addRange(range);
    }
  };
  var surroundContentsWithMark = (range, attrs) => {
    const mark = document.createElement("mark");
    mark.addEventListener("mouseenter", handleMarkMouseenter);
    if (attrs) {
      attrs.forEach((value, key) => {
        mark.setAttribute(key, value);
      });
    }
    range.surroundContents(mark);
    safariHandleMutatedRange(range);
    mark.addEventListener("mouseleave", handleMarkMouseLeave);
    return [range, mark];
  };
  function highlight(range, attrs) {
    const marks = [];
    if (window.location.origin.endsWith(".paulgraham.com") && window.getSelection()?.toString().endsWith("\n")) {
      const [_, mark] = surroundContentsWithMark(range, attrs);
      marks.push(mark);
      return marks;
    }
    if (range.startOffset === 0 && range.endOffset === 0 && range.toString().trim() === range.startContainer.textContent?.trim()) {
      range.selectNodeContents(range.startContainer);
      const [_, mark] = surroundContentsWithMark(range, attrs);
      marks.push(mark);
      return marks;
    }
    if (isHTMLElement(range.commonAncestorContainer) && isTextChunk(range.commonAncestorContainer) && range.toString() === range.commonAncestorContainer.textContent) {
      range.selectNodeContents(range.commonAncestorContainer);
      const [_, mark] = surroundContentsWithMark(range, attrs);
      marks.push(mark);
      return marks;
    }
    if (range.startContainer === range.endContainer) {
      const [_, mark] = surroundContentsWithMark(range, attrs);
      marks.push(mark);
      return marks;
    }
    const ranges = [];
    const tw = document.createTreeWalker(range.commonAncestorContainer);
    let node = tw.currentNode;
    let startNodeFound = false;
    let startContainerFound = node === range.startContainer;
    while (node) {
      if (!startContainerFound) {
        node = tw.nextNode();
        startContainerFound = node === range.startContainer;
        continue;
      }
      if (node === range.endContainer) {
        const r = new Range();
        r.selectNode(node);
        r.setEnd(node, range.endOffset);
        ranges.push(r);
        break;
      }
      if (node.nodeName === "#text") {
        const r = new Range();
        r.selectNode(node);
        if (!startNodeFound) {
          startNodeFound = true;
          r.setStart(node, range.startOffset);
        }
        ranges.push(r);
      }
      node = tw.nextNode();
    }
    ranges.forEach((r) => {
      if (r.commonAncestorContainer.nodeName !== "MARK") {
        const [_, mark] = surroundContentsWithMark(r, attrs);
        marks.push(mark);
      }
    });
    return marks;
  }
  var eqTextsByNonWhitepsace = (a, b, regexModifications = "") => {
    const text3 = a.replaceAll(
      new RegExp(whiteSpace.source + regexModifications, whiteSpace.flags),
      " "
    );
    const annotationText = b.replaceAll(
      new RegExp(whiteSpace.source + regexModifications, whiteSpace.flags),
      " "
    );
    return text3 === annotationText;
  };

  // node_modules/nanoid/index.browser.js
  var nanoid = (size = 21) => crypto.getRandomValues(new Uint8Array(size)).reduce((id, byte) => {
    byte &= 63;
    if (byte < 36) {
      id += byte.toString(36);
    } else if (byte < 62) {
      id += (byte - 26).toString(36).toUpperCase();
    } else if (byte > 62) {
      id += "-";
    } else {
      id += "_";
    }
    return id;
  }, "");

  // node_modules/decode-named-character-reference/index.dom.js
  var element = document.createElement("i");
  function decodeNamedCharacterReference(value) {
    const characterReference2 = "&" + value + ";";
    element.innerHTML = characterReference2;
    const char = element.textContent;
    if (char.charCodeAt(char.length - 1) === 59 && value !== "semi") {
      return false;
    }
    return char === characterReference2 ? false : char;
  }

  // node_modules/micromark-util-chunked/index.js
  function splice(list3, start, remove, items) {
    const end = list3.length;
    let chunkStart = 0;
    let parameters;
    if (start < 0) {
      start = -start > end ? 0 : end + start;
    } else {
      start = start > end ? end : start;
    }
    remove = remove > 0 ? remove : 0;
    if (items.length < 1e4) {
      parameters = Array.from(items);
      parameters.unshift(start, remove);
      [].splice.apply(list3, parameters);
    } else {
      if (remove)
        [].splice.apply(list3, [start, remove]);
      while (chunkStart < items.length) {
        parameters = items.slice(chunkStart, chunkStart + 1e4);
        parameters.unshift(start, 0);
        [].splice.apply(list3, parameters);
        chunkStart += 1e4;
        start += 1e4;
      }
    }
  }
  function push(list3, items) {
    if (list3.length > 0) {
      splice(list3, list3.length, 0, items);
      return list3;
    }
    return items;
  }

  // node_modules/micromark-util-combine-extensions/index.js
  var hasOwnProperty = {}.hasOwnProperty;
  function combineExtensions(extensions) {
    const all = {};
    let index = -1;
    while (++index < extensions.length) {
      syntaxExtension(all, extensions[index]);
    }
    return all;
  }
  function syntaxExtension(all, extension) {
    let hook;
    for (hook in extension) {
      const maybe = hasOwnProperty.call(all, hook) ? all[hook] : void 0;
      const left = maybe || (all[hook] = {});
      const right = extension[hook];
      let code;
      for (code in right) {
        if (!hasOwnProperty.call(left, code))
          left[code] = [];
        const value = right[code];
        constructs(
          left[code],
          Array.isArray(value) ? value : value ? [value] : []
        );
      }
    }
  }
  function constructs(existing, list3) {
    let index = -1;
    const before = [];
    while (++index < list3.length) {
      ;
      (list3[index].add === "after" ? existing : before).push(list3[index]);
    }
    splice(existing, 0, 0, before);
  }
  function combineHtmlExtensions(htmlExtensions) {
    const handlers = {};
    let index = -1;
    while (++index < htmlExtensions.length) {
      htmlExtension(handlers, htmlExtensions[index]);
    }
    return handlers;
  }
  function htmlExtension(all, extension) {
    let hook;
    for (hook in extension) {
      const maybe = hasOwnProperty.call(all, hook) ? all[hook] : void 0;
      const left = maybe || (all[hook] = {});
      const right = extension[hook];
      let type;
      if (right) {
        for (type in right) {
          left[type] = right[type];
        }
      }
    }
  }

  // node_modules/micromark-util-decode-numeric-character-reference/index.js
  function decodeNumericCharacterReference(value, base) {
    const code = Number.parseInt(value, base);
    if (code < 9 || code === 11 || code > 13 && code < 32 || code > 126 && code < 160 || code > 55295 && code < 57344 || code > 64975 && code < 65008 || (code & 65535) === 65535 || (code & 65535) === 65534 || code > 1114111) {
      return "\uFFFD";
    }
    return String.fromCharCode(code);
  }

  // node_modules/micromark-util-encode/index.js
  var characterReferences = { '"': "quot", "&": "amp", "<": "lt", ">": "gt" };
  function encode(value) {
    return value.replace(/["&<>]/g, replace);
    function replace(value2) {
      return "&" + characterReferences[value2] + ";";
    }
  }

  // node_modules/micromark-util-normalize-identifier/index.js
  function normalizeIdentifier(value) {
    return value.replace(/[\t\n\r ]+/g, " ").replace(/^ | $/g, "").toLowerCase().toUpperCase();
  }

  // node_modules/micromark-util-character/lib/unicode-punctuation-regex.js
  var unicodePunctuationRegex = /[!-/:-@[-`{-~\u00A1\u00A7\u00AB\u00B6\u00B7\u00BB\u00BF\u037E\u0387\u055A-\u055F\u0589\u058A\u05BE\u05C0\u05C3\u05C6\u05F3\u05F4\u0609\u060A\u060C\u060D\u061B\u061E\u061F\u066A-\u066D\u06D4\u0700-\u070D\u07F7-\u07F9\u0830-\u083E\u085E\u0964\u0965\u0970\u09FD\u0A76\u0AF0\u0C77\u0C84\u0DF4\u0E4F\u0E5A\u0E5B\u0F04-\u0F12\u0F14\u0F3A-\u0F3D\u0F85\u0FD0-\u0FD4\u0FD9\u0FDA\u104A-\u104F\u10FB\u1360-\u1368\u1400\u166E\u169B\u169C\u16EB-\u16ED\u1735\u1736\u17D4-\u17D6\u17D8-\u17DA\u1800-\u180A\u1944\u1945\u1A1E\u1A1F\u1AA0-\u1AA6\u1AA8-\u1AAD\u1B5A-\u1B60\u1BFC-\u1BFF\u1C3B-\u1C3F\u1C7E\u1C7F\u1CC0-\u1CC7\u1CD3\u2010-\u2027\u2030-\u2043\u2045-\u2051\u2053-\u205E\u207D\u207E\u208D\u208E\u2308-\u230B\u2329\u232A\u2768-\u2775\u27C5\u27C6\u27E6-\u27EF\u2983-\u2998\u29D8-\u29DB\u29FC\u29FD\u2CF9-\u2CFC\u2CFE\u2CFF\u2D70\u2E00-\u2E2E\u2E30-\u2E4F\u2E52\u3001-\u3003\u3008-\u3011\u3014-\u301F\u3030\u303D\u30A0\u30FB\uA4FE\uA4FF\uA60D-\uA60F\uA673\uA67E\uA6F2-\uA6F7\uA874-\uA877\uA8CE\uA8CF\uA8F8-\uA8FA\uA8FC\uA92E\uA92F\uA95F\uA9C1-\uA9CD\uA9DE\uA9DF\uAA5C-\uAA5F\uAADE\uAADF\uAAF0\uAAF1\uABEB\uFD3E\uFD3F\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE61\uFE63\uFE68\uFE6A\uFE6B\uFF01-\uFF03\uFF05-\uFF0A\uFF0C-\uFF0F\uFF1A\uFF1B\uFF1F\uFF20\uFF3B-\uFF3D\uFF3F\uFF5B\uFF5D\uFF5F-\uFF65]/;

  // node_modules/micromark-util-character/index.js
  var asciiAlpha = regexCheck(/[A-Za-z]/);
  var asciiDigit = regexCheck(/\d/);
  var asciiHexDigit = regexCheck(/[\dA-Fa-f]/);
  var asciiAlphanumeric = regexCheck(/[\dA-Za-z]/);
  var asciiPunctuation = regexCheck(/[!-/:-@[-`{-~]/);
  var asciiAtext = regexCheck(/[#-'*+\--9=?A-Z^-~]/);
  function asciiControl(code) {
    return code !== null && (code < 32 || code === 127);
  }
  function markdownLineEndingOrSpace(code) {
    return code !== null && (code < 0 || code === 32);
  }
  function markdownLineEnding(code) {
    return code !== null && code < -2;
  }
  function markdownSpace(code) {
    return code === -2 || code === -1 || code === 32;
  }
  var unicodeWhitespace = regexCheck(/\s/);
  var unicodePunctuation = regexCheck(unicodePunctuationRegex);
  function regexCheck(regex) {
    return check;
    function check(code) {
      return code !== null && regex.test(String.fromCharCode(code));
    }
  }

  // node_modules/micromark-util-sanitize-uri/index.js
  function sanitizeUri(url, protocol) {
    const value = encode(normalizeUri(url || ""));
    if (!protocol) {
      return value;
    }
    const colon = value.indexOf(":");
    const questionMark = value.indexOf("?");
    const numberSign = value.indexOf("#");
    const slash = value.indexOf("/");
    if (colon < 0 || slash > -1 && colon > slash || questionMark > -1 && colon > questionMark || numberSign > -1 && colon > numberSign || protocol.test(value.slice(0, colon))) {
      return value;
    }
    return "";
  }
  function normalizeUri(value) {
    const result = [];
    let index = -1;
    let start = 0;
    let skip = 0;
    while (++index < value.length) {
      const code = value.charCodeAt(index);
      let replace = "";
      if (code === 37 && asciiAlphanumeric(value.charCodeAt(index + 1)) && asciiAlphanumeric(value.charCodeAt(index + 2))) {
        skip = 2;
      } else if (code < 128) {
        if (!/[!#$&-;=?-Z_a-z~]/.test(String.fromCharCode(code))) {
          replace = String.fromCharCode(code);
        }
      } else if (code > 55295 && code < 57344) {
        const next = value.charCodeAt(index + 1);
        if (code < 56320 && next > 56319 && next < 57344) {
          replace = String.fromCharCode(code, next);
          skip = 1;
        } else {
          replace = "\uFFFD";
        }
      } else {
        replace = String.fromCharCode(code);
      }
      if (replace) {
        result.push(value.slice(start, index), encodeURIComponent(replace));
        start = index + skip + 1;
        replace = "";
      }
      if (skip) {
        index += skip;
        skip = 0;
      }
    }
    return result.join("") + value.slice(start);
  }

  // node_modules/micromark/lib/compile.js
  var hasOwnProperty2 = {}.hasOwnProperty;
  var protocolHref = /^(https?|ircs?|mailto|xmpp)$/i;
  var protocolSrc = /^https?$/i;
  function compile(options = {}) {
    let tags = true;
    const definitions = {};
    const buffers = [[]];
    const mediaStack = [];
    const tightStack = [];
    const defaultHandlers = {
      enter: {
        blockQuote: onenterblockquote,
        codeFenced: onentercodefenced,
        codeFencedFenceInfo: buffer,
        codeFencedFenceMeta: buffer,
        codeIndented: onentercodeindented,
        codeText: onentercodetext,
        content: onentercontent,
        definition: onenterdefinition,
        definitionDestinationString: onenterdefinitiondestinationstring,
        definitionLabelString: buffer,
        definitionTitleString: buffer,
        emphasis: onenteremphasis,
        htmlFlow: onenterhtmlflow,
        htmlText: onenterhtml,
        image: onenterimage,
        label: buffer,
        link: onenterlink,
        listItemMarker: onenterlistitemmarker,
        listItemValue: onenterlistitemvalue,
        listOrdered: onenterlistordered,
        listUnordered: onenterlistunordered,
        paragraph: onenterparagraph,
        reference: buffer,
        resource: onenterresource,
        resourceDestinationString: onenterresourcedestinationstring,
        resourceTitleString: buffer,
        setextHeading: onentersetextheading,
        strong: onenterstrong
      },
      exit: {
        atxHeading: onexitatxheading,
        atxHeadingSequence: onexitatxheadingsequence,
        autolinkEmail: onexitautolinkemail,
        autolinkProtocol: onexitautolinkprotocol,
        blockQuote: onexitblockquote,
        characterEscapeValue: onexitdata,
        characterReferenceMarkerHexadecimal: onexitcharacterreferencemarker,
        characterReferenceMarkerNumeric: onexitcharacterreferencemarker,
        characterReferenceValue: onexitcharacterreferencevalue,
        codeFenced: onexitflowcode,
        codeFencedFence: onexitcodefencedfence,
        codeFencedFenceInfo: onexitcodefencedfenceinfo,
        codeFencedFenceMeta: resume,
        codeFlowValue: onexitcodeflowvalue,
        codeIndented: onexitflowcode,
        codeText: onexitcodetext,
        codeTextData: onexitdata,
        data: onexitdata,
        definition: onexitdefinition,
        definitionDestinationString: onexitdefinitiondestinationstring,
        definitionLabelString: onexitdefinitionlabelstring,
        definitionTitleString: onexitdefinitiontitlestring,
        emphasis: onexitemphasis,
        hardBreakEscape: onexithardbreak,
        hardBreakTrailing: onexithardbreak,
        htmlFlow: onexithtml,
        htmlFlowData: onexitdata,
        htmlText: onexithtml,
        htmlTextData: onexitdata,
        image: onexitmedia,
        label: onexitlabel,
        labelText: onexitlabeltext,
        lineEnding: onexitlineending,
        link: onexitmedia,
        listOrdered: onexitlistordered,
        listUnordered: onexitlistunordered,
        paragraph: onexitparagraph,
        reference: resume,
        referenceString: onexitreferencestring,
        resource: resume,
        resourceDestinationString: onexitresourcedestinationstring,
        resourceTitleString: onexitresourcetitlestring,
        setextHeading: onexitsetextheading,
        setextHeadingLineSequence: onexitsetextheadinglinesequence,
        setextHeadingText: onexitsetextheadingtext,
        strong: onexitstrong,
        thematicBreak: onexitthematicbreak
      }
    };
    const handlers = combineHtmlExtensions(
      [defaultHandlers].concat(options.htmlExtensions || [])
    );
    const data = {
      tightStack
    };
    const context = {
      lineEndingIfNeeded,
      options,
      encode: encode2,
      raw,
      tag,
      buffer,
      resume,
      setData,
      getData
    };
    let lineEndingStyle = options.defaultLineEnding;
    return compile2;
    function compile2(events) {
      let index = -1;
      let start = 0;
      const listStack = [];
      let head = [];
      let body = [];
      while (++index < events.length) {
        if (!lineEndingStyle && (events[index][1].type === "lineEnding" || events[index][1].type === "lineEndingBlank")) {
          lineEndingStyle = events[index][2].sliceSerialize(events[index][1]);
        }
        if (events[index][1].type === "listOrdered" || events[index][1].type === "listUnordered") {
          if (events[index][0] === "enter") {
            listStack.push(index);
          } else {
            prepareList(events.slice(listStack.pop(), index));
          }
        }
        if (events[index][1].type === "definition") {
          if (events[index][0] === "enter") {
            body = push(body, events.slice(start, index));
            start = index;
          } else {
            head = push(head, events.slice(start, index + 1));
            start = index + 1;
          }
        }
      }
      head = push(head, body);
      head = push(head, events.slice(start));
      index = -1;
      const result = head;
      if (handlers.enter.null) {
        handlers.enter.null.call(context);
      }
      while (++index < events.length) {
        const handler = handlers[result[index][0]];
        if (hasOwnProperty2.call(handler, result[index][1].type)) {
          handler[result[index][1].type].call(
            Object.assign(
              {
                sliceSerialize: result[index][2].sliceSerialize
              },
              context
            ),
            result[index][1]
          );
        }
      }
      if (handlers.exit.null) {
        handlers.exit.null.call(context);
      }
      return buffers[0].join("");
    }
    function prepareList(slice) {
      const length = slice.length;
      let index = 0;
      let containerBalance = 0;
      let loose = false;
      let atMarker;
      while (++index < length) {
        const event = slice[index];
        if (event[1]._container) {
          atMarker = void 0;
          if (event[0] === "enter") {
            containerBalance++;
          } else {
            containerBalance--;
          }
        } else
          switch (event[1].type) {
            case "listItemPrefix": {
              if (event[0] === "exit") {
                atMarker = true;
              }
              break;
            }
            case "linePrefix": {
              break;
            }
            case "lineEndingBlank": {
              if (event[0] === "enter" && !containerBalance) {
                if (atMarker) {
                  atMarker = void 0;
                } else {
                  loose = true;
                }
              }
              break;
            }
            default: {
              atMarker = void 0;
            }
          }
      }
      slice[0][1]._loose = loose;
    }
    function setData(key, value) {
      data[key] = value;
    }
    function getData(key) {
      return data[key];
    }
    function buffer() {
      buffers.push([]);
    }
    function resume() {
      const buf = buffers.pop();
      return buf.join("");
    }
    function tag(value) {
      if (!tags)
        return;
      setData("lastWasTag", true);
      buffers[buffers.length - 1].push(value);
    }
    function raw(value) {
      setData("lastWasTag");
      buffers[buffers.length - 1].push(value);
    }
    function lineEnding2() {
      raw(lineEndingStyle || "\n");
    }
    function lineEndingIfNeeded() {
      const buffer2 = buffers[buffers.length - 1];
      const slice = buffer2[buffer2.length - 1];
      const previous2 = slice ? slice.charCodeAt(slice.length - 1) : null;
      if (previous2 === 10 || previous2 === 13 || previous2 === null) {
        return;
      }
      lineEnding2();
    }
    function encode2(value) {
      return getData("ignoreEncode") ? value : encode(value);
    }
    function onenterlistordered(token) {
      tightStack.push(!token._loose);
      lineEndingIfNeeded();
      tag("<ol");
      setData("expectFirstItem", true);
    }
    function onenterlistunordered(token) {
      tightStack.push(!token._loose);
      lineEndingIfNeeded();
      tag("<ul");
      setData("expectFirstItem", true);
    }
    function onenterlistitemvalue(token) {
      if (getData("expectFirstItem")) {
        const value = Number.parseInt(this.sliceSerialize(token), 10);
        if (value !== 1) {
          tag(' start="' + encode2(String(value)) + '"');
        }
      }
    }
    function onenterlistitemmarker() {
      if (getData("expectFirstItem")) {
        tag(">");
      } else {
        onexitlistitem();
      }
      lineEndingIfNeeded();
      tag("<li>");
      setData("expectFirstItem");
      setData("lastWasTag");
    }
    function onexitlistordered() {
      onexitlistitem();
      tightStack.pop();
      lineEnding2();
      tag("</ol>");
    }
    function onexitlistunordered() {
      onexitlistitem();
      tightStack.pop();
      lineEnding2();
      tag("</ul>");
    }
    function onexitlistitem() {
      if (getData("lastWasTag") && !getData("slurpAllLineEndings")) {
        lineEndingIfNeeded();
      }
      tag("</li>");
      setData("slurpAllLineEndings");
    }
    function onenterblockquote() {
      tightStack.push(false);
      lineEndingIfNeeded();
      tag("<blockquote>");
    }
    function onexitblockquote() {
      tightStack.pop();
      lineEndingIfNeeded();
      tag("</blockquote>");
      setData("slurpAllLineEndings");
    }
    function onenterparagraph() {
      if (!tightStack[tightStack.length - 1]) {
        lineEndingIfNeeded();
        tag("<p>");
      }
      setData("slurpAllLineEndings");
    }
    function onexitparagraph() {
      if (tightStack[tightStack.length - 1]) {
        setData("slurpAllLineEndings", true);
      } else {
        tag("</p>");
      }
    }
    function onentercodefenced() {
      lineEndingIfNeeded();
      tag("<pre><code");
      setData("fencesCount", 0);
    }
    function onexitcodefencedfenceinfo() {
      const value = resume();
      tag(' class="language-' + value + '"');
    }
    function onexitcodefencedfence() {
      const count = getData("fencesCount") || 0;
      if (!count) {
        tag(">");
        setData("slurpOneLineEnding", true);
      }
      setData("fencesCount", count + 1);
    }
    function onentercodeindented() {
      lineEndingIfNeeded();
      tag("<pre><code>");
    }
    function onexitflowcode() {
      const count = getData("fencesCount");
      if (count !== void 0 && count < 2 && data.tightStack.length > 0 && !getData("lastWasTag")) {
        lineEnding2();
      }
      if (getData("flowCodeSeenData")) {
        lineEndingIfNeeded();
      }
      tag("</code></pre>");
      if (count !== void 0 && count < 2)
        lineEndingIfNeeded();
      setData("flowCodeSeenData");
      setData("fencesCount");
      setData("slurpOneLineEnding");
    }
    function onenterimage() {
      mediaStack.push({
        image: true
      });
      tags = void 0;
    }
    function onenterlink() {
      mediaStack.push({});
    }
    function onexitlabeltext(token) {
      mediaStack[mediaStack.length - 1].labelId = this.sliceSerialize(token);
    }
    function onexitlabel() {
      mediaStack[mediaStack.length - 1].label = resume();
    }
    function onexitreferencestring(token) {
      mediaStack[mediaStack.length - 1].referenceId = this.sliceSerialize(token);
    }
    function onenterresource() {
      buffer();
      mediaStack[mediaStack.length - 1].destination = "";
    }
    function onenterresourcedestinationstring() {
      buffer();
      setData("ignoreEncode", true);
    }
    function onexitresourcedestinationstring() {
      mediaStack[mediaStack.length - 1].destination = resume();
      setData("ignoreEncode");
    }
    function onexitresourcetitlestring() {
      mediaStack[mediaStack.length - 1].title = resume();
    }
    function onexitmedia() {
      let index = mediaStack.length - 1;
      const media = mediaStack[index];
      const id = media.referenceId || media.labelId;
      const context2 = media.destination === void 0 ? definitions[normalizeIdentifier(id)] : media;
      tags = true;
      while (index--) {
        if (mediaStack[index].image) {
          tags = void 0;
          break;
        }
      }
      if (media.image) {
        tag(
          '<img src="' + sanitizeUri(
            context2.destination,
            options.allowDangerousProtocol ? void 0 : protocolSrc
          ) + '" alt="'
        );
        raw(media.label);
        tag('"');
      } else {
        tag(
          '<a href="' + sanitizeUri(
            context2.destination,
            options.allowDangerousProtocol ? void 0 : protocolHref
          ) + '"'
        );
      }
      tag(context2.title ? ' title="' + context2.title + '"' : "");
      if (media.image) {
        tag(" />");
      } else {
        tag(">");
        raw(media.label);
        tag("</a>");
      }
      mediaStack.pop();
    }
    function onenterdefinition() {
      buffer();
      mediaStack.push({});
    }
    function onexitdefinitionlabelstring(token) {
      resume();
      mediaStack[mediaStack.length - 1].labelId = this.sliceSerialize(token);
    }
    function onenterdefinitiondestinationstring() {
      buffer();
      setData("ignoreEncode", true);
    }
    function onexitdefinitiondestinationstring() {
      mediaStack[mediaStack.length - 1].destination = resume();
      setData("ignoreEncode");
    }
    function onexitdefinitiontitlestring() {
      mediaStack[mediaStack.length - 1].title = resume();
    }
    function onexitdefinition() {
      const media = mediaStack[mediaStack.length - 1];
      const id = normalizeIdentifier(media.labelId);
      resume();
      if (!hasOwnProperty2.call(definitions, id)) {
        definitions[id] = mediaStack[mediaStack.length - 1];
      }
      mediaStack.pop();
    }
    function onentercontent() {
      setData("slurpAllLineEndings", true);
    }
    function onexitatxheadingsequence(token) {
      if (getData("headingRank"))
        return;
      setData("headingRank", this.sliceSerialize(token).length);
      lineEndingIfNeeded();
      tag("<h" + getData("headingRank") + ">");
    }
    function onentersetextheading() {
      buffer();
      setData("slurpAllLineEndings");
    }
    function onexitsetextheadingtext() {
      setData("slurpAllLineEndings", true);
    }
    function onexitatxheading() {
      tag("</h" + getData("headingRank") + ">");
      setData("headingRank");
    }
    function onexitsetextheadinglinesequence(token) {
      setData(
        "headingRank",
        this.sliceSerialize(token).charCodeAt(0) === 61 ? 1 : 2
      );
    }
    function onexitsetextheading() {
      const value = resume();
      lineEndingIfNeeded();
      tag("<h" + getData("headingRank") + ">");
      raw(value);
      tag("</h" + getData("headingRank") + ">");
      setData("slurpAllLineEndings");
      setData("headingRank");
    }
    function onexitdata(token) {
      raw(encode2(this.sliceSerialize(token)));
    }
    function onexitlineending(token) {
      if (getData("slurpAllLineEndings")) {
        return;
      }
      if (getData("slurpOneLineEnding")) {
        setData("slurpOneLineEnding");
        return;
      }
      if (getData("inCodeText")) {
        raw(" ");
        return;
      }
      raw(encode2(this.sliceSerialize(token)));
    }
    function onexitcodeflowvalue(token) {
      raw(encode2(this.sliceSerialize(token)));
      setData("flowCodeSeenData", true);
    }
    function onexithardbreak() {
      tag("<br />");
    }
    function onenterhtmlflow() {
      lineEndingIfNeeded();
      onenterhtml();
    }
    function onexithtml() {
      setData("ignoreEncode");
    }
    function onenterhtml() {
      if (options.allowDangerousHtml) {
        setData("ignoreEncode", true);
      }
    }
    function onenteremphasis() {
      tag("<em>");
    }
    function onenterstrong() {
      tag("<strong>");
    }
    function onentercodetext() {
      setData("inCodeText", true);
      tag("<code>");
    }
    function onexitcodetext() {
      setData("inCodeText");
      tag("</code>");
    }
    function onexitemphasis() {
      tag("</em>");
    }
    function onexitstrong() {
      tag("</strong>");
    }
    function onexitthematicbreak() {
      lineEndingIfNeeded();
      tag("<hr />");
    }
    function onexitcharacterreferencemarker(token) {
      setData("characterReferenceType", token.type);
    }
    function onexitcharacterreferencevalue(token) {
      let value = this.sliceSerialize(token);
      value = getData("characterReferenceType") ? decodeNumericCharacterReference(
        value,
        getData("characterReferenceType") === "characterReferenceMarkerNumeric" ? 10 : 16
      ) : decodeNamedCharacterReference(value);
      raw(encode2(value));
      setData("characterReferenceType");
    }
    function onexitautolinkprotocol(token) {
      const uri = this.sliceSerialize(token);
      tag(
        '<a href="' + sanitizeUri(
          uri,
          options.allowDangerousProtocol ? void 0 : protocolHref
        ) + '">'
      );
      raw(encode2(uri));
      tag("</a>");
    }
    function onexitautolinkemail(token) {
      const uri = this.sliceSerialize(token);
      tag('<a href="' + sanitizeUri("mailto:" + uri) + '">');
      raw(encode2(uri));
      tag("</a>");
    }
  }

  // node_modules/micromark-factory-space/index.js
  function factorySpace(effects, ok, type, max) {
    const limit = max ? max - 1 : Number.POSITIVE_INFINITY;
    let size = 0;
    return start;
    function start(code) {
      if (markdownSpace(code)) {
        effects.enter(type);
        return prefix(code);
      }
      return ok(code);
    }
    function prefix(code) {
      if (markdownSpace(code) && size++ < limit) {
        effects.consume(code);
        return prefix;
      }
      effects.exit(type);
      return ok(code);
    }
  }

  // node_modules/micromark/lib/initialize/content.js
  var content = {
    tokenize: initializeContent
  };
  function initializeContent(effects) {
    const contentStart = effects.attempt(
      this.parser.constructs.contentInitial,
      afterContentStartConstruct,
      paragraphInitial
    );
    let previous2;
    return contentStart;
    function afterContentStartConstruct(code) {
      if (code === null) {
        effects.consume(code);
        return;
      }
      effects.enter("lineEnding");
      effects.consume(code);
      effects.exit("lineEnding");
      return factorySpace(effects, contentStart, "linePrefix");
    }
    function paragraphInitial(code) {
      effects.enter("paragraph");
      return lineStart(code);
    }
    function lineStart(code) {
      const token = effects.enter("chunkText", {
        contentType: "text",
        previous: previous2
      });
      if (previous2) {
        previous2.next = token;
      }
      previous2 = token;
      return data(code);
    }
    function data(code) {
      if (code === null) {
        effects.exit("chunkText");
        effects.exit("paragraph");
        effects.consume(code);
        return;
      }
      if (markdownLineEnding(code)) {
        effects.consume(code);
        effects.exit("chunkText");
        return lineStart;
      }
      effects.consume(code);
      return data;
    }
  }

  // node_modules/micromark/lib/initialize/document.js
  var document2 = {
    tokenize: initializeDocument
  };
  var containerConstruct = {
    tokenize: tokenizeContainer
  };
  function initializeDocument(effects) {
    const self2 = this;
    const stack = [];
    let continued = 0;
    let childFlow;
    let childToken;
    let lineStartOffset;
    return start;
    function start(code) {
      if (continued < stack.length) {
        const item = stack[continued];
        self2.containerState = item[1];
        return effects.attempt(
          item[0].continuation,
          documentContinue,
          checkNewContainers
        )(code);
      }
      return checkNewContainers(code);
    }
    function documentContinue(code) {
      continued++;
      if (self2.containerState._closeFlow) {
        self2.containerState._closeFlow = void 0;
        if (childFlow) {
          closeFlow();
        }
        const indexBeforeExits = self2.events.length;
        let indexBeforeFlow = indexBeforeExits;
        let point;
        while (indexBeforeFlow--) {
          if (self2.events[indexBeforeFlow][0] === "exit" && self2.events[indexBeforeFlow][1].type === "chunkFlow") {
            point = self2.events[indexBeforeFlow][1].end;
            break;
          }
        }
        exitContainers(continued);
        let index = indexBeforeExits;
        while (index < self2.events.length) {
          self2.events[index][1].end = Object.assign({}, point);
          index++;
        }
        splice(
          self2.events,
          indexBeforeFlow + 1,
          0,
          self2.events.slice(indexBeforeExits)
        );
        self2.events.length = index;
        return checkNewContainers(code);
      }
      return start(code);
    }
    function checkNewContainers(code) {
      if (continued === stack.length) {
        if (!childFlow) {
          return documentContinued(code);
        }
        if (childFlow.currentConstruct && childFlow.currentConstruct.concrete) {
          return flowStart(code);
        }
        self2.interrupt = Boolean(
          childFlow.currentConstruct && !childFlow._gfmTableDynamicInterruptHack
        );
      }
      self2.containerState = {};
      return effects.check(
        containerConstruct,
        thereIsANewContainer,
        thereIsNoNewContainer
      )(code);
    }
    function thereIsANewContainer(code) {
      if (childFlow)
        closeFlow();
      exitContainers(continued);
      return documentContinued(code);
    }
    function thereIsNoNewContainer(code) {
      self2.parser.lazy[self2.now().line] = continued !== stack.length;
      lineStartOffset = self2.now().offset;
      return flowStart(code);
    }
    function documentContinued(code) {
      self2.containerState = {};
      return effects.attempt(
        containerConstruct,
        containerContinue,
        flowStart
      )(code);
    }
    function containerContinue(code) {
      continued++;
      stack.push([self2.currentConstruct, self2.containerState]);
      return documentContinued(code);
    }
    function flowStart(code) {
      if (code === null) {
        if (childFlow)
          closeFlow();
        exitContainers(0);
        effects.consume(code);
        return;
      }
      childFlow = childFlow || self2.parser.flow(self2.now());
      effects.enter("chunkFlow", {
        contentType: "flow",
        previous: childToken,
        _tokenizer: childFlow
      });
      return flowContinue(code);
    }
    function flowContinue(code) {
      if (code === null) {
        writeToChild(effects.exit("chunkFlow"), true);
        exitContainers(0);
        effects.consume(code);
        return;
      }
      if (markdownLineEnding(code)) {
        effects.consume(code);
        writeToChild(effects.exit("chunkFlow"));
        continued = 0;
        self2.interrupt = void 0;
        return start;
      }
      effects.consume(code);
      return flowContinue;
    }
    function writeToChild(token, eof) {
      const stream = self2.sliceStream(token);
      if (eof)
        stream.push(null);
      token.previous = childToken;
      if (childToken)
        childToken.next = token;
      childToken = token;
      childFlow.defineSkip(token.start);
      childFlow.write(stream);
      if (self2.parser.lazy[token.start.line]) {
        let index = childFlow.events.length;
        while (index--) {
          if (childFlow.events[index][1].start.offset < lineStartOffset && (!childFlow.events[index][1].end || childFlow.events[index][1].end.offset > lineStartOffset)) {
            return;
          }
        }
        const indexBeforeExits = self2.events.length;
        let indexBeforeFlow = indexBeforeExits;
        let seen;
        let point;
        while (indexBeforeFlow--) {
          if (self2.events[indexBeforeFlow][0] === "exit" && self2.events[indexBeforeFlow][1].type === "chunkFlow") {
            if (seen) {
              point = self2.events[indexBeforeFlow][1].end;
              break;
            }
            seen = true;
          }
        }
        exitContainers(continued);
        index = indexBeforeExits;
        while (index < self2.events.length) {
          self2.events[index][1].end = Object.assign({}, point);
          index++;
        }
        splice(
          self2.events,
          indexBeforeFlow + 1,
          0,
          self2.events.slice(indexBeforeExits)
        );
        self2.events.length = index;
      }
    }
    function exitContainers(size) {
      let index = stack.length;
      while (index-- > size) {
        const entry = stack[index];
        self2.containerState = entry[1];
        entry[0].exit.call(self2, effects);
      }
      stack.length = size;
    }
    function closeFlow() {
      childFlow.write([null]);
      childToken = void 0;
      childFlow = void 0;
      self2.containerState._closeFlow = void 0;
    }
  }
  function tokenizeContainer(effects, ok, nok) {
    return factorySpace(
      effects,
      effects.attempt(this.parser.constructs.document, ok, nok),
      "linePrefix",
      this.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
    );
  }

  // node_modules/micromark-util-classify-character/index.js
  function classifyCharacter(code) {
    if (code === null || markdownLineEndingOrSpace(code) || unicodeWhitespace(code)) {
      return 1;
    }
    if (unicodePunctuation(code)) {
      return 2;
    }
  }

  // node_modules/micromark-util-resolve-all/index.js
  function resolveAll(constructs2, events, context) {
    const called = [];
    let index = -1;
    while (++index < constructs2.length) {
      const resolve = constructs2[index].resolveAll;
      if (resolve && !called.includes(resolve)) {
        events = resolve(events, context);
        called.push(resolve);
      }
    }
    return events;
  }

  // node_modules/micromark-core-commonmark/lib/attention.js
  var attention = {
    name: "attention",
    tokenize: tokenizeAttention,
    resolveAll: resolveAllAttention
  };
  function resolveAllAttention(events, context) {
    let index = -1;
    let open;
    let group;
    let text3;
    let openingSequence;
    let closingSequence;
    let use;
    let nextEvents;
    let offset;
    while (++index < events.length) {
      if (events[index][0] === "enter" && events[index][1].type === "attentionSequence" && events[index][1]._close) {
        open = index;
        while (open--) {
          if (events[open][0] === "exit" && events[open][1].type === "attentionSequence" && events[open][1]._open && context.sliceSerialize(events[open][1]).charCodeAt(0) === context.sliceSerialize(events[index][1]).charCodeAt(0)) {
            if ((events[open][1]._close || events[index][1]._open) && (events[index][1].end.offset - events[index][1].start.offset) % 3 && !((events[open][1].end.offset - events[open][1].start.offset + events[index][1].end.offset - events[index][1].start.offset) % 3)) {
              continue;
            }
            use = events[open][1].end.offset - events[open][1].start.offset > 1 && events[index][1].end.offset - events[index][1].start.offset > 1 ? 2 : 1;
            const start = Object.assign({}, events[open][1].end);
            const end = Object.assign({}, events[index][1].start);
            movePoint(start, -use);
            movePoint(end, use);
            openingSequence = {
              type: use > 1 ? "strongSequence" : "emphasisSequence",
              start,
              end: Object.assign({}, events[open][1].end)
            };
            closingSequence = {
              type: use > 1 ? "strongSequence" : "emphasisSequence",
              start: Object.assign({}, events[index][1].start),
              end
            };
            text3 = {
              type: use > 1 ? "strongText" : "emphasisText",
              start: Object.assign({}, events[open][1].end),
              end: Object.assign({}, events[index][1].start)
            };
            group = {
              type: use > 1 ? "strong" : "emphasis",
              start: Object.assign({}, openingSequence.start),
              end: Object.assign({}, closingSequence.end)
            };
            events[open][1].end = Object.assign({}, openingSequence.start);
            events[index][1].start = Object.assign({}, closingSequence.end);
            nextEvents = [];
            if (events[open][1].end.offset - events[open][1].start.offset) {
              nextEvents = push(nextEvents, [
                ["enter", events[open][1], context],
                ["exit", events[open][1], context]
              ]);
            }
            nextEvents = push(nextEvents, [
              ["enter", group, context],
              ["enter", openingSequence, context],
              ["exit", openingSequence, context],
              ["enter", text3, context]
            ]);
            nextEvents = push(
              nextEvents,
              resolveAll(
                context.parser.constructs.insideSpan.null,
                events.slice(open + 1, index),
                context
              )
            );
            nextEvents = push(nextEvents, [
              ["exit", text3, context],
              ["enter", closingSequence, context],
              ["exit", closingSequence, context],
              ["exit", group, context]
            ]);
            if (events[index][1].end.offset - events[index][1].start.offset) {
              offset = 2;
              nextEvents = push(nextEvents, [
                ["enter", events[index][1], context],
                ["exit", events[index][1], context]
              ]);
            } else {
              offset = 0;
            }
            splice(events, open - 1, index - open + 3, nextEvents);
            index = open + nextEvents.length - offset - 2;
            break;
          }
        }
      }
    }
    index = -1;
    while (++index < events.length) {
      if (events[index][1].type === "attentionSequence") {
        events[index][1].type = "data";
      }
    }
    return events;
  }
  function tokenizeAttention(effects, ok) {
    const attentionMarkers2 = this.parser.constructs.attentionMarkers.null;
    const previous2 = this.previous;
    const before = classifyCharacter(previous2);
    let marker;
    return start;
    function start(code) {
      effects.enter("attentionSequence");
      marker = code;
      return sequence(code);
    }
    function sequence(code) {
      if (code === marker) {
        effects.consume(code);
        return sequence;
      }
      const token = effects.exit("attentionSequence");
      const after = classifyCharacter(code);
      const open = !after || after === 2 && before || attentionMarkers2.includes(code);
      const close = !before || before === 2 && after || attentionMarkers2.includes(previous2);
      token._open = Boolean(marker === 42 ? open : open && (before || !close));
      token._close = Boolean(marker === 42 ? close : close && (after || !open));
      return ok(code);
    }
  }
  function movePoint(point, offset) {
    point.column += offset;
    point.offset += offset;
    point._bufferIndex += offset;
  }

  // node_modules/micromark-core-commonmark/lib/autolink.js
  var autolink = {
    name: "autolink",
    tokenize: tokenizeAutolink
  };
  function tokenizeAutolink(effects, ok, nok) {
    let size = 1;
    return start;
    function start(code) {
      effects.enter("autolink");
      effects.enter("autolinkMarker");
      effects.consume(code);
      effects.exit("autolinkMarker");
      effects.enter("autolinkProtocol");
      return open;
    }
    function open(code) {
      if (asciiAlpha(code)) {
        effects.consume(code);
        return schemeOrEmailAtext;
      }
      return asciiAtext(code) ? emailAtext(code) : nok(code);
    }
    function schemeOrEmailAtext(code) {
      return code === 43 || code === 45 || code === 46 || asciiAlphanumeric(code) ? schemeInsideOrEmailAtext(code) : emailAtext(code);
    }
    function schemeInsideOrEmailAtext(code) {
      if (code === 58) {
        effects.consume(code);
        return urlInside;
      }
      if ((code === 43 || code === 45 || code === 46 || asciiAlphanumeric(code)) && size++ < 32) {
        effects.consume(code);
        return schemeInsideOrEmailAtext;
      }
      return emailAtext(code);
    }
    function urlInside(code) {
      if (code === 62) {
        effects.exit("autolinkProtocol");
        return end(code);
      }
      if (code === null || code === 32 || code === 60 || asciiControl(code)) {
        return nok(code);
      }
      effects.consume(code);
      return urlInside;
    }
    function emailAtext(code) {
      if (code === 64) {
        effects.consume(code);
        size = 0;
        return emailAtSignOrDot;
      }
      if (asciiAtext(code)) {
        effects.consume(code);
        return emailAtext;
      }
      return nok(code);
    }
    function emailAtSignOrDot(code) {
      return asciiAlphanumeric(code) ? emailLabel(code) : nok(code);
    }
    function emailLabel(code) {
      if (code === 46) {
        effects.consume(code);
        size = 0;
        return emailAtSignOrDot;
      }
      if (code === 62) {
        effects.exit("autolinkProtocol").type = "autolinkEmail";
        return end(code);
      }
      return emailValue(code);
    }
    function emailValue(code) {
      if ((code === 45 || asciiAlphanumeric(code)) && size++ < 63) {
        effects.consume(code);
        return code === 45 ? emailValue : emailLabel;
      }
      return nok(code);
    }
    function end(code) {
      effects.enter("autolinkMarker");
      effects.consume(code);
      effects.exit("autolinkMarker");
      effects.exit("autolink");
      return ok;
    }
  }

  // node_modules/micromark-core-commonmark/lib/blank-line.js
  var blankLine = {
    tokenize: tokenizeBlankLine,
    partial: true
  };
  function tokenizeBlankLine(effects, ok, nok) {
    return factorySpace(effects, afterWhitespace, "linePrefix");
    function afterWhitespace(code) {
      return code === null || markdownLineEnding(code) ? ok(code) : nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/block-quote.js
  var blockQuote = {
    name: "blockQuote",
    tokenize: tokenizeBlockQuoteStart,
    continuation: {
      tokenize: tokenizeBlockQuoteContinuation
    },
    exit
  };
  function tokenizeBlockQuoteStart(effects, ok, nok) {
    const self2 = this;
    return start;
    function start(code) {
      if (code === 62) {
        const state = self2.containerState;
        if (!state.open) {
          effects.enter("blockQuote", {
            _container: true
          });
          state.open = true;
        }
        effects.enter("blockQuotePrefix");
        effects.enter("blockQuoteMarker");
        effects.consume(code);
        effects.exit("blockQuoteMarker");
        return after;
      }
      return nok(code);
    }
    function after(code) {
      if (markdownSpace(code)) {
        effects.enter("blockQuotePrefixWhitespace");
        effects.consume(code);
        effects.exit("blockQuotePrefixWhitespace");
        effects.exit("blockQuotePrefix");
        return ok;
      }
      effects.exit("blockQuotePrefix");
      return ok(code);
    }
  }
  function tokenizeBlockQuoteContinuation(effects, ok, nok) {
    return factorySpace(
      effects,
      effects.attempt(blockQuote, ok, nok),
      "linePrefix",
      this.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
    );
  }
  function exit(effects) {
    effects.exit("blockQuote");
  }

  // node_modules/micromark-core-commonmark/lib/character-escape.js
  var characterEscape = {
    name: "characterEscape",
    tokenize: tokenizeCharacterEscape
  };
  function tokenizeCharacterEscape(effects, ok, nok) {
    return start;
    function start(code) {
      effects.enter("characterEscape");
      effects.enter("escapeMarker");
      effects.consume(code);
      effects.exit("escapeMarker");
      return open;
    }
    function open(code) {
      if (asciiPunctuation(code)) {
        effects.enter("characterEscapeValue");
        effects.consume(code);
        effects.exit("characterEscapeValue");
        effects.exit("characterEscape");
        return ok;
      }
      return nok(code);
    }
  }

  // node_modules/parse-entities/lib/decode-entity.browser.js
  var element2 = document.createElement("i");
  function decodeEntity(value) {
    const characterReference2 = "&" + value + ";";
    element2.innerHTML = characterReference2;
    const char = element2.textContent;
    if (char.charCodeAt(char.length - 1) === 59 && value !== "semi") {
      return false;
    }
    return char === characterReference2 ? false : char;
  }

  // node_modules/micromark-core-commonmark/lib/character-reference.js
  var characterReference = {
    name: "characterReference",
    tokenize: tokenizeCharacterReference
  };
  function tokenizeCharacterReference(effects, ok, nok) {
    const self2 = this;
    let size = 0;
    let max;
    let test;
    return start;
    function start(code) {
      effects.enter("characterReference");
      effects.enter("characterReferenceMarker");
      effects.consume(code);
      effects.exit("characterReferenceMarker");
      return open;
    }
    function open(code) {
      if (code === 35) {
        effects.enter("characterReferenceMarkerNumeric");
        effects.consume(code);
        effects.exit("characterReferenceMarkerNumeric");
        return numeric;
      }
      effects.enter("characterReferenceValue");
      max = 31;
      test = asciiAlphanumeric;
      return value(code);
    }
    function numeric(code) {
      if (code === 88 || code === 120) {
        effects.enter("characterReferenceMarkerHexadecimal");
        effects.consume(code);
        effects.exit("characterReferenceMarkerHexadecimal");
        effects.enter("characterReferenceValue");
        max = 6;
        test = asciiHexDigit;
        return value;
      }
      effects.enter("characterReferenceValue");
      max = 7;
      test = asciiDigit;
      return value(code);
    }
    function value(code) {
      let token;
      if (code === 59 && size) {
        token = effects.exit("characterReferenceValue");
        if (test === asciiAlphanumeric && !decodeEntity(self2.sliceSerialize(token))) {
          return nok(code);
        }
        effects.enter("characterReferenceMarker");
        effects.consume(code);
        effects.exit("characterReferenceMarker");
        effects.exit("characterReference");
        return ok;
      }
      if (test(code) && size++ < max) {
        effects.consume(code);
        return value;
      }
      return nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/code-fenced.js
  var codeFenced = {
    name: "codeFenced",
    tokenize: tokenizeCodeFenced,
    concrete: true
  };
  function tokenizeCodeFenced(effects, ok, nok) {
    const self2 = this;
    const closingFenceConstruct = {
      tokenize: tokenizeClosingFence,
      partial: true
    };
    const nonLazyLine = {
      tokenize: tokenizeNonLazyLine,
      partial: true
    };
    const tail = this.events[this.events.length - 1];
    const initialPrefix = tail && tail[1].type === "linePrefix" ? tail[2].sliceSerialize(tail[1], true).length : 0;
    let sizeOpen = 0;
    let marker;
    return start;
    function start(code) {
      effects.enter("codeFenced");
      effects.enter("codeFencedFence");
      effects.enter("codeFencedFenceSequence");
      marker = code;
      return sequenceOpen(code);
    }
    function sequenceOpen(code) {
      if (code === marker) {
        effects.consume(code);
        sizeOpen++;
        return sequenceOpen;
      }
      effects.exit("codeFencedFenceSequence");
      return sizeOpen < 3 ? nok(code) : factorySpace(effects, infoOpen, "whitespace")(code);
    }
    function infoOpen(code) {
      if (code === null || markdownLineEnding(code)) {
        return openAfter(code);
      }
      effects.enter("codeFencedFenceInfo");
      effects.enter("chunkString", {
        contentType: "string"
      });
      return info(code);
    }
    function info(code) {
      if (code === null || markdownLineEndingOrSpace(code)) {
        effects.exit("chunkString");
        effects.exit("codeFencedFenceInfo");
        return factorySpace(effects, infoAfter, "whitespace")(code);
      }
      if (code === 96 && code === marker)
        return nok(code);
      effects.consume(code);
      return info;
    }
    function infoAfter(code) {
      if (code === null || markdownLineEnding(code)) {
        return openAfter(code);
      }
      effects.enter("codeFencedFenceMeta");
      effects.enter("chunkString", {
        contentType: "string"
      });
      return meta(code);
    }
    function meta(code) {
      if (code === null || markdownLineEnding(code)) {
        effects.exit("chunkString");
        effects.exit("codeFencedFenceMeta");
        return openAfter(code);
      }
      if (code === 96 && code === marker)
        return nok(code);
      effects.consume(code);
      return meta;
    }
    function openAfter(code) {
      effects.exit("codeFencedFence");
      return self2.interrupt ? ok(code) : contentStart(code);
    }
    function contentStart(code) {
      if (code === null) {
        return after(code);
      }
      if (markdownLineEnding(code)) {
        return effects.attempt(
          nonLazyLine,
          effects.attempt(
            closingFenceConstruct,
            after,
            initialPrefix ? factorySpace(
              effects,
              contentStart,
              "linePrefix",
              initialPrefix + 1
            ) : contentStart
          ),
          after
        )(code);
      }
      effects.enter("codeFlowValue");
      return contentContinue(code);
    }
    function contentContinue(code) {
      if (code === null || markdownLineEnding(code)) {
        effects.exit("codeFlowValue");
        return contentStart(code);
      }
      effects.consume(code);
      return contentContinue;
    }
    function after(code) {
      effects.exit("codeFenced");
      return ok(code);
    }
    function tokenizeNonLazyLine(effects2, ok2, nok2) {
      const self3 = this;
      return start2;
      function start2(code) {
        effects2.enter("lineEnding");
        effects2.consume(code);
        effects2.exit("lineEnding");
        return lineStart;
      }
      function lineStart(code) {
        return self3.parser.lazy[self3.now().line] ? nok2(code) : ok2(code);
      }
    }
    function tokenizeClosingFence(effects2, ok2, nok2) {
      let size = 0;
      return factorySpace(
        effects2,
        closingSequenceStart,
        "linePrefix",
        this.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
      );
      function closingSequenceStart(code) {
        effects2.enter("codeFencedFence");
        effects2.enter("codeFencedFenceSequence");
        return closingSequence(code);
      }
      function closingSequence(code) {
        if (code === marker) {
          effects2.consume(code);
          size++;
          return closingSequence;
        }
        if (size < sizeOpen)
          return nok2(code);
        effects2.exit("codeFencedFenceSequence");
        return factorySpace(effects2, closingSequenceEnd, "whitespace")(code);
      }
      function closingSequenceEnd(code) {
        if (code === null || markdownLineEnding(code)) {
          effects2.exit("codeFencedFence");
          return ok2(code);
        }
        return nok2(code);
      }
    }
  }

  // node_modules/micromark-core-commonmark/lib/code-indented.js
  var codeIndented = {
    name: "codeIndented",
    tokenize: tokenizeCodeIndented
  };
  var indentedContent = {
    tokenize: tokenizeIndentedContent,
    partial: true
  };
  function tokenizeCodeIndented(effects, ok, nok) {
    const self2 = this;
    return start;
    function start(code) {
      effects.enter("codeIndented");
      return factorySpace(effects, afterStartPrefix, "linePrefix", 4 + 1)(code);
    }
    function afterStartPrefix(code) {
      const tail = self2.events[self2.events.length - 1];
      return tail && tail[1].type === "linePrefix" && tail[2].sliceSerialize(tail[1], true).length >= 4 ? afterPrefix(code) : nok(code);
    }
    function afterPrefix(code) {
      if (code === null) {
        return after(code);
      }
      if (markdownLineEnding(code)) {
        return effects.attempt(indentedContent, afterPrefix, after)(code);
      }
      effects.enter("codeFlowValue");
      return content3(code);
    }
    function content3(code) {
      if (code === null || markdownLineEnding(code)) {
        effects.exit("codeFlowValue");
        return afterPrefix(code);
      }
      effects.consume(code);
      return content3;
    }
    function after(code) {
      effects.exit("codeIndented");
      return ok(code);
    }
  }
  function tokenizeIndentedContent(effects, ok, nok) {
    const self2 = this;
    return start;
    function start(code) {
      if (self2.parser.lazy[self2.now().line]) {
        return nok(code);
      }
      if (markdownLineEnding(code)) {
        effects.enter("lineEnding");
        effects.consume(code);
        effects.exit("lineEnding");
        return start;
      }
      return factorySpace(effects, afterPrefix, "linePrefix", 4 + 1)(code);
    }
    function afterPrefix(code) {
      const tail = self2.events[self2.events.length - 1];
      return tail && tail[1].type === "linePrefix" && tail[2].sliceSerialize(tail[1], true).length >= 4 ? ok(code) : markdownLineEnding(code) ? start(code) : nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/code-text.js
  var codeText = {
    name: "codeText",
    tokenize: tokenizeCodeText,
    resolve: resolveCodeText,
    previous
  };
  function resolveCodeText(events) {
    let tailExitIndex = events.length - 4;
    let headEnterIndex = 3;
    let index;
    let enter;
    if ((events[headEnterIndex][1].type === "lineEnding" || events[headEnterIndex][1].type === "space") && (events[tailExitIndex][1].type === "lineEnding" || events[tailExitIndex][1].type === "space")) {
      index = headEnterIndex;
      while (++index < tailExitIndex) {
        if (events[index][1].type === "codeTextData") {
          events[headEnterIndex][1].type = "codeTextPadding";
          events[tailExitIndex][1].type = "codeTextPadding";
          headEnterIndex += 2;
          tailExitIndex -= 2;
          break;
        }
      }
    }
    index = headEnterIndex - 1;
    tailExitIndex++;
    while (++index <= tailExitIndex) {
      if (enter === void 0) {
        if (index !== tailExitIndex && events[index][1].type !== "lineEnding") {
          enter = index;
        }
      } else if (index === tailExitIndex || events[index][1].type === "lineEnding") {
        events[enter][1].type = "codeTextData";
        if (index !== enter + 2) {
          events[enter][1].end = events[index - 1][1].end;
          events.splice(enter + 2, index - enter - 2);
          tailExitIndex -= index - enter - 2;
          index = enter + 2;
        }
        enter = void 0;
      }
    }
    return events;
  }
  function previous(code) {
    return code !== 96 || this.events[this.events.length - 1][1].type === "characterEscape";
  }
  function tokenizeCodeText(effects, ok, nok) {
    const self2 = this;
    let sizeOpen = 0;
    let size;
    let token;
    return start;
    function start(code) {
      effects.enter("codeText");
      effects.enter("codeTextSequence");
      return openingSequence(code);
    }
    function openingSequence(code) {
      if (code === 96) {
        effects.consume(code);
        sizeOpen++;
        return openingSequence;
      }
      effects.exit("codeTextSequence");
      return gap(code);
    }
    function gap(code) {
      if (code === null) {
        return nok(code);
      }
      if (code === 96) {
        token = effects.enter("codeTextSequence");
        size = 0;
        return closingSequence(code);
      }
      if (code === 32) {
        effects.enter("space");
        effects.consume(code);
        effects.exit("space");
        return gap;
      }
      if (markdownLineEnding(code)) {
        effects.enter("lineEnding");
        effects.consume(code);
        effects.exit("lineEnding");
        return gap;
      }
      effects.enter("codeTextData");
      return data(code);
    }
    function data(code) {
      if (code === null || code === 32 || code === 96 || markdownLineEnding(code)) {
        effects.exit("codeTextData");
        return gap(code);
      }
      effects.consume(code);
      return data;
    }
    function closingSequence(code) {
      if (code === 96) {
        effects.consume(code);
        size++;
        return closingSequence;
      }
      if (size === sizeOpen) {
        effects.exit("codeTextSequence");
        effects.exit("codeText");
        return ok(code);
      }
      token.type = "codeTextData";
      return data(code);
    }
  }

  // node_modules/micromark-util-subtokenize/index.js
  function subtokenize(events) {
    const jumps = {};
    let index = -1;
    let event;
    let lineIndex;
    let otherIndex;
    let otherEvent;
    let parameters;
    let subevents;
    let more;
    while (++index < events.length) {
      while (index in jumps) {
        index = jumps[index];
      }
      event = events[index];
      if (index && event[1].type === "chunkFlow" && events[index - 1][1].type === "listItemPrefix") {
        subevents = event[1]._tokenizer.events;
        otherIndex = 0;
        if (otherIndex < subevents.length && subevents[otherIndex][1].type === "lineEndingBlank") {
          otherIndex += 2;
        }
        if (otherIndex < subevents.length && subevents[otherIndex][1].type === "content") {
          while (++otherIndex < subevents.length) {
            if (subevents[otherIndex][1].type === "content") {
              break;
            }
            if (subevents[otherIndex][1].type === "chunkText") {
              subevents[otherIndex][1]._isInFirstContentOfListItem = true;
              otherIndex++;
            }
          }
        }
      }
      if (event[0] === "enter") {
        if (event[1].contentType) {
          Object.assign(jumps, subcontent(events, index));
          index = jumps[index];
          more = true;
        }
      } else if (event[1]._container) {
        otherIndex = index;
        lineIndex = void 0;
        while (otherIndex--) {
          otherEvent = events[otherIndex];
          if (otherEvent[1].type === "lineEnding" || otherEvent[1].type === "lineEndingBlank") {
            if (otherEvent[0] === "enter") {
              if (lineIndex) {
                events[lineIndex][1].type = "lineEndingBlank";
              }
              otherEvent[1].type = "lineEnding";
              lineIndex = otherIndex;
            }
          } else {
            break;
          }
        }
        if (lineIndex) {
          event[1].end = Object.assign({}, events[lineIndex][1].start);
          parameters = events.slice(lineIndex, index);
          parameters.unshift(event);
          splice(events, lineIndex, index - lineIndex + 1, parameters);
        }
      }
    }
    return !more;
  }
  function subcontent(events, eventIndex) {
    const token = events[eventIndex][1];
    const context = events[eventIndex][2];
    let startPosition = eventIndex - 1;
    const startPositions = [];
    const tokenizer = token._tokenizer || context.parser[token.contentType](token.start);
    const childEvents = tokenizer.events;
    const jumps = [];
    const gaps = {};
    let stream;
    let previous2;
    let index = -1;
    let current = token;
    let adjust = 0;
    let start = 0;
    const breaks = [start];
    while (current) {
      while (events[++startPosition][1] !== current) {
      }
      startPositions.push(startPosition);
      if (!current._tokenizer) {
        stream = context.sliceStream(current);
        if (!current.next) {
          stream.push(null);
        }
        if (previous2) {
          tokenizer.defineSkip(current.start);
        }
        if (current._isInFirstContentOfListItem) {
          tokenizer._gfmTasklistFirstContentOfListItem = true;
        }
        tokenizer.write(stream);
        if (current._isInFirstContentOfListItem) {
          tokenizer._gfmTasklistFirstContentOfListItem = void 0;
        }
      }
      previous2 = current;
      current = current.next;
    }
    current = token;
    while (++index < childEvents.length) {
      if (childEvents[index][0] === "exit" && childEvents[index - 1][0] === "enter" && childEvents[index][1].type === childEvents[index - 1][1].type && childEvents[index][1].start.line !== childEvents[index][1].end.line) {
        start = index + 1;
        breaks.push(start);
        current._tokenizer = void 0;
        current.previous = void 0;
        current = current.next;
      }
    }
    tokenizer.events = [];
    if (current) {
      current._tokenizer = void 0;
      current.previous = void 0;
    } else {
      breaks.pop();
    }
    index = breaks.length;
    while (index--) {
      const slice = childEvents.slice(breaks[index], breaks[index + 1]);
      const start2 = startPositions.pop();
      jumps.unshift([start2, start2 + slice.length - 1]);
      splice(events, start2, 2, slice);
    }
    index = -1;
    while (++index < jumps.length) {
      gaps[adjust + jumps[index][0]] = adjust + jumps[index][1];
      adjust += jumps[index][1] - jumps[index][0] - 1;
    }
    return gaps;
  }

  // node_modules/micromark-core-commonmark/lib/content.js
  var content2 = {
    tokenize: tokenizeContent,
    resolve: resolveContent
  };
  var continuationConstruct = {
    tokenize: tokenizeContinuation,
    partial: true
  };
  function resolveContent(events) {
    subtokenize(events);
    return events;
  }
  function tokenizeContent(effects, ok) {
    let previous2;
    return start;
    function start(code) {
      effects.enter("content");
      previous2 = effects.enter("chunkContent", {
        contentType: "content"
      });
      return data(code);
    }
    function data(code) {
      if (code === null) {
        return contentEnd(code);
      }
      if (markdownLineEnding(code)) {
        return effects.check(
          continuationConstruct,
          contentContinue,
          contentEnd
        )(code);
      }
      effects.consume(code);
      return data;
    }
    function contentEnd(code) {
      effects.exit("chunkContent");
      effects.exit("content");
      return ok(code);
    }
    function contentContinue(code) {
      effects.consume(code);
      effects.exit("chunkContent");
      previous2.next = effects.enter("chunkContent", {
        contentType: "content",
        previous: previous2
      });
      previous2 = previous2.next;
      return data;
    }
  }
  function tokenizeContinuation(effects, ok, nok) {
    const self2 = this;
    return startLookahead;
    function startLookahead(code) {
      effects.exit("chunkContent");
      effects.enter("lineEnding");
      effects.consume(code);
      effects.exit("lineEnding");
      return factorySpace(effects, prefixed, "linePrefix");
    }
    function prefixed(code) {
      if (code === null || markdownLineEnding(code)) {
        return nok(code);
      }
      const tail = self2.events[self2.events.length - 1];
      if (!self2.parser.constructs.disable.null.includes("codeIndented") && tail && tail[1].type === "linePrefix" && tail[2].sliceSerialize(tail[1], true).length >= 4) {
        return ok(code);
      }
      return effects.interrupt(self2.parser.constructs.flow, nok, ok)(code);
    }
  }

  // node_modules/micromark-factory-destination/index.js
  function factoryDestination(effects, ok, nok, type, literalType, literalMarkerType, rawType, stringType, max) {
    const limit = max || Number.POSITIVE_INFINITY;
    let balance = 0;
    return start;
    function start(code) {
      if (code === 60) {
        effects.enter(type);
        effects.enter(literalType);
        effects.enter(literalMarkerType);
        effects.consume(code);
        effects.exit(literalMarkerType);
        return destinationEnclosedBefore;
      }
      if (code === null || code === 41 || asciiControl(code)) {
        return nok(code);
      }
      effects.enter(type);
      effects.enter(rawType);
      effects.enter(stringType);
      effects.enter("chunkString", {
        contentType: "string"
      });
      return destinationRaw(code);
    }
    function destinationEnclosedBefore(code) {
      if (code === 62) {
        effects.enter(literalMarkerType);
        effects.consume(code);
        effects.exit(literalMarkerType);
        effects.exit(literalType);
        effects.exit(type);
        return ok;
      }
      effects.enter(stringType);
      effects.enter("chunkString", {
        contentType: "string"
      });
      return destinationEnclosed(code);
    }
    function destinationEnclosed(code) {
      if (code === 62) {
        effects.exit("chunkString");
        effects.exit(stringType);
        return destinationEnclosedBefore(code);
      }
      if (code === null || code === 60 || markdownLineEnding(code)) {
        return nok(code);
      }
      effects.consume(code);
      return code === 92 ? destinationEnclosedEscape : destinationEnclosed;
    }
    function destinationEnclosedEscape(code) {
      if (code === 60 || code === 62 || code === 92) {
        effects.consume(code);
        return destinationEnclosed;
      }
      return destinationEnclosed(code);
    }
    function destinationRaw(code) {
      if (code === 40) {
        if (++balance > limit)
          return nok(code);
        effects.consume(code);
        return destinationRaw;
      }
      if (code === 41) {
        if (!balance--) {
          effects.exit("chunkString");
          effects.exit(stringType);
          effects.exit(rawType);
          effects.exit(type);
          return ok(code);
        }
        effects.consume(code);
        return destinationRaw;
      }
      if (code === null || markdownLineEndingOrSpace(code)) {
        if (balance)
          return nok(code);
        effects.exit("chunkString");
        effects.exit(stringType);
        effects.exit(rawType);
        effects.exit(type);
        return ok(code);
      }
      if (asciiControl(code))
        return nok(code);
      effects.consume(code);
      return code === 92 ? destinationRawEscape : destinationRaw;
    }
    function destinationRawEscape(code) {
      if (code === 40 || code === 41 || code === 92) {
        effects.consume(code);
        return destinationRaw;
      }
      return destinationRaw(code);
    }
  }

  // node_modules/micromark-factory-label/index.js
  function factoryLabel(effects, ok, nok, type, markerType, stringType) {
    const self2 = this;
    let size = 0;
    let data;
    return start;
    function start(code) {
      effects.enter(type);
      effects.enter(markerType);
      effects.consume(code);
      effects.exit(markerType);
      effects.enter(stringType);
      return atBreak;
    }
    function atBreak(code) {
      if (code === null || code === 91 || code === 93 && !data || code === 94 && !size && "_hiddenFootnoteSupport" in self2.parser.constructs || size > 999) {
        return nok(code);
      }
      if (code === 93) {
        effects.exit(stringType);
        effects.enter(markerType);
        effects.consume(code);
        effects.exit(markerType);
        effects.exit(type);
        return ok;
      }
      if (markdownLineEnding(code)) {
        effects.enter("lineEnding");
        effects.consume(code);
        effects.exit("lineEnding");
        return atBreak;
      }
      effects.enter("chunkString", {
        contentType: "string"
      });
      return label(code);
    }
    function label(code) {
      if (code === null || code === 91 || code === 93 || markdownLineEnding(code) || size++ > 999) {
        effects.exit("chunkString");
        return atBreak(code);
      }
      effects.consume(code);
      data = data || !markdownSpace(code);
      return code === 92 ? labelEscape : label;
    }
    function labelEscape(code) {
      if (code === 91 || code === 92 || code === 93) {
        effects.consume(code);
        size++;
        return label;
      }
      return label(code);
    }
  }

  // node_modules/micromark-factory-title/index.js
  function factoryTitle(effects, ok, nok, type, markerType, stringType) {
    let marker;
    return start;
    function start(code) {
      effects.enter(type);
      effects.enter(markerType);
      effects.consume(code);
      effects.exit(markerType);
      marker = code === 40 ? 41 : code;
      return atFirstTitleBreak;
    }
    function atFirstTitleBreak(code) {
      if (code === marker) {
        effects.enter(markerType);
        effects.consume(code);
        effects.exit(markerType);
        effects.exit(type);
        return ok;
      }
      effects.enter(stringType);
      return atTitleBreak(code);
    }
    function atTitleBreak(code) {
      if (code === marker) {
        effects.exit(stringType);
        return atFirstTitleBreak(marker);
      }
      if (code === null) {
        return nok(code);
      }
      if (markdownLineEnding(code)) {
        effects.enter("lineEnding");
        effects.consume(code);
        effects.exit("lineEnding");
        return factorySpace(effects, atTitleBreak, "linePrefix");
      }
      effects.enter("chunkString", {
        contentType: "string"
      });
      return title(code);
    }
    function title(code) {
      if (code === marker || code === null || markdownLineEnding(code)) {
        effects.exit("chunkString");
        return atTitleBreak(code);
      }
      effects.consume(code);
      return code === 92 ? titleEscape : title;
    }
    function titleEscape(code) {
      if (code === marker || code === 92) {
        effects.consume(code);
        return title;
      }
      return title(code);
    }
  }

  // node_modules/micromark-factory-whitespace/index.js
  function factoryWhitespace(effects, ok) {
    let seen;
    return start;
    function start(code) {
      if (markdownLineEnding(code)) {
        effects.enter("lineEnding");
        effects.consume(code);
        effects.exit("lineEnding");
        seen = true;
        return start;
      }
      if (markdownSpace(code)) {
        return factorySpace(
          effects,
          start,
          seen ? "linePrefix" : "lineSuffix"
        )(code);
      }
      return ok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/definition.js
  var definition = {
    name: "definition",
    tokenize: tokenizeDefinition
  };
  var titleConstruct = {
    tokenize: tokenizeTitle,
    partial: true
  };
  function tokenizeDefinition(effects, ok, nok) {
    const self2 = this;
    let identifier;
    return start;
    function start(code) {
      effects.enter("definition");
      return factoryLabel.call(
        self2,
        effects,
        labelAfter,
        nok,
        "definitionLabel",
        "definitionLabelMarker",
        "definitionLabelString"
      )(code);
    }
    function labelAfter(code) {
      identifier = normalizeIdentifier(
        self2.sliceSerialize(self2.events[self2.events.length - 1][1]).slice(1, -1)
      );
      if (code === 58) {
        effects.enter("definitionMarker");
        effects.consume(code);
        effects.exit("definitionMarker");
        return factoryWhitespace(
          effects,
          factoryDestination(
            effects,
            effects.attempt(
              titleConstruct,
              factorySpace(effects, after, "whitespace"),
              factorySpace(effects, after, "whitespace")
            ),
            nok,
            "definitionDestination",
            "definitionDestinationLiteral",
            "definitionDestinationLiteralMarker",
            "definitionDestinationRaw",
            "definitionDestinationString"
          )
        );
      }
      return nok(code);
    }
    function after(code) {
      if (code === null || markdownLineEnding(code)) {
        effects.exit("definition");
        if (!self2.parser.defined.includes(identifier)) {
          self2.parser.defined.push(identifier);
        }
        return ok(code);
      }
      return nok(code);
    }
  }
  function tokenizeTitle(effects, ok, nok) {
    return start;
    function start(code) {
      return markdownLineEndingOrSpace(code) ? factoryWhitespace(effects, before)(code) : nok(code);
    }
    function before(code) {
      if (code === 34 || code === 39 || code === 40) {
        return factoryTitle(
          effects,
          factorySpace(effects, after, "whitespace"),
          nok,
          "definitionTitle",
          "definitionTitleMarker",
          "definitionTitleString"
        )(code);
      }
      return nok(code);
    }
    function after(code) {
      return code === null || markdownLineEnding(code) ? ok(code) : nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/hard-break-escape.js
  var hardBreakEscape = {
    name: "hardBreakEscape",
    tokenize: tokenizeHardBreakEscape
  };
  function tokenizeHardBreakEscape(effects, ok, nok) {
    return start;
    function start(code) {
      effects.enter("hardBreakEscape");
      effects.enter("escapeMarker");
      effects.consume(code);
      return open;
    }
    function open(code) {
      if (markdownLineEnding(code)) {
        effects.exit("escapeMarker");
        effects.exit("hardBreakEscape");
        return ok(code);
      }
      return nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/heading-atx.js
  var headingAtx = {
    name: "headingAtx",
    tokenize: tokenizeHeadingAtx,
    resolve: resolveHeadingAtx
  };
  function resolveHeadingAtx(events, context) {
    let contentEnd = events.length - 2;
    let contentStart = 3;
    let content3;
    let text3;
    if (events[contentStart][1].type === "whitespace") {
      contentStart += 2;
    }
    if (contentEnd - 2 > contentStart && events[contentEnd][1].type === "whitespace") {
      contentEnd -= 2;
    }
    if (events[contentEnd][1].type === "atxHeadingSequence" && (contentStart === contentEnd - 1 || contentEnd - 4 > contentStart && events[contentEnd - 2][1].type === "whitespace")) {
      contentEnd -= contentStart + 1 === contentEnd ? 2 : 4;
    }
    if (contentEnd > contentStart) {
      content3 = {
        type: "atxHeadingText",
        start: events[contentStart][1].start,
        end: events[contentEnd][1].end
      };
      text3 = {
        type: "chunkText",
        start: events[contentStart][1].start,
        end: events[contentEnd][1].end,
        contentType: "text"
      };
      splice(events, contentStart, contentEnd - contentStart + 1, [
        ["enter", content3, context],
        ["enter", text3, context],
        ["exit", text3, context],
        ["exit", content3, context]
      ]);
    }
    return events;
  }
  function tokenizeHeadingAtx(effects, ok, nok) {
    const self2 = this;
    let size = 0;
    return start;
    function start(code) {
      effects.enter("atxHeading");
      effects.enter("atxHeadingSequence");
      return fenceOpenInside(code);
    }
    function fenceOpenInside(code) {
      if (code === 35 && size++ < 6) {
        effects.consume(code);
        return fenceOpenInside;
      }
      if (code === null || markdownLineEndingOrSpace(code)) {
        effects.exit("atxHeadingSequence");
        return self2.interrupt ? ok(code) : headingBreak(code);
      }
      return nok(code);
    }
    function headingBreak(code) {
      if (code === 35) {
        effects.enter("atxHeadingSequence");
        return sequence(code);
      }
      if (code === null || markdownLineEnding(code)) {
        effects.exit("atxHeading");
        return ok(code);
      }
      if (markdownSpace(code)) {
        return factorySpace(effects, headingBreak, "whitespace")(code);
      }
      effects.enter("atxHeadingText");
      return data(code);
    }
    function sequence(code) {
      if (code === 35) {
        effects.consume(code);
        return sequence;
      }
      effects.exit("atxHeadingSequence");
      return headingBreak(code);
    }
    function data(code) {
      if (code === null || code === 35 || markdownLineEndingOrSpace(code)) {
        effects.exit("atxHeadingText");
        return headingBreak(code);
      }
      effects.consume(code);
      return data;
    }
  }

  // node_modules/micromark-util-html-tag-name/index.js
  var htmlBlockNames = [
    "address",
    "article",
    "aside",
    "base",
    "basefont",
    "blockquote",
    "body",
    "caption",
    "center",
    "col",
    "colgroup",
    "dd",
    "details",
    "dialog",
    "dir",
    "div",
    "dl",
    "dt",
    "fieldset",
    "figcaption",
    "figure",
    "footer",
    "form",
    "frame",
    "frameset",
    "h1",
    "h2",
    "h3",
    "h4",
    "h5",
    "h6",
    "head",
    "header",
    "hr",
    "html",
    "iframe",
    "legend",
    "li",
    "link",
    "main",
    "menu",
    "menuitem",
    "nav",
    "noframes",
    "ol",
    "optgroup",
    "option",
    "p",
    "param",
    "section",
    "source",
    "summary",
    "table",
    "tbody",
    "td",
    "tfoot",
    "th",
    "thead",
    "title",
    "tr",
    "track",
    "ul"
  ];
  var htmlRawNames = ["pre", "script", "style", "textarea"];

  // node_modules/micromark-core-commonmark/lib/html-flow.js
  var htmlFlow = {
    name: "htmlFlow",
    tokenize: tokenizeHtmlFlow,
    resolveTo: resolveToHtmlFlow,
    concrete: true
  };
  var nextBlankConstruct = {
    tokenize: tokenizeNextBlank,
    partial: true
  };
  function resolveToHtmlFlow(events) {
    let index = events.length;
    while (index--) {
      if (events[index][0] === "enter" && events[index][1].type === "htmlFlow") {
        break;
      }
    }
    if (index > 1 && events[index - 2][1].type === "linePrefix") {
      events[index][1].start = events[index - 2][1].start;
      events[index + 1][1].start = events[index - 2][1].start;
      events.splice(index - 2, 2);
    }
    return events;
  }
  function tokenizeHtmlFlow(effects, ok, nok) {
    const self2 = this;
    let kind;
    let startTag;
    let buffer;
    let index;
    let marker;
    return start;
    function start(code) {
      effects.enter("htmlFlow");
      effects.enter("htmlFlowData");
      effects.consume(code);
      return open;
    }
    function open(code) {
      if (code === 33) {
        effects.consume(code);
        return declarationStart;
      }
      if (code === 47) {
        effects.consume(code);
        return tagCloseStart;
      }
      if (code === 63) {
        effects.consume(code);
        kind = 3;
        return self2.interrupt ? ok : continuationDeclarationInside;
      }
      if (asciiAlpha(code)) {
        effects.consume(code);
        buffer = String.fromCharCode(code);
        startTag = true;
        return tagName;
      }
      return nok(code);
    }
    function declarationStart(code) {
      if (code === 45) {
        effects.consume(code);
        kind = 2;
        return commentOpenInside;
      }
      if (code === 91) {
        effects.consume(code);
        kind = 5;
        buffer = "CDATA[";
        index = 0;
        return cdataOpenInside;
      }
      if (asciiAlpha(code)) {
        effects.consume(code);
        kind = 4;
        return self2.interrupt ? ok : continuationDeclarationInside;
      }
      return nok(code);
    }
    function commentOpenInside(code) {
      if (code === 45) {
        effects.consume(code);
        return self2.interrupt ? ok : continuationDeclarationInside;
      }
      return nok(code);
    }
    function cdataOpenInside(code) {
      if (code === buffer.charCodeAt(index++)) {
        effects.consume(code);
        return index === buffer.length ? self2.interrupt ? ok : continuation : cdataOpenInside;
      }
      return nok(code);
    }
    function tagCloseStart(code) {
      if (asciiAlpha(code)) {
        effects.consume(code);
        buffer = String.fromCharCode(code);
        return tagName;
      }
      return nok(code);
    }
    function tagName(code) {
      if (code === null || code === 47 || code === 62 || markdownLineEndingOrSpace(code)) {
        if (code !== 47 && startTag && htmlRawNames.includes(buffer.toLowerCase())) {
          kind = 1;
          return self2.interrupt ? ok(code) : continuation(code);
        }
        if (htmlBlockNames.includes(buffer.toLowerCase())) {
          kind = 6;
          if (code === 47) {
            effects.consume(code);
            return basicSelfClosing;
          }
          return self2.interrupt ? ok(code) : continuation(code);
        }
        kind = 7;
        return self2.interrupt && !self2.parser.lazy[self2.now().line] ? nok(code) : startTag ? completeAttributeNameBefore(code) : completeClosingTagAfter(code);
      }
      if (code === 45 || asciiAlphanumeric(code)) {
        effects.consume(code);
        buffer += String.fromCharCode(code);
        return tagName;
      }
      return nok(code);
    }
    function basicSelfClosing(code) {
      if (code === 62) {
        effects.consume(code);
        return self2.interrupt ? ok : continuation;
      }
      return nok(code);
    }
    function completeClosingTagAfter(code) {
      if (markdownSpace(code)) {
        effects.consume(code);
        return completeClosingTagAfter;
      }
      return completeEnd(code);
    }
    function completeAttributeNameBefore(code) {
      if (code === 47) {
        effects.consume(code);
        return completeEnd;
      }
      if (code === 58 || code === 95 || asciiAlpha(code)) {
        effects.consume(code);
        return completeAttributeName;
      }
      if (markdownSpace(code)) {
        effects.consume(code);
        return completeAttributeNameBefore;
      }
      return completeEnd(code);
    }
    function completeAttributeName(code) {
      if (code === 45 || code === 46 || code === 58 || code === 95 || asciiAlphanumeric(code)) {
        effects.consume(code);
        return completeAttributeName;
      }
      return completeAttributeNameAfter(code);
    }
    function completeAttributeNameAfter(code) {
      if (code === 61) {
        effects.consume(code);
        return completeAttributeValueBefore;
      }
      if (markdownSpace(code)) {
        effects.consume(code);
        return completeAttributeNameAfter;
      }
      return completeAttributeNameBefore(code);
    }
    function completeAttributeValueBefore(code) {
      if (code === null || code === 60 || code === 61 || code === 62 || code === 96) {
        return nok(code);
      }
      if (code === 34 || code === 39) {
        effects.consume(code);
        marker = code;
        return completeAttributeValueQuoted;
      }
      if (markdownSpace(code)) {
        effects.consume(code);
        return completeAttributeValueBefore;
      }
      marker = null;
      return completeAttributeValueUnquoted(code);
    }
    function completeAttributeValueQuoted(code) {
      if (code === null || markdownLineEnding(code)) {
        return nok(code);
      }
      if (code === marker) {
        effects.consume(code);
        return completeAttributeValueQuotedAfter;
      }
      effects.consume(code);
      return completeAttributeValueQuoted;
    }
    function completeAttributeValueUnquoted(code) {
      if (code === null || code === 34 || code === 39 || code === 60 || code === 61 || code === 62 || code === 96 || markdownLineEndingOrSpace(code)) {
        return completeAttributeNameAfter(code);
      }
      effects.consume(code);
      return completeAttributeValueUnquoted;
    }
    function completeAttributeValueQuotedAfter(code) {
      if (code === 47 || code === 62 || markdownSpace(code)) {
        return completeAttributeNameBefore(code);
      }
      return nok(code);
    }
    function completeEnd(code) {
      if (code === 62) {
        effects.consume(code);
        return completeAfter;
      }
      return nok(code);
    }
    function completeAfter(code) {
      if (markdownSpace(code)) {
        effects.consume(code);
        return completeAfter;
      }
      return code === null || markdownLineEnding(code) ? continuation(code) : nok(code);
    }
    function continuation(code) {
      if (code === 45 && kind === 2) {
        effects.consume(code);
        return continuationCommentInside;
      }
      if (code === 60 && kind === 1) {
        effects.consume(code);
        return continuationRawTagOpen;
      }
      if (code === 62 && kind === 4) {
        effects.consume(code);
        return continuationClose;
      }
      if (code === 63 && kind === 3) {
        effects.consume(code);
        return continuationDeclarationInside;
      }
      if (code === 93 && kind === 5) {
        effects.consume(code);
        return continuationCharacterDataInside;
      }
      if (markdownLineEnding(code) && (kind === 6 || kind === 7)) {
        return effects.check(
          nextBlankConstruct,
          continuationClose,
          continuationAtLineEnding
        )(code);
      }
      if (code === null || markdownLineEnding(code)) {
        return continuationAtLineEnding(code);
      }
      effects.consume(code);
      return continuation;
    }
    function continuationAtLineEnding(code) {
      effects.exit("htmlFlowData");
      return htmlContinueStart(code);
    }
    function htmlContinueStart(code) {
      if (code === null) {
        return done(code);
      }
      if (markdownLineEnding(code)) {
        return effects.attempt(
          {
            tokenize: htmlLineEnd,
            partial: true
          },
          htmlContinueStart,
          done
        )(code);
      }
      effects.enter("htmlFlowData");
      return continuation(code);
    }
    function htmlLineEnd(effects2, ok2, nok2) {
      return start2;
      function start2(code) {
        effects2.enter("lineEnding");
        effects2.consume(code);
        effects2.exit("lineEnding");
        return lineStart;
      }
      function lineStart(code) {
        return self2.parser.lazy[self2.now().line] ? nok2(code) : ok2(code);
      }
    }
    function continuationCommentInside(code) {
      if (code === 45) {
        effects.consume(code);
        return continuationDeclarationInside;
      }
      return continuation(code);
    }
    function continuationRawTagOpen(code) {
      if (code === 47) {
        effects.consume(code);
        buffer = "";
        return continuationRawEndTag;
      }
      return continuation(code);
    }
    function continuationRawEndTag(code) {
      if (code === 62 && htmlRawNames.includes(buffer.toLowerCase())) {
        effects.consume(code);
        return continuationClose;
      }
      if (asciiAlpha(code) && buffer.length < 8) {
        effects.consume(code);
        buffer += String.fromCharCode(code);
        return continuationRawEndTag;
      }
      return continuation(code);
    }
    function continuationCharacterDataInside(code) {
      if (code === 93) {
        effects.consume(code);
        return continuationDeclarationInside;
      }
      return continuation(code);
    }
    function continuationDeclarationInside(code) {
      if (code === 62) {
        effects.consume(code);
        return continuationClose;
      }
      if (code === 45 && kind === 2) {
        effects.consume(code);
        return continuationDeclarationInside;
      }
      return continuation(code);
    }
    function continuationClose(code) {
      if (code === null || markdownLineEnding(code)) {
        effects.exit("htmlFlowData");
        return done(code);
      }
      effects.consume(code);
      return continuationClose;
    }
    function done(code) {
      effects.exit("htmlFlow");
      return ok(code);
    }
  }
  function tokenizeNextBlank(effects, ok, nok) {
    return start;
    function start(code) {
      effects.exit("htmlFlowData");
      effects.enter("lineEndingBlank");
      effects.consume(code);
      effects.exit("lineEndingBlank");
      return effects.attempt(blankLine, ok, nok);
    }
  }

  // node_modules/micromark-core-commonmark/lib/html-text.js
  var htmlText = {
    name: "htmlText",
    tokenize: tokenizeHtmlText
  };
  function tokenizeHtmlText(effects, ok, nok) {
    const self2 = this;
    let marker;
    let buffer;
    let index;
    let returnState;
    return start;
    function start(code) {
      effects.enter("htmlText");
      effects.enter("htmlTextData");
      effects.consume(code);
      return open;
    }
    function open(code) {
      if (code === 33) {
        effects.consume(code);
        return declarationOpen;
      }
      if (code === 47) {
        effects.consume(code);
        return tagCloseStart;
      }
      if (code === 63) {
        effects.consume(code);
        return instruction;
      }
      if (asciiAlpha(code)) {
        effects.consume(code);
        return tagOpen;
      }
      return nok(code);
    }
    function declarationOpen(code) {
      if (code === 45) {
        effects.consume(code);
        return commentOpen;
      }
      if (code === 91) {
        effects.consume(code);
        buffer = "CDATA[";
        index = 0;
        return cdataOpen;
      }
      if (asciiAlpha(code)) {
        effects.consume(code);
        return declaration;
      }
      return nok(code);
    }
    function commentOpen(code) {
      if (code === 45) {
        effects.consume(code);
        return commentStart;
      }
      return nok(code);
    }
    function commentStart(code) {
      if (code === null || code === 62) {
        return nok(code);
      }
      if (code === 45) {
        effects.consume(code);
        return commentStartDash;
      }
      return comment(code);
    }
    function commentStartDash(code) {
      if (code === null || code === 62) {
        return nok(code);
      }
      return comment(code);
    }
    function comment(code) {
      if (code === null) {
        return nok(code);
      }
      if (code === 45) {
        effects.consume(code);
        return commentClose;
      }
      if (markdownLineEnding(code)) {
        returnState = comment;
        return atLineEnding(code);
      }
      effects.consume(code);
      return comment;
    }
    function commentClose(code) {
      if (code === 45) {
        effects.consume(code);
        return end;
      }
      return comment(code);
    }
    function cdataOpen(code) {
      if (code === buffer.charCodeAt(index++)) {
        effects.consume(code);
        return index === buffer.length ? cdata : cdataOpen;
      }
      return nok(code);
    }
    function cdata(code) {
      if (code === null) {
        return nok(code);
      }
      if (code === 93) {
        effects.consume(code);
        return cdataClose;
      }
      if (markdownLineEnding(code)) {
        returnState = cdata;
        return atLineEnding(code);
      }
      effects.consume(code);
      return cdata;
    }
    function cdataClose(code) {
      if (code === 93) {
        effects.consume(code);
        return cdataEnd;
      }
      return cdata(code);
    }
    function cdataEnd(code) {
      if (code === 62) {
        return end(code);
      }
      if (code === 93) {
        effects.consume(code);
        return cdataEnd;
      }
      return cdata(code);
    }
    function declaration(code) {
      if (code === null || code === 62) {
        return end(code);
      }
      if (markdownLineEnding(code)) {
        returnState = declaration;
        return atLineEnding(code);
      }
      effects.consume(code);
      return declaration;
    }
    function instruction(code) {
      if (code === null) {
        return nok(code);
      }
      if (code === 63) {
        effects.consume(code);
        return instructionClose;
      }
      if (markdownLineEnding(code)) {
        returnState = instruction;
        return atLineEnding(code);
      }
      effects.consume(code);
      return instruction;
    }
    function instructionClose(code) {
      return code === 62 ? end(code) : instruction(code);
    }
    function tagCloseStart(code) {
      if (asciiAlpha(code)) {
        effects.consume(code);
        return tagClose;
      }
      return nok(code);
    }
    function tagClose(code) {
      if (code === 45 || asciiAlphanumeric(code)) {
        effects.consume(code);
        return tagClose;
      }
      return tagCloseBetween(code);
    }
    function tagCloseBetween(code) {
      if (markdownLineEnding(code)) {
        returnState = tagCloseBetween;
        return atLineEnding(code);
      }
      if (markdownSpace(code)) {
        effects.consume(code);
        return tagCloseBetween;
      }
      return end(code);
    }
    function tagOpen(code) {
      if (code === 45 || asciiAlphanumeric(code)) {
        effects.consume(code);
        return tagOpen;
      }
      if (code === 47 || code === 62 || markdownLineEndingOrSpace(code)) {
        return tagOpenBetween(code);
      }
      return nok(code);
    }
    function tagOpenBetween(code) {
      if (code === 47) {
        effects.consume(code);
        return end;
      }
      if (code === 58 || code === 95 || asciiAlpha(code)) {
        effects.consume(code);
        return tagOpenAttributeName;
      }
      if (markdownLineEnding(code)) {
        returnState = tagOpenBetween;
        return atLineEnding(code);
      }
      if (markdownSpace(code)) {
        effects.consume(code);
        return tagOpenBetween;
      }
      return end(code);
    }
    function tagOpenAttributeName(code) {
      if (code === 45 || code === 46 || code === 58 || code === 95 || asciiAlphanumeric(code)) {
        effects.consume(code);
        return tagOpenAttributeName;
      }
      return tagOpenAttributeNameAfter(code);
    }
    function tagOpenAttributeNameAfter(code) {
      if (code === 61) {
        effects.consume(code);
        return tagOpenAttributeValueBefore;
      }
      if (markdownLineEnding(code)) {
        returnState = tagOpenAttributeNameAfter;
        return atLineEnding(code);
      }
      if (markdownSpace(code)) {
        effects.consume(code);
        return tagOpenAttributeNameAfter;
      }
      return tagOpenBetween(code);
    }
    function tagOpenAttributeValueBefore(code) {
      if (code === null || code === 60 || code === 61 || code === 62 || code === 96) {
        return nok(code);
      }
      if (code === 34 || code === 39) {
        effects.consume(code);
        marker = code;
        return tagOpenAttributeValueQuoted;
      }
      if (markdownLineEnding(code)) {
        returnState = tagOpenAttributeValueBefore;
        return atLineEnding(code);
      }
      if (markdownSpace(code)) {
        effects.consume(code);
        return tagOpenAttributeValueBefore;
      }
      effects.consume(code);
      marker = void 0;
      return tagOpenAttributeValueUnquoted;
    }
    function tagOpenAttributeValueQuoted(code) {
      if (code === marker) {
        effects.consume(code);
        return tagOpenAttributeValueQuotedAfter;
      }
      if (code === null) {
        return nok(code);
      }
      if (markdownLineEnding(code)) {
        returnState = tagOpenAttributeValueQuoted;
        return atLineEnding(code);
      }
      effects.consume(code);
      return tagOpenAttributeValueQuoted;
    }
    function tagOpenAttributeValueQuotedAfter(code) {
      if (code === 62 || code === 47 || markdownLineEndingOrSpace(code)) {
        return tagOpenBetween(code);
      }
      return nok(code);
    }
    function tagOpenAttributeValueUnquoted(code) {
      if (code === null || code === 34 || code === 39 || code === 60 || code === 61 || code === 96) {
        return nok(code);
      }
      if (code === 62 || markdownLineEndingOrSpace(code)) {
        return tagOpenBetween(code);
      }
      effects.consume(code);
      return tagOpenAttributeValueUnquoted;
    }
    function atLineEnding(code) {
      effects.exit("htmlTextData");
      effects.enter("lineEnding");
      effects.consume(code);
      effects.exit("lineEnding");
      return factorySpace(
        effects,
        afterPrefix,
        "linePrefix",
        self2.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
      );
    }
    function afterPrefix(code) {
      effects.enter("htmlTextData");
      return returnState(code);
    }
    function end(code) {
      if (code === 62) {
        effects.consume(code);
        effects.exit("htmlTextData");
        effects.exit("htmlText");
        return ok;
      }
      return nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/label-end.js
  var labelEnd = {
    name: "labelEnd",
    tokenize: tokenizeLabelEnd,
    resolveTo: resolveToLabelEnd,
    resolveAll: resolveAllLabelEnd
  };
  var resourceConstruct = {
    tokenize: tokenizeResource
  };
  var fullReferenceConstruct = {
    tokenize: tokenizeFullReference
  };
  var collapsedReferenceConstruct = {
    tokenize: tokenizeCollapsedReference
  };
  function resolveAllLabelEnd(events) {
    let index = -1;
    let token;
    while (++index < events.length) {
      token = events[index][1];
      if (token.type === "labelImage" || token.type === "labelLink" || token.type === "labelEnd") {
        events.splice(index + 1, token.type === "labelImage" ? 4 : 2);
        token.type = "data";
        index++;
      }
    }
    return events;
  }
  function resolveToLabelEnd(events, context) {
    let index = events.length;
    let offset = 0;
    let token;
    let open;
    let close;
    let media;
    while (index--) {
      token = events[index][1];
      if (open) {
        if (token.type === "link" || token.type === "labelLink" && token._inactive) {
          break;
        }
        if (events[index][0] === "enter" && token.type === "labelLink") {
          token._inactive = true;
        }
      } else if (close) {
        if (events[index][0] === "enter" && (token.type === "labelImage" || token.type === "labelLink") && !token._balanced) {
          open = index;
          if (token.type !== "labelLink") {
            offset = 2;
            break;
          }
        }
      } else if (token.type === "labelEnd") {
        close = index;
      }
    }
    const group = {
      type: events[open][1].type === "labelLink" ? "link" : "image",
      start: Object.assign({}, events[open][1].start),
      end: Object.assign({}, events[events.length - 1][1].end)
    };
    const label = {
      type: "label",
      start: Object.assign({}, events[open][1].start),
      end: Object.assign({}, events[close][1].end)
    };
    const text3 = {
      type: "labelText",
      start: Object.assign({}, events[open + offset + 2][1].end),
      end: Object.assign({}, events[close - 2][1].start)
    };
    media = [
      ["enter", group, context],
      ["enter", label, context]
    ];
    media = push(media, events.slice(open + 1, open + offset + 3));
    media = push(media, [["enter", text3, context]]);
    media = push(
      media,
      resolveAll(
        context.parser.constructs.insideSpan.null,
        events.slice(open + offset + 4, close - 3),
        context
      )
    );
    media = push(media, [
      ["exit", text3, context],
      events[close - 2],
      events[close - 1],
      ["exit", label, context]
    ]);
    media = push(media, events.slice(close + 1));
    media = push(media, [["exit", group, context]]);
    splice(events, open, events.length, media);
    return events;
  }
  function tokenizeLabelEnd(effects, ok, nok) {
    const self2 = this;
    let index = self2.events.length;
    let labelStart;
    let defined;
    while (index--) {
      if ((self2.events[index][1].type === "labelImage" || self2.events[index][1].type === "labelLink") && !self2.events[index][1]._balanced) {
        labelStart = self2.events[index][1];
        break;
      }
    }
    return start;
    function start(code) {
      if (!labelStart) {
        return nok(code);
      }
      if (labelStart._inactive)
        return balanced(code);
      defined = self2.parser.defined.includes(
        normalizeIdentifier(
          self2.sliceSerialize({
            start: labelStart.end,
            end: self2.now()
          })
        )
      );
      effects.enter("labelEnd");
      effects.enter("labelMarker");
      effects.consume(code);
      effects.exit("labelMarker");
      effects.exit("labelEnd");
      return afterLabelEnd;
    }
    function afterLabelEnd(code) {
      if (code === 40) {
        return effects.attempt(
          resourceConstruct,
          ok,
          defined ? ok : balanced
        )(code);
      }
      if (code === 91) {
        return effects.attempt(
          fullReferenceConstruct,
          ok,
          defined ? effects.attempt(collapsedReferenceConstruct, ok, balanced) : balanced
        )(code);
      }
      return defined ? ok(code) : balanced(code);
    }
    function balanced(code) {
      labelStart._balanced = true;
      return nok(code);
    }
  }
  function tokenizeResource(effects, ok, nok) {
    return start;
    function start(code) {
      effects.enter("resource");
      effects.enter("resourceMarker");
      effects.consume(code);
      effects.exit("resourceMarker");
      return factoryWhitespace(effects, open);
    }
    function open(code) {
      if (code === 41) {
        return end(code);
      }
      return factoryDestination(
        effects,
        destinationAfter,
        nok,
        "resourceDestination",
        "resourceDestinationLiteral",
        "resourceDestinationLiteralMarker",
        "resourceDestinationRaw",
        "resourceDestinationString",
        3
      )(code);
    }
    function destinationAfter(code) {
      return markdownLineEndingOrSpace(code) ? factoryWhitespace(effects, between)(code) : end(code);
    }
    function between(code) {
      if (code === 34 || code === 39 || code === 40) {
        return factoryTitle(
          effects,
          factoryWhitespace(effects, end),
          nok,
          "resourceTitle",
          "resourceTitleMarker",
          "resourceTitleString"
        )(code);
      }
      return end(code);
    }
    function end(code) {
      if (code === 41) {
        effects.enter("resourceMarker");
        effects.consume(code);
        effects.exit("resourceMarker");
        effects.exit("resource");
        return ok;
      }
      return nok(code);
    }
  }
  function tokenizeFullReference(effects, ok, nok) {
    const self2 = this;
    return start;
    function start(code) {
      return factoryLabel.call(
        self2,
        effects,
        afterLabel,
        nok,
        "reference",
        "referenceMarker",
        "referenceString"
      )(code);
    }
    function afterLabel(code) {
      return self2.parser.defined.includes(
        normalizeIdentifier(
          self2.sliceSerialize(self2.events[self2.events.length - 1][1]).slice(1, -1)
        )
      ) ? ok(code) : nok(code);
    }
  }
  function tokenizeCollapsedReference(effects, ok, nok) {
    return start;
    function start(code) {
      effects.enter("reference");
      effects.enter("referenceMarker");
      effects.consume(code);
      effects.exit("referenceMarker");
      return open;
    }
    function open(code) {
      if (code === 93) {
        effects.enter("referenceMarker");
        effects.consume(code);
        effects.exit("referenceMarker");
        effects.exit("reference");
        return ok;
      }
      return nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/label-start-image.js
  var labelStartImage = {
    name: "labelStartImage",
    tokenize: tokenizeLabelStartImage,
    resolveAll: labelEnd.resolveAll
  };
  function tokenizeLabelStartImage(effects, ok, nok) {
    const self2 = this;
    return start;
    function start(code) {
      effects.enter("labelImage");
      effects.enter("labelImageMarker");
      effects.consume(code);
      effects.exit("labelImageMarker");
      return open;
    }
    function open(code) {
      if (code === 91) {
        effects.enter("labelMarker");
        effects.consume(code);
        effects.exit("labelMarker");
        effects.exit("labelImage");
        return after;
      }
      return nok(code);
    }
    function after(code) {
      return code === 94 && "_hiddenFootnoteSupport" in self2.parser.constructs ? nok(code) : ok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/label-start-link.js
  var labelStartLink = {
    name: "labelStartLink",
    tokenize: tokenizeLabelStartLink,
    resolveAll: labelEnd.resolveAll
  };
  function tokenizeLabelStartLink(effects, ok, nok) {
    const self2 = this;
    return start;
    function start(code) {
      effects.enter("labelLink");
      effects.enter("labelMarker");
      effects.consume(code);
      effects.exit("labelMarker");
      effects.exit("labelLink");
      return after;
    }
    function after(code) {
      return code === 94 && "_hiddenFootnoteSupport" in self2.parser.constructs ? nok(code) : ok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/line-ending.js
  var lineEnding = {
    name: "lineEnding",
    tokenize: tokenizeLineEnding
  };
  function tokenizeLineEnding(effects, ok) {
    return start;
    function start(code) {
      effects.enter("lineEnding");
      effects.consume(code);
      effects.exit("lineEnding");
      return factorySpace(effects, ok, "linePrefix");
    }
  }

  // node_modules/micromark-core-commonmark/lib/thematic-break.js
  var thematicBreak = {
    name: "thematicBreak",
    tokenize: tokenizeThematicBreak
  };
  function tokenizeThematicBreak(effects, ok, nok) {
    let size = 0;
    let marker;
    return start;
    function start(code) {
      effects.enter("thematicBreak");
      marker = code;
      return atBreak(code);
    }
    function atBreak(code) {
      if (code === marker) {
        effects.enter("thematicBreakSequence");
        return sequence(code);
      }
      if (markdownSpace(code)) {
        return factorySpace(effects, atBreak, "whitespace")(code);
      }
      if (size < 3 || code !== null && !markdownLineEnding(code)) {
        return nok(code);
      }
      effects.exit("thematicBreak");
      return ok(code);
    }
    function sequence(code) {
      if (code === marker) {
        effects.consume(code);
        size++;
        return sequence;
      }
      effects.exit("thematicBreakSequence");
      return atBreak(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/list.js
  var list2 = {
    name: "list",
    tokenize: tokenizeListStart,
    continuation: {
      tokenize: tokenizeListContinuation
    },
    exit: tokenizeListEnd
  };
  var listItemPrefixWhitespaceConstruct = {
    tokenize: tokenizeListItemPrefixWhitespace,
    partial: true
  };
  var indentConstruct = {
    tokenize: tokenizeIndent,
    partial: true
  };
  function tokenizeListStart(effects, ok, nok) {
    const self2 = this;
    const tail = self2.events[self2.events.length - 1];
    let initialSize = tail && tail[1].type === "linePrefix" ? tail[2].sliceSerialize(tail[1], true).length : 0;
    let size = 0;
    return start;
    function start(code) {
      const kind = self2.containerState.type || (code === 42 || code === 43 || code === 45 ? "listUnordered" : "listOrdered");
      if (kind === "listUnordered" ? !self2.containerState.marker || code === self2.containerState.marker : asciiDigit(code)) {
        if (!self2.containerState.type) {
          self2.containerState.type = kind;
          effects.enter(kind, {
            _container: true
          });
        }
        if (kind === "listUnordered") {
          effects.enter("listItemPrefix");
          return code === 42 || code === 45 ? effects.check(thematicBreak, nok, atMarker)(code) : atMarker(code);
        }
        if (!self2.interrupt || code === 49) {
          effects.enter("listItemPrefix");
          effects.enter("listItemValue");
          return inside(code);
        }
      }
      return nok(code);
    }
    function inside(code) {
      if (asciiDigit(code) && ++size < 10) {
        effects.consume(code);
        return inside;
      }
      if ((!self2.interrupt || size < 2) && (self2.containerState.marker ? code === self2.containerState.marker : code === 41 || code === 46)) {
        effects.exit("listItemValue");
        return atMarker(code);
      }
      return nok(code);
    }
    function atMarker(code) {
      effects.enter("listItemMarker");
      effects.consume(code);
      effects.exit("listItemMarker");
      self2.containerState.marker = self2.containerState.marker || code;
      return effects.check(
        blankLine,
        self2.interrupt ? nok : onBlank,
        effects.attempt(
          listItemPrefixWhitespaceConstruct,
          endOfPrefix,
          otherPrefix
        )
      );
    }
    function onBlank(code) {
      self2.containerState.initialBlankLine = true;
      initialSize++;
      return endOfPrefix(code);
    }
    function otherPrefix(code) {
      if (markdownSpace(code)) {
        effects.enter("listItemPrefixWhitespace");
        effects.consume(code);
        effects.exit("listItemPrefixWhitespace");
        return endOfPrefix;
      }
      return nok(code);
    }
    function endOfPrefix(code) {
      self2.containerState.size = initialSize + self2.sliceSerialize(effects.exit("listItemPrefix"), true).length;
      return ok(code);
    }
  }
  function tokenizeListContinuation(effects, ok, nok) {
    const self2 = this;
    self2.containerState._closeFlow = void 0;
    return effects.check(blankLine, onBlank, notBlank);
    function onBlank(code) {
      self2.containerState.furtherBlankLines = self2.containerState.furtherBlankLines || self2.containerState.initialBlankLine;
      return factorySpace(
        effects,
        ok,
        "listItemIndent",
        self2.containerState.size + 1
      )(code);
    }
    function notBlank(code) {
      if (self2.containerState.furtherBlankLines || !markdownSpace(code)) {
        self2.containerState.furtherBlankLines = void 0;
        self2.containerState.initialBlankLine = void 0;
        return notInCurrentItem(code);
      }
      self2.containerState.furtherBlankLines = void 0;
      self2.containerState.initialBlankLine = void 0;
      return effects.attempt(indentConstruct, ok, notInCurrentItem)(code);
    }
    function notInCurrentItem(code) {
      self2.containerState._closeFlow = true;
      self2.interrupt = void 0;
      return factorySpace(
        effects,
        effects.attempt(list2, ok, nok),
        "linePrefix",
        self2.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
      )(code);
    }
  }
  function tokenizeIndent(effects, ok, nok) {
    const self2 = this;
    return factorySpace(
      effects,
      afterPrefix,
      "listItemIndent",
      self2.containerState.size + 1
    );
    function afterPrefix(code) {
      const tail = self2.events[self2.events.length - 1];
      return tail && tail[1].type === "listItemIndent" && tail[2].sliceSerialize(tail[1], true).length === self2.containerState.size ? ok(code) : nok(code);
    }
  }
  function tokenizeListEnd(effects) {
    effects.exit(this.containerState.type);
  }
  function tokenizeListItemPrefixWhitespace(effects, ok, nok) {
    const self2 = this;
    return factorySpace(
      effects,
      afterPrefix,
      "listItemPrefixWhitespace",
      self2.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4 + 1
    );
    function afterPrefix(code) {
      const tail = self2.events[self2.events.length - 1];
      return !markdownSpace(code) && tail && tail[1].type === "listItemPrefixWhitespace" ? ok(code) : nok(code);
    }
  }

  // node_modules/micromark-core-commonmark/lib/setext-underline.js
  var setextUnderline = {
    name: "setextUnderline",
    tokenize: tokenizeSetextUnderline,
    resolveTo: resolveToSetextUnderline
  };
  function resolveToSetextUnderline(events, context) {
    let index = events.length;
    let content3;
    let text3;
    let definition2;
    while (index--) {
      if (events[index][0] === "enter") {
        if (events[index][1].type === "content") {
          content3 = index;
          break;
        }
        if (events[index][1].type === "paragraph") {
          text3 = index;
        }
      } else {
        if (events[index][1].type === "content") {
          events.splice(index, 1);
        }
        if (!definition2 && events[index][1].type === "definition") {
          definition2 = index;
        }
      }
    }
    const heading = {
      type: "setextHeading",
      start: Object.assign({}, events[text3][1].start),
      end: Object.assign({}, events[events.length - 1][1].end)
    };
    events[text3][1].type = "setextHeadingText";
    if (definition2) {
      events.splice(text3, 0, ["enter", heading, context]);
      events.splice(definition2 + 1, 0, ["exit", events[content3][1], context]);
      events[content3][1].end = Object.assign({}, events[definition2][1].end);
    } else {
      events[content3][1] = heading;
    }
    events.push(["exit", heading, context]);
    return events;
  }
  function tokenizeSetextUnderline(effects, ok, nok) {
    const self2 = this;
    let index = self2.events.length;
    let marker;
    let paragraph;
    while (index--) {
      if (self2.events[index][1].type !== "lineEnding" && self2.events[index][1].type !== "linePrefix" && self2.events[index][1].type !== "content") {
        paragraph = self2.events[index][1].type === "paragraph";
        break;
      }
    }
    return start;
    function start(code) {
      if (!self2.parser.lazy[self2.now().line] && (self2.interrupt || paragraph)) {
        effects.enter("setextHeadingLine");
        effects.enter("setextHeadingLineSequence");
        marker = code;
        return closingSequence(code);
      }
      return nok(code);
    }
    function closingSequence(code) {
      if (code === marker) {
        effects.consume(code);
        return closingSequence;
      }
      effects.exit("setextHeadingLineSequence");
      return factorySpace(effects, closingSequenceEnd, "lineSuffix")(code);
    }
    function closingSequenceEnd(code) {
      if (code === null || markdownLineEnding(code)) {
        effects.exit("setextHeadingLine");
        return ok(code);
      }
      return nok(code);
    }
  }

  // node_modules/micromark/lib/initialize/flow.js
  var flow = {
    tokenize: initializeFlow
  };
  function initializeFlow(effects) {
    const self2 = this;
    const initial = effects.attempt(
      blankLine,
      atBlankEnding,
      effects.attempt(
        this.parser.constructs.flowInitial,
        afterConstruct,
        factorySpace(
          effects,
          effects.attempt(
            this.parser.constructs.flow,
            afterConstruct,
            effects.attempt(content2, afterConstruct)
          ),
          "linePrefix"
        )
      )
    );
    return initial;
    function atBlankEnding(code) {
      if (code === null) {
        effects.consume(code);
        return;
      }
      effects.enter("lineEndingBlank");
      effects.consume(code);
      effects.exit("lineEndingBlank");
      self2.currentConstruct = void 0;
      return initial;
    }
    function afterConstruct(code) {
      if (code === null) {
        effects.consume(code);
        return;
      }
      effects.enter("lineEnding");
      effects.consume(code);
      effects.exit("lineEnding");
      self2.currentConstruct = void 0;
      return initial;
    }
  }

  // node_modules/micromark/lib/initialize/text.js
  var resolver = {
    resolveAll: createResolver()
  };
  var string = initializeFactory("string");
  var text = initializeFactory("text");
  function initializeFactory(field) {
    return {
      tokenize: initializeText,
      resolveAll: createResolver(
        field === "text" ? resolveAllLineSuffixes : void 0
      )
    };
    function initializeText(effects) {
      const self2 = this;
      const constructs2 = this.parser.constructs[field];
      const text3 = effects.attempt(constructs2, start, notText);
      return start;
      function start(code) {
        return atBreak(code) ? text3(code) : notText(code);
      }
      function notText(code) {
        if (code === null) {
          effects.consume(code);
          return;
        }
        effects.enter("data");
        effects.consume(code);
        return data;
      }
      function data(code) {
        if (atBreak(code)) {
          effects.exit("data");
          return text3(code);
        }
        effects.consume(code);
        return data;
      }
      function atBreak(code) {
        if (code === null) {
          return true;
        }
        const list3 = constructs2[code];
        let index = -1;
        if (list3) {
          while (++index < list3.length) {
            const item = list3[index];
            if (!item.previous || item.previous.call(self2, self2.previous)) {
              return true;
            }
          }
        }
        return false;
      }
    }
  }
  function createResolver(extraResolver) {
    return resolveAllText;
    function resolveAllText(events, context) {
      let index = -1;
      let enter;
      while (++index <= events.length) {
        if (enter === void 0) {
          if (events[index] && events[index][1].type === "data") {
            enter = index;
            index++;
          }
        } else if (!events[index] || events[index][1].type !== "data") {
          if (index !== enter + 2) {
            events[enter][1].end = events[index - 1][1].end;
            events.splice(enter + 2, index - enter - 2);
            index = enter + 2;
          }
          enter = void 0;
        }
      }
      return extraResolver ? extraResolver(events, context) : events;
    }
  }
  function resolveAllLineSuffixes(events, context) {
    let eventIndex = 0;
    while (++eventIndex <= events.length) {
      if ((eventIndex === events.length || events[eventIndex][1].type === "lineEnding") && events[eventIndex - 1][1].type === "data") {
        const data = events[eventIndex - 1][1];
        const chunks = context.sliceStream(data);
        let index = chunks.length;
        let bufferIndex = -1;
        let size = 0;
        let tabs;
        while (index--) {
          const chunk = chunks[index];
          if (typeof chunk === "string") {
            bufferIndex = chunk.length;
            while (chunk.charCodeAt(bufferIndex - 1) === 32) {
              size++;
              bufferIndex--;
            }
            if (bufferIndex)
              break;
            bufferIndex = -1;
          } else if (chunk === -2) {
            tabs = true;
            size++;
          } else if (chunk === -1) {
          } else {
            index++;
            break;
          }
        }
        if (size) {
          const token = {
            type: eventIndex === events.length || tabs || size < 2 ? "lineSuffix" : "hardBreakTrailing",
            start: {
              line: data.end.line,
              column: data.end.column - size,
              offset: data.end.offset - size,
              _index: data.start._index + index,
              _bufferIndex: index ? bufferIndex : data.start._bufferIndex + bufferIndex
            },
            end: Object.assign({}, data.end)
          };
          data.end = Object.assign({}, token.start);
          if (data.start.offset === data.end.offset) {
            Object.assign(data, token);
          } else {
            events.splice(
              eventIndex,
              0,
              ["enter", token, context],
              ["exit", token, context]
            );
            eventIndex += 2;
          }
        }
        eventIndex++;
      }
    }
    return events;
  }

  // node_modules/micromark/lib/create-tokenizer.js
  function createTokenizer(parser, initialize, from) {
    let point = Object.assign(
      from ? Object.assign({}, from) : {
        line: 1,
        column: 1,
        offset: 0
      },
      {
        _index: 0,
        _bufferIndex: -1
      }
    );
    const columnStart = {};
    const resolveAllConstructs = [];
    let chunks = [];
    let stack = [];
    let consumed = true;
    const effects = {
      consume,
      enter,
      exit: exit2,
      attempt: constructFactory(onsuccessfulconstruct),
      check: constructFactory(onsuccessfulcheck),
      interrupt: constructFactory(onsuccessfulcheck, {
        interrupt: true
      })
    };
    const context = {
      previous: null,
      code: null,
      containerState: {},
      events: [],
      parser,
      sliceStream,
      sliceSerialize,
      now,
      defineSkip,
      write
    };
    let state = initialize.tokenize.call(context, effects);
    let expectedCode;
    if (initialize.resolveAll) {
      resolveAllConstructs.push(initialize);
    }
    return context;
    function write(slice) {
      chunks = push(chunks, slice);
      main2();
      if (chunks[chunks.length - 1] !== null) {
        return [];
      }
      addResult(initialize, 0);
      context.events = resolveAll(resolveAllConstructs, context.events, context);
      return context.events;
    }
    function sliceSerialize(token, expandTabs) {
      return serializeChunks(sliceStream(token), expandTabs);
    }
    function sliceStream(token) {
      return sliceChunks(chunks, token);
    }
    function now() {
      return Object.assign({}, point);
    }
    function defineSkip(value) {
      columnStart[value.line] = value.column;
      accountForPotentialSkip();
    }
    function main2() {
      let chunkIndex;
      while (point._index < chunks.length) {
        const chunk = chunks[point._index];
        if (typeof chunk === "string") {
          chunkIndex = point._index;
          if (point._bufferIndex < 0) {
            point._bufferIndex = 0;
          }
          while (point._index === chunkIndex && point._bufferIndex < chunk.length) {
            go(chunk.charCodeAt(point._bufferIndex));
          }
        } else {
          go(chunk);
        }
      }
    }
    function go(code) {
      consumed = void 0;
      expectedCode = code;
      state = state(code);
    }
    function consume(code) {
      if (markdownLineEnding(code)) {
        point.line++;
        point.column = 1;
        point.offset += code === -3 ? 2 : 1;
        accountForPotentialSkip();
      } else if (code !== -1) {
        point.column++;
        point.offset++;
      }
      if (point._bufferIndex < 0) {
        point._index++;
      } else {
        point._bufferIndex++;
        if (point._bufferIndex === chunks[point._index].length) {
          point._bufferIndex = -1;
          point._index++;
        }
      }
      context.previous = code;
      consumed = true;
    }
    function enter(type, fields) {
      const token = fields || {};
      token.type = type;
      token.start = now();
      context.events.push(["enter", token, context]);
      stack.push(token);
      return token;
    }
    function exit2(type) {
      const token = stack.pop();
      token.end = now();
      context.events.push(["exit", token, context]);
      return token;
    }
    function onsuccessfulconstruct(construct, info) {
      addResult(construct, info.from);
    }
    function onsuccessfulcheck(_, info) {
      info.restore();
    }
    function constructFactory(onreturn, fields) {
      return hook;
      function hook(constructs2, returnState, bogusState) {
        let listOfConstructs;
        let constructIndex;
        let currentConstruct;
        let info;
        return Array.isArray(constructs2) ? handleListOfConstructs(constructs2) : "tokenize" in constructs2 ? handleListOfConstructs([constructs2]) : handleMapOfConstructs(constructs2);
        function handleMapOfConstructs(map) {
          return start;
          function start(code) {
            const def = code !== null && map[code];
            const all = code !== null && map.null;
            const list3 = [
              ...Array.isArray(def) ? def : def ? [def] : [],
              ...Array.isArray(all) ? all : all ? [all] : []
            ];
            return handleListOfConstructs(list3)(code);
          }
        }
        function handleListOfConstructs(list3) {
          listOfConstructs = list3;
          constructIndex = 0;
          if (list3.length === 0) {
            return bogusState;
          }
          return handleConstruct(list3[constructIndex]);
        }
        function handleConstruct(construct) {
          return start;
          function start(code) {
            info = store();
            currentConstruct = construct;
            if (!construct.partial) {
              context.currentConstruct = construct;
            }
            if (construct.name && context.parser.constructs.disable.null.includes(construct.name)) {
              return nok(code);
            }
            return construct.tokenize.call(
              fields ? Object.assign(Object.create(context), fields) : context,
              effects,
              ok,
              nok
            )(code);
          }
        }
        function ok(code) {
          consumed = true;
          onreturn(currentConstruct, info);
          return returnState;
        }
        function nok(code) {
          consumed = true;
          info.restore();
          if (++constructIndex < listOfConstructs.length) {
            return handleConstruct(listOfConstructs[constructIndex]);
          }
          return bogusState;
        }
      }
    }
    function addResult(construct, from2) {
      if (construct.resolveAll && !resolveAllConstructs.includes(construct)) {
        resolveAllConstructs.push(construct);
      }
      if (construct.resolve) {
        splice(
          context.events,
          from2,
          context.events.length - from2,
          construct.resolve(context.events.slice(from2), context)
        );
      }
      if (construct.resolveTo) {
        context.events = construct.resolveTo(context.events, context);
      }
    }
    function store() {
      const startPoint = now();
      const startPrevious = context.previous;
      const startCurrentConstruct = context.currentConstruct;
      const startEventsIndex = context.events.length;
      const startStack = Array.from(stack);
      return {
        restore,
        from: startEventsIndex
      };
      function restore() {
        point = startPoint;
        context.previous = startPrevious;
        context.currentConstruct = startCurrentConstruct;
        context.events.length = startEventsIndex;
        stack = startStack;
        accountForPotentialSkip();
      }
    }
    function accountForPotentialSkip() {
      if (point.line in columnStart && point.column < 2) {
        point.column = columnStart[point.line];
        point.offset += columnStart[point.line] - 1;
      }
    }
  }
  function sliceChunks(chunks, token) {
    const startIndex = token.start._index;
    const startBufferIndex = token.start._bufferIndex;
    const endIndex = token.end._index;
    const endBufferIndex = token.end._bufferIndex;
    let view;
    if (startIndex === endIndex) {
      view = [chunks[startIndex].slice(startBufferIndex, endBufferIndex)];
    } else {
      view = chunks.slice(startIndex, endIndex);
      if (startBufferIndex > -1) {
        view[0] = view[0].slice(startBufferIndex);
      }
      if (endBufferIndex > 0) {
        view.push(chunks[endIndex].slice(0, endBufferIndex));
      }
    }
    return view;
  }
  function serializeChunks(chunks, expandTabs) {
    let index = -1;
    const result = [];
    let atTab;
    while (++index < chunks.length) {
      const chunk = chunks[index];
      let value;
      if (typeof chunk === "string") {
        value = chunk;
      } else
        switch (chunk) {
          case -5: {
            value = "\r";
            break;
          }
          case -4: {
            value = "\n";
            break;
          }
          case -3: {
            value = "\r\n";
            break;
          }
          case -2: {
            value = expandTabs ? " " : "	";
            break;
          }
          case -1: {
            if (!expandTabs && atTab)
              continue;
            value = " ";
            break;
          }
          default: {
            value = String.fromCharCode(chunk);
          }
        }
      atTab = chunk === -2;
      result.push(value);
    }
    return result.join("");
  }

  // node_modules/micromark/lib/constructs.js
  var constructs_exports = {};
  __export(constructs_exports, {
    attentionMarkers: () => attentionMarkers,
    contentInitial: () => contentInitial,
    disable: () => disable,
    document: () => document3,
    flow: () => flow2,
    flowInitial: () => flowInitial,
    insideSpan: () => insideSpan,
    string: () => string2,
    text: () => text2
  });
  var document3 = {
    [42]: list2,
    [43]: list2,
    [45]: list2,
    [48]: list2,
    [49]: list2,
    [50]: list2,
    [51]: list2,
    [52]: list2,
    [53]: list2,
    [54]: list2,
    [55]: list2,
    [56]: list2,
    [57]: list2,
    [62]: blockQuote
  };
  var contentInitial = {
    [91]: definition
  };
  var flowInitial = {
    [-2]: codeIndented,
    [-1]: codeIndented,
    [32]: codeIndented
  };
  var flow2 = {
    [35]: headingAtx,
    [42]: thematicBreak,
    [45]: [setextUnderline, thematicBreak],
    [60]: htmlFlow,
    [61]: setextUnderline,
    [95]: thematicBreak,
    [96]: codeFenced,
    [126]: codeFenced
  };
  var string2 = {
    [38]: characterReference,
    [92]: characterEscape
  };
  var text2 = {
    [-5]: lineEnding,
    [-4]: lineEnding,
    [-3]: lineEnding,
    [33]: labelStartImage,
    [38]: characterReference,
    [42]: attention,
    [60]: [autolink, htmlText],
    [91]: labelStartLink,
    [92]: [hardBreakEscape, characterEscape],
    [93]: labelEnd,
    [95]: attention,
    [96]: codeText
  };
  var insideSpan = {
    null: [attention, resolver]
  };
  var attentionMarkers = {
    null: [42, 95]
  };
  var disable = {
    null: []
  };

  // node_modules/micromark/lib/parse.js
  function parse(options = {}) {
    const constructs2 = combineExtensions(
      [constructs_exports].concat(options.extensions || [])
    );
    const parser = {
      defined: [],
      lazy: {},
      constructs: constructs2,
      content: create(content),
      document: create(document2),
      flow: create(flow),
      string: create(string),
      text: create(text)
    };
    return parser;
    function create(initial) {
      return creator;
      function creator(from) {
        return createTokenizer(parser, initial, from);
      }
    }
  }

  // node_modules/micromark/lib/postprocess.js
  function postprocess(events) {
    while (!subtokenize(events)) {
    }
    return events;
  }

  // node_modules/micromark/lib/preprocess.js
  var search = /[\0\t\n\r]/g;
  function preprocess() {
    let column = 1;
    let buffer = "";
    let start = true;
    let atCarriageReturn;
    return preprocessor;
    function preprocessor(value, encoding, end) {
      const chunks = [];
      let match;
      let next;
      let startPosition;
      let endPosition;
      let code;
      value = buffer + value.toString(encoding);
      startPosition = 0;
      buffer = "";
      if (start) {
        if (value.charCodeAt(0) === 65279) {
          startPosition++;
        }
        start = void 0;
      }
      while (startPosition < value.length) {
        search.lastIndex = startPosition;
        match = search.exec(value);
        endPosition = match && match.index !== void 0 ? match.index : value.length;
        code = value.charCodeAt(endPosition);
        if (!match) {
          buffer = value.slice(startPosition);
          break;
        }
        if (code === 10 && startPosition === endPosition && atCarriageReturn) {
          chunks.push(-3);
          atCarriageReturn = void 0;
        } else {
          if (atCarriageReturn) {
            chunks.push(-5);
            atCarriageReturn = void 0;
          }
          if (startPosition < endPosition) {
            chunks.push(value.slice(startPosition, endPosition));
            column += endPosition - startPosition;
          }
          switch (code) {
            case 0: {
              chunks.push(65533);
              column++;
              break;
            }
            case 9: {
              next = Math.ceil(column / 4) * 4;
              chunks.push(-2);
              while (column++ < next)
                chunks.push(-1);
              break;
            }
            case 10: {
              chunks.push(-4);
              column = 1;
              break;
            }
            default: {
              atCarriageReturn = true;
              column = 1;
            }
          }
        }
        startPosition = endPosition + 1;
      }
      if (end) {
        if (atCarriageReturn)
          chunks.push(-5);
        if (buffer)
          chunks.push(buffer);
        chunks.push(null);
      }
      return chunks;
    }
  }

  // node_modules/micromark/index.js
  var micromark = function(value, encoding, options) {
    if (typeof encoding !== "string") {
      options = encoding;
      encoding = void 0;
    }
    return compile(options)(
      postprocess(
        parse(options).document().write(preprocess()(value, encoding, true))
      )
    );
  };

  // hooks/useHighlighter/prepareMarkup.ts
  var addTextChunkClassNames = (el, parentIsTextChunk = false, addCustomStyles) => {
    addCustomStyles && addCustomStyles(el);
    if (parentIsTextChunk) {
      return;
    }
    switch (el.nodeName) {
      case "P":
        setIsTextChunk(el);
        break;
      case "H1":
      case "H2":
      case "H3":
      case "H4":
      case "H5":
      case "H6":
        el.id = el.textContent?.slice(0, 40).toLowerCase().replace(/[^a-z]/g, "-") || "";
        setIsTextChunk(el);
        break;
    }
    return el;
  };
  var isListItem = (li) => {
    return li.nodeName === "LI";
  };
  var isP = (p) => {
    return p.nodeName === "P";
  };
  var isUlOL = (list3) => {
    return list3.nodeName === "UL" || list3.nodeName === "OL";
  };
  var markupLiElement = (li, parentType, liIndex = 0, parentIsTextChunk = false, styleArgs) => {
    if (!isListItem(li)) {
      return;
    }
    const [_, newChildNodes] = markupChildren(
      [],
      li.childNodes,
      parentIsTextChunk,
      styleArgs
    );
    li.childNodes.forEach((c, idx) => {
      c.replaceWith(newChildNodes[idx]);
    });
    const firstChild = li.childNodes[0];
    if (firstChild && isP(firstChild)) {
      addTextChunkClassNames(firstChild, false, styleArgs?.addCustomStyles);
    } else {
      let list3 = null;
      let childIndex = 0;
      const beforeEls = [];
      while (!list3 && childIndex + 1 <= li.childNodes.length) {
        const node = li.childNodes[childIndex];
        if (isUlOL(node)) {
          list3 = node;
        } else {
          beforeEls.push(node);
        }
        childIndex++;
      }
      const span = document.createElement("span");
      if (parentType === "UL") {
        span.innerHTML = `<span class="${styleArgs?.customUlLiMarker || ""}">* </span>`;
      } else {
        li.value = liIndex + 1;
        span.innerHTML = `<span data-total-digits="${li.value.toString().length}" class="${styleArgs?.customOlLiMarker || ""}">${liIndex + 1}. </span>`;
      }
      beforeEls.forEach((el) => {
        span.appendChild(el);
      });
      setIsTextChunk(span);
      li.innerHTML = `${span.outerHTML}${list3 ? list3.outerHTML : ""}`;
    }
    addTextChunkClassNames(li, false, styleArgs?.addCustomStyles);
    return li;
  };
  var markupChildren = (children, childNodes, parentIsTextChunk = false, styleArgs) => {
    childNodes.forEach((child) => {
      if (!isHTMLElement(child)) {
        return;
      }
      switch (child.nodeName) {
        case "BLOCKQUOTE":
          const [_, newChildNodes] = markupChildren(
            [],
            child.childNodes,
            false,
            styleArgs
          );
          child.childNodes.forEach((c, idx) => {
            c.replaceWith(newChildNodes[idx]);
          });
          addTextChunkClassNames(child, false, styleArgs?.addCustomStyles);
          break;
        case "UL":
          child.childNodes.forEach(
            (li) => markupLiElement(li, "UL", 0, true, styleArgs)
          );
          break;
        case "OL":
          let liIndex = 0;
          child.childNodes.forEach((li) => {
            const updatedLi = markupLiElement(li, "OL", liIndex, true, styleArgs);
            if (updatedLi?.value) {
              liIndex = updatedLi.value;
            }
          });
          break;
        default:
          addTextChunkClassNames(
            child,
            parentIsTextChunk,
            styleArgs?.addCustomStyles
          );
      }
      children.push(child.outerHTML);
    });
    return [children, childNodes];
  };
  var setImagesDimensions = (dom, imageClassNames) => {
    dom.querySelectorAll("img").forEach((img) => {
      img.classList.add(...imageClassNames);
      img.loading = "lazy";
      const split = img.alt.split("}");
      if (split.length === 2) {
        const dimensionsString = split[0] + `}`;
        try {
          const dimensions = JSON.parse(dimensionsString);
          if (dimensions.width && typeof dimensions.width === "number" && dimensions.height && typeof dimensions.height === "number") {
            img.width = dimensions.width;
            img.height = dimensions.height;
            img.alt = split.slice(1).join("").trim();
          }
        } catch (error) {
        }
      }
    });
    return dom;
  };
  var entryHTML = (markdown, options, styleArgs) => {
    const htmlString = micromark(markdown, options);
    const dom = document.createElement("div");
    dom.innerHTML = htmlString;
    setImagesDimensions(dom, styleArgs?.imageClassNames || []);
    const children = [];
    dom.querySelectorAll("pre").forEach((pre) => {
      pre.insertAdjacentElement("beforebegin", document.createElement("p"));
      pre.insertAdjacentElement("afterend", document.createElement("p"));
    });
    dom.querySelectorAll("a").forEach((a) => {
      a.target = "_blank";
    });
    dom.insertAdjacentElement("beforeend", document.createElement("p"));
    markupChildren(children, dom.childNodes, false, styleArgs);
    dom.remove();
    return children.join("");
  };

  // hooks/useHighlighter/getSearchStringWordBounds/getSearchStringWordBounds.ts
  var getSearchStringWordBounds = (search2, text3) => {
    const words = text3.trim().split(/\s+/);
    let searchArray = search2.trim().split(/\s+/);
    let start = -1;
    let end = -1;
    let wordIndex = 0;
    let isMatching = true;
    while (searchArray.length > 0 && words.length > 0) {
      const isLast = searchArray.length === 1;
      if (words[0] !== searchArray[0]) {
        isMatching = false;
        if (start !== -1) {
          start = -1;
        }
        words.shift();
        searchArray = search2.trim().split(/\s+/);
      } else if (isMatching) {
        if (start === -1) {
          start = wordIndex;
        }
        if (isLast) {
          end = wordIndex + 1;
        }
        words.shift();
        searchArray.shift();
      } else {
        isMatching = true;
        if (start === -1) {
          start = wordIndex;
        }
        if (isLast) {
          end = wordIndex + 1;
        }
        words.shift();
        searchArray.shift();
      }
      wordIndex++;
    }
    return [start, end];
  };

  // web-extension/popup/popup.ts
  if (globalThis.browser?.runtime.getURL("").startsWith("moz-extension")) {
    globalThis.chrome = globalThis.browser;
  }
  var chunkSelector = [
    "address",
    "article",
    "aside",
    "blockquote",
    "details",
    "dialog",
    "dd",
    "div",
    "dl",
    "dt",
    "fieldset",
    "figcaption",
    "figure",
    "footer",
    "form",
    "h1",
    "h2",
    "h3",
    "h4",
    "h5",
    "h6",
    "header",
    "hgroup",
    "hr",
    "li",
    "main",
    "nav",
    "ol",
    "p",
    "pre",
    "section",
    "table",
    "ul"
  ].join(",");
  var floatingIframeHeight = 187;
  var styles = `
#matter-popup-app {
  border: 0 !important;
  box-shadow: 0px 0px transparent;
  color-scheme: light !important;
  right: 0 !important;
  padding: 0 !important;
  pointer-events: none !important;
  position: fixed !important;
  opacity: 0 !important;
  top: 10px !important;
  transition: opacity 0.2s ease !important;
  user-select: none !important;
  height: 500px !important;
  width: 470px !important;
  z-index: ${Number.MAX_SAFE_INTEGER} !important;
}

#matter-popup-app[data-matter-active] {
  display: block !important;
}

#matter-popup-app[data-matter-hidden] {
  visibility: hidden !important;
  z-index: -1 !important;
}

#matter-popup-app[data-matter-active="true"] {
  pointer-events: auto !important;
  opacity: 1 !important;
  transition: opacity 0.2s ease !important;
}

@media print {
  #matter-popup-app, #matter-floating-iframe, #matter-modal-iframe {
    display: none !important;
  }
}

#matter-floating-iframe {
  border: 0 !important;
  box-shadow: 0px 0px transparent;
  color-scheme: light !important;

  height: ${floatingIframeHeight}px !important;
  position: absolute !important;
  z-index: ${Number.MAX_SAFE_INTEGER} !important;
  width: 350px !important;

  pointer-events: none !important;
  opacity: 0 !important;
  visibility: hidden;
}

#matter-floating-iframe[data-matter-active] {
  display: block !important;
}

#matter-floating-iframe[data-matter-active="true"] {
  pointer-events: auto !important;
  opacity: 1 !important;
  visibility: visible;
}

#matter-modal-iframe {
  border: 0 !important;
  display: none !important;
  z-index: ${Number.MAX_SAFE_INTEGER} !important;
}

#matter-modal-iframe[data-matter-active="true"] {
  display: block !important;
  height: 100vh;
  width: 100vw;
  position: fixed;
  top: 0;
  left: 0;
}

mark[data-annotation-id][data-open-web-highlight] {
  background: #fff8c6 !important;
  box-shadow: 0 0.195em 0 0 #fff8c6,0 calc(0.195em * -1) 0 0 #fff8c6 !important;
  font-weight: inherit;
  font-style: inherit;
}

mark[data-annotation-id][data-open-web-highlight][data-line-height-normal] {
  box-shadow: none !important;
}

mark[data-open-web-highlight][data-annotation-has-note] {
  text-decoration: underline;
  text-decoration-color: #ffd02a;
  text-decoration-thickness: 2.5px;
  text-decoration-skip-ink: none;
  text-underline-offset: 1px;
}

mark[data-open-web-highlight][data-annotation-has-note][data-line-height-normal] {
  text-decoration-thickness: 1px;
}
`.trim();
  var activeAnnotation = { current: null };
  var tooltipMap = /* @__PURE__ */ new Map();
  var getHref = (el) => {
    let { href } = window.location;
    let matchedNonWindowHref = false;
    if (href === "https://twitter.com/home" || href === "https://twitter.com" || href.startsWith("https://twitter.com/i/topics/")) {
      const closestTweetLink = el instanceof HTMLElement && el.closest(`[data-testid="cellInnerDiv"]`)?.querySelector(
        'a[role="link"][href*="/status/"]'
      )?.href;
      if (closestTweetLink) {
        matchedNonWindowHref = true;
      }
      href = closestTweetLink || href;
    }
    return { href, matchedNonWindowHref };
  };
  var markListener = (e) => {
    if (!(e.target instanceof HTMLElement)) {
      return;
    }
    e.stopPropagation();
    const annotationId = e.target.getAttribute("data-annotation-id") || e.target.closest("mark")?.getAttribute("data-annotation-id");
    const mark = document.querySelector(`[data-annotation-id="${annotationId}"]`);
    if (!annotationId || !mark || !(mark instanceof HTMLElement)) {
      return;
    }
    activeAnnotation.current = annotationId;
    const iframe = document.querySelector(
      "#matter-floating-iframe"
    );
    if (iframe && mark.parentElement) {
      const markBounds = mark.getBoundingClientRect();
      const parentBounds = mark.parentElement?.getBoundingClientRect();
      const horizotalBounds = parentBounds && markBounds.width === parentBounds.width ? markBounds : parentBounds;
      iframe.setAttribute("data-matter-active", "true");
      iframe.style.top = `${window.scrollY + markBounds.top - floatingIframeHeight}px`;
      iframe.style.left = `${window.scrollX + horizotalBounds.left + horizotalBounds.width / 2}px`;
      iframe.style.transform = "translateX(-50%)";
      iframe.dispatchEvent(
        new CustomEvent("MATTER:MARK_CLICK", {
          detail: { annotationId: activeAnnotation.current }
        })
      );
    }
  };
  var popoverDisableClicksTimeout = {
    current: null
  };
  var closePopup = (iframe, extensionPort) => {
    iframe.setAttribute("data-matter-active", "false");
    iframe.setAttribute("aria-hidden", "true");
    if (extensionPort) {
      extensionPort.postMessage({ type: "POPUP_CLOSED" });
    }
    iframe.blur();
    if (isSafari()) {
      if (popoverDisableClicksTimeout.current) {
        clearTimeout(popoverDisableClicksTimeout.current);
      }
      popoverDisableClicksTimeout.current = setTimeout(() => {
        iframe.setAttribute("data-matter-hidden", "true");
      }, 1e3);
    }
  };
  var closePopover = (iframe, popoverPort) => {
    iframe.setAttribute("data-matter-active", "false");
    popoverPort.postMessage({ type: "CLOSE_POPOVER" });
  };
  var openModal = (iframe) => {
    iframe.setAttribute("data-matter-active", "true");
  };
  var closeModal = (iframe) => {
    iframe.setAttribute("data-matter-active", "false");
  };
  var openPopup = (iframe, extensionPort, asLink = false, customMsg = "") => {
    if (popoverDisableClicksTimeout.current) {
      clearTimeout(popoverDisableClicksTimeout.current);
    }
    iframe.setAttribute("data-matter-active", "true");
    iframe.setAttribute("aria-hidden", "false");
    iframe.removeAttribute("data-matter-hidden");
    const storedState = matterSessionStorage().get(
      hashStrToInt(window.location.href).toString()
    );
    if (!customMsg && !asLink && storedState?.libraryState !== libraryState.LIBRARY_STATE_ARCHIVED && storedState?.libraryState !== libraryState.LIBRARY_STATE_SAVED && storedState?.libraryState !== libraryState.LIBRARY_STATE_DELETED) {
      chrome.runtime.sendMessage({
        type: "SAVE_PAGE",
        payload: { pageData: getPageData() }
      });
    }
    chrome.runtime.sendMessage({ type: "SET_TAGS" }, (response) => {
      const tagsMsg = {
        type: "TAGS",
        payload: response
      };
      extensionPort.postMessage(tagsMsg);
    });
    const openMsg = {
      type: "OPEN_POPUP",
      payload: {
        url: window.location.href,
        storedState,
        asLink,
        customMsg
      }
    };
    extensionPort.postMessage(openMsg);
    const query = new URLSearchParams(window.location.search);
    if (query.get("matterDebug")) {
      extensionPort.postMessage({
        type: "DEBUG",
        payload: { debug: query.get("matterDebug") }
      });
    }
  };
  var openReader = (url) => {
    chrome.runtime.sendMessage({
      type: "OPEN_READER",
      payload: {
        url: `${webappUrlNew}/reader?url=${encodeURIComponent(url)}&from=ext`,
        pageData: getPageData()
      }
    });
  };
  var savePageOrLink = ({
    iframe,
    extensionPort,
    pageData,
    asLink = false
  }) => {
    openPopup(iframe, extensionPort, asLink);
    extensionPort.postMessage({ type: "SAVE_PAGE" });
    chrome.runtime.sendMessage({
      type: "SAVE_PAGE",
      payload: { pageData: pageData || getPageData() }
    });
  };
  var openLogin = () => {
    chrome.runtime.sendMessage({ type: "OPEN_LOGIN" });
  };
  var getPageData = (customUrl, disableHtmlPayload = false) => ({
    url: customUrl || window.location.href,
    html: disableHtmlPayload ? "" : document.documentElement.outerHTML,
    user_agent: window.navigator.userAgent
  });
  var checkLogin = () => {
    return new Promise((resolve) => {
      chrome.runtime.sendMessage(
        {
          type: "IS_USER_LOGGED_IN"
        },
        (response) => {
          if (response.payload) {
            return resolve(true);
          }
          return resolve(false);
        }
      );
    });
  };
  var initIframe = () => {
    window.dispatchEvent(new CustomEvent("MR_EXTENSION_RELOAD"));
    const iframeSrc = () => chrome.runtime.getURL("/index.html");
    const iframe = document.createElement("iframe");
    iframe.id = "matter-popup-app";
    iframe.src = iframeSrc();
    iframe.style.display = "none";
    closePopup(iframe);
    const floatingIframe = document.createElement("iframe");
    floatingIframe.id = "matter-floating-iframe";
    floatingIframe.src = chrome.runtime.getURL("/popover.html");
    floatingIframe.style.display = "none";
    const modalIframe = document.createElement("iframe");
    modalIframe.id = "matter-modal-iframe";
    modalIframe.src = chrome.runtime.getURL("/modal.html");
    modalIframe.style.display = "none";
    const style = document.createElement("style");
    style.innerHTML = styles;
    document.documentElement.appendChild(style);
    document.documentElement.appendChild(iframe);
    document.documentElement.appendChild(floatingIframe);
    document.documentElement.appendChild(modalIframe);
    return { iframe, style, floatingIframe, modalIframe };
  };
  var extensionPortOnMsg = async ({
    e,
    iframe,
    extensionPort,
    webappPortReady,
    modalIframe,
    modalPort
  }) => {
    switch (e.data.type) {
      case "OPEN_KINDLE_SETUP":
        chrome.runtime.sendMessage(
          {
            type: "GET_READER_DATA",
            payload: { pageData: getPageData(window.location.href) }
          },
          (response) => {
            const contentId = response?.content?.id;
            if (contentId) {
              modalPort.postMessage({
                type: "SET_CONTENT_ID",
                payload: { contentId }
              });
            }
          }
        );
        closePopup(iframe, extensionPort);
        setTimeout(() => {
          document.activeElement && document.activeElement instanceof HTMLElement && document.activeElement.blur();
          openModal(modalIframe);
        }, 100);
        break;
      case "POPUP_MESSAGE_CHANNEL_READY":
        webappPortReady.current = true;
        break;
      case "OPEN_READER":
        openReader(window.location.href);
        break;
      case "CLOSE_POPUP":
        closePopup(iframe, extensionPort);
        break;
      case "GET_SAFARI_EXTENSION_ENABLED": {
        const { safariKbdShortcutsEnabled } = await storageGet([
          "safariKbdShortcutsEnabled"
        ]);
        extensionPort.postMessage({
          type: "SAFARI_EXTENSION_ENABLED",
          payload: safariKbdShortcutsEnabled !== false
        });
        break;
      }
      case "GET_PROFILE": {
        const storage = await storageGet(["profile"]);
        if (storage?.profile) {
          extensionPort.postMessage({
            type: "SET_PROFILE",
            payload: { profile: storage.profile }
          });
          modalPort.postMessage({
            type: "SET_PROFILE",
            payload: { profile: storage.profile }
          });
        }
        break;
      }
      case "TOGGLE_SAFARI_SHORTCUTS_ENABLED": {
        const { safariKbdShortcutsEnabled } = await storageGet([
          "safariKbdShortcutsEnabled"
        ]);
        const update = typeof safariKbdShortcutsEnabled === "undefined" ? false : !safariKbdShortcutsEnabled;
        chrome.storage.local.set(
          {
            safariKbdShortcutsEnabled: update
          },
          () => {
            extensionPort.postMessage({
              type: "SAFARI_EXTENSION_ENABLED",
              payload: update
            });
          }
        );
        break;
      }
      case "OPEN_FIREFOX_SHORTCUTS_HELP":
        chrome.runtime.sendMessage({ type: "OPEN_FIREFOX_SHORTCUTS_HELP" });
        break;
      case "OPEN_SHORTCUTS_PAGE":
        chrome.runtime.sendMessage({ type: "OPEN_SHORTCUTS_PAGE" });
        break;
      case "SAVE_PAGE":
        chrome.runtime.sendMessage({
          type: "SAVE_PAGE",
          payload: { pageData: getPageData() }
        });
        break;
      case "SEND_TO_KINDLE": {
        chrome.runtime.sendMessage(
          {
            type: "SEND_TO_KINDLE",
            payload: { pageData: getPageData() }
          },
          async (response) => {
            if (response?.type === "SEND_TO_KINDLE_SUCCESS") {
              extensionPort.postMessage({ type: "SEND_TO_KINDLE_SUCCESS" });
            } else if (response.type === "SEND_TO_KINDLE_FAIL") {
              extensionPort.postMessage({ type: "SEND_TO_KINDLE_FAIL" });
            } else if (response?.type === "NO_KINDLE_ACCOUNT") {
              const storage = await storageGet(["profile"]);
              if (storage.profile) {
                modalPort.postMessage({
                  type: "SET_PROFILE",
                  payload: { profile: storage.profile }
                });
              }
              chrome.runtime.sendMessage(
                {
                  type: "GET_READER_DATA",
                  payload: { pageData: getPageData(window.location.href) }
                },
                (response2) => {
                  const contentId = response2?.content?.id;
                  if (contentId) {
                    modalPort.postMessage({
                      type: "SET_CONTENT_ID",
                      payload: { contentId }
                    });
                  }
                }
              );
              closePopup(iframe, extensionPort);
              setTimeout(() => {
                document.activeElement && document.activeElement instanceof HTMLElement && document.activeElement.blur();
                openModal(modalIframe);
              }, 100);
            }
          }
        );
        break;
      }
      case "SET_ENTRY_ATTRIBUTES": {
        const { payload } = e.data;
        chrome.runtime.sendMessage(
          {
            type: "SET_ENTRY_ATTRIBUTES",
            payload
          },
          (response) => {
            if (response.msgId) {
              if (response.status === "SUCCEEDED") {
                setMatterSessionStorageByUrl(window.location.href, {
                  key: "attributes",
                  value: {
                    libraryState: payload.attributes.library_state,
                    note: payload.attributes.note,
                    isFavorited: payload.attributes.is_favorited,
                    tags: payload.attributes.tags
                  }
                });
              }
              extensionPort.postMessage({
                type: "RESOLVE_MSG_ID",
                payload: { msgId: response.msgId, status: response.status }
              });
            }
          }
        );
        break;
      }
    }
  };
  var parseAnnotationFromReaderData = (response, {
    hiddenTextEls,
    range,
    selectionString: initialSelectionString,
    rangeClone,
    extensionPort,
    iframe,
    href,
    marks
  }) => {
    if (!response.success) {
      openPopup(iframe, extensionPort, false, "Sorry, highlight failed");
      marks.forEach((mark) => {
        mark.removeEventListener("click", markListener);
        if (isHTMLElement(mark)) {
          unwrapElement(mark);
        }
      });
      return;
    }
    setMatterSessionStorageByUrl(href, {
      key: "readerData",
      value: response
    });
    const content3 = response.content;
    if (!content3.article?.markdown) {
      return;
    }
    const html = entryHTML(content3.article?.markdown);
    const dom = document.createElement("div");
    dom.innerHTML = html.trim();
    dom.querySelectorAll("[data-text-chunk]").forEach((el) => {
      el.outerHTML = el.outerHTML + "\n";
    });
    logger(dom.outerHTML, { shouldConsoleLog: true });
    let selectionString = initialSelectionString?.trim();
    if (!selectionString) {
      return;
    }
    selectionString = selectionString.replaceAll(/\n+/g, "\n");
    logger(`searching for string: ${selectionString}`, {
      shouldConsoleLog: true
    });
    const domTextContent = dom.textContent.replaceAll(/\n+/g, "\n");
    const { commonAncestorContainer } = range;
    const selectionDocFragment = range.cloneContents();
    if (commonAncestorContainer instanceof HTMLElement && commonAncestorContainer.closest("ul")) {
      logger(
        { msg: "Selection range occurs within an unordered list" },
        { shouldConsoleLog: true }
      );
      commonAncestorContainer.closest("ul")?.querySelectorAll("li").forEach((li, idx) => {
        const liText = li.textContent?.trim() || "";
        liText.replaceAll(/\s+/g, " ");
        if (liText && selectionString && selectionString.indexOf(liText) >= 0) {
          selectionString = selectionString.replace(liText, `* ${liText}`);
        }
      });
      selectionString = selectionString.replaceAll("\n* ", " * ");
      logger(
        { msg: `selectionString ul li modifications: ${selectionString}` },
        { shouldConsoleLog: true }
      );
    } else if (selectionDocFragment.querySelector("ul li")) {
      selectionDocFragment.querySelectorAll("ul li").forEach((li) => {
        const liText = li.textContent?.trim() || "";
        liText.replaceAll(/\s+/g, " ");
        if (liText && selectionString && selectionString.indexOf(liText) >= 0) {
          selectionString = selectionString.replace(liText, `* ${liText}`);
        }
      });
    } else if (selectionDocFragment.querySelector("ol li")) {
      selectionDocFragment.querySelectorAll("ol li").forEach((li, idx) => {
        const liText = li.textContent?.trim() || "";
        liText.replaceAll(/\s+/g, " ");
        if (liText && selectionString && selectionString.indexOf(liText) >= 0) {
          selectionString = selectionString.replace(
            liText,
            `${idx + 1}. ${liText}`
          );
        }
      });
    } else if (commonAncestorContainer instanceof HTMLElement && commonAncestorContainer.closest("ol")) {
      commonAncestorContainer.closest("ol")?.querySelectorAll("li").forEach((li, idx) => {
        if (li.textContent && selectionString && selectionString.indexOf(li.textContent) >= 0) {
          const liText = li.textContent?.trim() || "";
          liText.replaceAll(/\s+/g, " ");
          selectionString = selectionString.replace(
            liText,
            `${idx + 1}. ${liText}`
          );
        }
      });
    }
    selectionString = selectionString.replaceAll(/\n+/g, "\n");
    if (domTextContent && !domTextContent.includes(selectionString)) {
      logger(
        {
          msg: "\u26A0\uFE0F Failed to find selection string in DOM text. Removing hidden text and attempting again...",
          level: "warn"
        },
        { shouldConsoleLog: true }
      );
      hiddenTextEls.forEach((el) => {
        if (el.textContent && selectionString && rangeClone?.commonAncestorContainer.contains(el) && selectionString.indexOf(el.textContent.trim()) >= 0) {
          selectionString = selectionString.replace(el.textContent.trim(), "\n");
        }
      });
      logger(`searching for string: ${selectionString}`, {
        shouldConsoleLog: true
      });
      if (!domTextContent.includes(selectionString)) {
        logger(
          {
            msg: "\u26A0\uFE0F Failed to find selection string in DOM text after removing hidden text. Normalizing whitespace and attempting again...",
            level: "warn"
          },
          { shouldConsoleLog: true }
        );
        selectionString = selectionString.replaceAll(/[^\S\r\n]+/g, " ");
        logger(`searching for string: ${selectionString}`, {
          shouldConsoleLog: true
        });
        if (!domTextContent.includes(selectionString)) {
          logger(
            {
              msg: "\u274C Failed to find selection string in DOM text",
              level: "warn"
            },
            { shouldConsoleLog: true }
          );
        }
      }
    } else {
      logger("\u2705 Successfully found selection text in parsed DOM", {
        shouldConsoleLog: true
      });
    }
    selectionString = selectionString.trim();
    const [word_start, word_end] = getSearchStringWordBounds(
      selectionString,
      dom.textContent
    );
    chrome.runtime.sendMessage(
      {
        type: "ADD_ANNOTATION",
        payload: {
          annotation: {
            word_start,
            word_end,
            text: selectionString.trim(),
            content_id: content3.id,
            note: null,
            scope: 2,
            is_liked: false,
            before_text: "",
            after_text: ""
          },
          pageUrl: href
        }
      },
      (response2) => {
        if (!response2?.status || response2.status > 300) {
          openPopup(iframe, extensionPort, false, "Sorry, highlight failed");
        } else if (response2.json && Array.isArray(response2.json)) {
          const didShowHighlightsToast = getMatterSessionStorageValByUrl(href)?.didShowHighlightsToast;
          if (!didShowHighlightsToast) {
            setMatterSessionStorageByUrl(href, {
              key: "didShowHighlightsToast",
              value: true
            });
            openPopup(iframe, extensionPort, false, "View Highlights in Matter");
          }
          const match = response2.json.find(
            ({ text: text3 }) => {
              if (selectionString) {
                return eqTextsByNonWhitepsace(
                  text3,
                  selectionString
                );
              }
            }
          );
          if (match) {
          }
        }
      }
    );
  };
  var runtimeMsgListener = async ({
    message,
    extensionPort,
    iframe,
    webappPortReady,
    popoverPort
  }) => {
    const isLoggedIn = await checkLogin();
    if (!isLoggedIn) {
      openLogin();
      return;
    }
    await (0, import_p_wait_for2.default)(() => {
      return webappPortReady.current;
    });
    switch (message.type) {
      case "ICON_CLICK":
        openPopup(iframe, extensionPort);
        break;
      case "CONTEXT_MENU_REQUEST_SAVE":
      case "COMMAND_SAVE":
        savePageOrLink({ iframe, extensionPort });
        break;
      case "CONTEXT_MENU_TOGGLE_READER_VIEW":
      case "COMMAND_OPEN_READER_VIEW":
        openReader(window.location.href);
        break;
      case "COMMAND_SAVE_AND_TAG":
        openPopup(iframe, extensionPort);
        extensionPort.postMessage({ type: "OPEN_TAGS_MENU" });
        break;
      case "COMMAND_SAVE_AND_NOTE":
        openPopup(iframe, extensionPort);
        extensionPort.postMessage({ type: "OPEN_NOTE_MENU" });
        break;
      case "HIGHLIGHT_TEXT": {
        const hiddenTextEls = [...document.querySelectorAll("*")].filter(
          (el) => isHTMLElement(el) && el.offsetParent === null && el.textContent && el.textContent?.trim().length > 0
        );
        let range = false;
        const originalSelection = window.getSelection()?.toString();
        try {
          range = getCurrentSelection(
            document.body,
            chunkSelector
          );
        } catch (err) {
          chrome.runtime.sendMessage({
            type: "WORDS_SELECTION_ERROR",
            payload: { url: window.location.href, originalSelection }
          });
          openPopup(iframe, extensionPort, false, "Sorry, highlight failed");
          window.getSelection()?.empty();
        }
        if (!range) {
          return;
        }
        let container = range.commonAncestorContainer.cloneNode(true);
        if (container && !(container instanceof HTMLElement)) {
          container = container.parentElement;
        }
        if (container instanceof HTMLElement) {
          container.setAttribute("data-text-chunk", "true");
        }
        const id = nanoid();
        let marks = [];
        tooltipMap.set(id, window.getSelection()?.toString() || "");
        marks = highlight(
          range,
          /* @__PURE__ */ new Map([["data-annotation-id", id]])
        );
        popoverPort.postMessage({
          type: "SET_SELECTION_TEXT",
          payload: { text: window.getSelection()?.toString() || "" }
        });
        marks.forEach((mark) => {
          if (mark instanceof HTMLElement) {
            mark.setAttribute("data-open-web-highlight", "true");
            mark.removeEventListener("click", markListener);
            mark.addEventListener("click", markListener);
            const { lineHeight } = window.getComputedStyle(mark);
            if (lineHeight === "normal") {
              mark.setAttribute("data-line-height-normal", "true");
            }
          }
        });
        safariHandleMutatedRange(range);
        const selectionString = window.getSelection()?.toString();
        const rangeClone = window.getSelection()?.getRangeAt(0).cloneRange();
        window.getSelection()?.empty();
        const { href, matchedNonWindowHref } = getHref(
          rangeClone?.startContainer
        );
        const existingReaderData = getMatterSessionStorageValByUrl(href)?.readerData?.[href];
        if (existingReaderData) {
          parseAnnotationFromReaderData(existingReaderData, {
            range,
            hiddenTextEls,
            selectionString,
            rangeClone,
            iframe,
            extensionPort,
            href,
            marks
          });
        } else {
          chrome.runtime.sendMessage(
            {
              type: "GET_READER_DATA",
              payload: { pageData: getPageData(href, matchedNonWindowHref) }
            },
            (response) => {
              if (range instanceof Range) {
                parseAnnotationFromReaderData(response, {
                  range,
                  hiddenTextEls,
                  selectionString,
                  rangeClone,
                  iframe,
                  extensionPort,
                  href,
                  marks
                });
              }
            }
          );
        }
        break;
      }
      case "SAVE_LINK_TO_MATTER":
        savePageOrLink({
          iframe,
          extensionPort,
          pageData: {
            url: message.payload
          },
          asLink: true
        });
        break;
      case "SAVE_PAGE_RESULT":
        if (message.payload.status && message.payload.status >= 400 || message.payload.error) {
          deleteMatterSessionStorageValByUrl(window.location.href);
          extensionPort.postMessage({
            type: "SAVE_PAGE_FAILED",
            payload: message.payload
          });
        } else {
          setMatterSessionStorageByUrl(window.location.href, {
            key: "libraryState",
            value: libraryState.LIBRARY_STATE_SAVED
          });
          extensionPort.postMessage({
            type: "SAVE_PAGE_SUCCEEDED",
            payload: message.payload
          });
          setMatterSessionStorageByUrl(window.location.href, {
            key: "contentStatus",
            value: message.payload.json
          });
        }
        break;
    }
    return true;
  };
  var onReaderView = () => {
    if (window.location.origin !== "https://web.getmatter.com" && window.location.origin !== webappUrlNew || window.location.pathname !== "/reader") {
      return;
    }
    const url = new URL(window.location.href);
    chrome.runtime.sendMessage(
      {
        type: "READER_VIEW_READY",
        payload: {
          url: decodeURIComponent(url.searchParams.get("url") || "")
        }
      },
      (response) => {
        sessionStorage.setItem(
          `mrReaderData:${url.searchParams.get("url") || ""}`,
          JSON.stringify(response)
        );
        chrome.storage.local.remove([
          `ReaderViewData:${url.searchParams.get("url")}`
        ]);
      }
    );
  };
  var main = () => {
    let channel = new MessageChannel();
    let popoverChannel = new MessageChannel();
    let modalChannel = new MessageChannel();
    const { iframe, style, floatingIframe, modalIframe } = initIframe();
    const floatingIframeClickListener = (e) => {
      e.stopPropagation();
    };
    floatingIframe.addEventListener("click", floatingIframeClickListener);
    const markCustomClickListener = (e) => {
      if (e.detail.annotationId) {
        popoverChannel.port1.postMessage({
          type: "SET_ANNOTAION_ID",
          payload: { id: e.detail.annotationId }
        });
      }
    };
    floatingIframe.addEventListener("MATTER:MARK_CLICK", markCustomClickListener);
    const windowClickListener = () => {
      if (floatingIframe.getAttribute("data-matter-active") === "true") {
        closePopover(floatingIframe, popoverChannel.port1);
      }
    };
    window.addEventListener("click", windowClickListener);
    const windowMsgListener = (e) => {
      if (iframe.contentWindow && e.data.type === "WEB_EXT_IFRAME_READY") {
        try {
          iframe.contentWindow.postMessage("INIT_POPUP_MESSAGE_CHANNEL", "*", [
            webappPort
          ]);
        } catch (error) {
          console.warn(
            "Failed to transfer MessageChannel port, will attempt once more.",
            error
          );
          channel = new MessageChannel();
          extensionPort = channel.port1;
          webappPort = channel.port2;
          try {
            iframe.contentWindow.postMessage("INIT_POPUP_MESSAGE_CHANNEL", "*", [
              webappPort
            ]);
          } catch (error2) {
            chrome.runtime.sendMessage({
              type: "ERROR",
              payload: "Failed on 2 attempts to establish a MessageChannel"
            });
          }
        }
      }
      if (floatingIframe.contentWindow && e.data.type === "WEB_EXT_POPOVER_IFRAME_READY") {
        popoverChannel.port1.onmessage = (e2) => {
          if (e2.data.type === "DELETE_ANNOTATION") {
            const marks = document.querySelectorAll(
              `mark[data-annotation-id="${activeAnnotation.current}"]`
            );
            let { href } = window.location;
            marks.forEach((mark, idx) => {
              if (idx === 0) {
                href = getHref(mark).href;
              }
              mark.removeEventListener("click", markListener);
              if (isHTMLElement(mark)) {
                unwrapElement(mark);
              }
            });
            closePopover(floatingIframe, popoverChannel.port1);
            const text3 = activeAnnotation.current && tooltipMap.get(activeAnnotation.current);
            if (text3) {
              chrome.runtime.sendMessage({
                type: "DELETE_ANNOTATION",
                payload: { text: text3, url: href }
              });
            }
          } else if (e2.data.type === "ANNOTATION_NOTE") {
            const text3 = activeAnnotation.current && tooltipMap.get(activeAnnotation.current);
            const note = e2.data.payload.note;
            const marks = document.querySelectorAll(
              `mark[data-annotation-id="${activeAnnotation.current}"]`
            );
            let { href } = window.location;
            marks.forEach((mark, idx) => {
              if (idx === 0) {
                href = getHref(mark).href;
              }
              mark.setAttribute("data-annotation-has-note", "true");
            });
            chrome.runtime.sendMessage(
              {
                type: "ANNOTATION_NOTE",
                payload: { text: text3, note, url: href }
              },
              (response) => {
                if (response.status && response.status < 400) {
                  popoverChannel.port1.postMessage({
                    type: "SET_NOTE",
                    payload: { note, id: activeAnnotation.current }
                  });
                } else {
                  openPopup(iframe, extensionPort, false, "Sorry, note failed");
                  marks.forEach((mark, idx) => {
                    mark.removeAttribute("data-annotation-has-note");
                  });
                }
              }
            );
            closePopover(floatingIframe, popoverChannel.port1);
          }
        };
        floatingIframe.contentWindow.postMessage(
          "INIT_POPOVER_MESSAGE_CHANNEL",
          "*",
          [popoverChannel.port2]
        );
      }
      if (modalIframe.contentWindow && e.data.type === "WEB_EXT_MODAL_IFRAME_READY") {
        modalChannel.port1.onmessage = (e2) => {
          switch (e2.data.type) {
            case "CLOSE_MODAL":
              closeModal(modalIframe);
              break;
            case "SET_KINDLE_EMAIL":
              chrome.runtime.sendMessage(
                {
                  type: "SET_KINDLE_EMAIL",
                  payload: e2.data.payload
                },
                (response) => {
                  if (response.type === "SET_KINDLE_EMAIL_SUCCESS") {
                    closeModal(modalIframe);
                    openPopup(iframe, extensionPort, false, "Sent to Kindle");
                  }
                }
              );
              break;
          }
        };
        modalIframe.contentWindow.postMessage("INIT_MODAL_MESSAGE_CHANNEL", "*", [
          modalChannel.port2
        ]);
      }
      if ((e.origin === "https://web.getmatter.com" || e.origin === webappUrlNew) && e.data === "MATTER_OPEN_SHORTCUTS") {
        chrome.runtime.sendMessage({ type: "OPEN_SHORTCUTS_PAGE" });
      }
    };
    window.addEventListener("message", windowMsgListener);
    const { contentWindow } = iframe;
    if (!contentWindow) {
      return;
    }
    let extensionPort = channel.port1;
    let webappPort = channel.port2;
    const webappPortReady = { current: false };
    extensionPort.onmessage = (e) => extensionPortOnMsg({
      e,
      iframe,
      extensionPort,
      webappPortReady,
      modalIframe,
      modalPort: modalChannel.port1
    });
    onReaderView();
    const runtimeMsgHandler = (message, _, sendResponse) => {
      runtimeMsgListener({
        message,
        extensionPort,
        iframe,
        webappPortReady,
        popoverPort: popoverChannel.port1
      });
      sendResponse(null);
      return true;
    };
    chrome.runtime.onMessage.addListener(runtimeMsgHandler);
    const handleEscKeyDown = (e) => {
      if (e.key === "Escape") {
        closePopup(iframe, extensionPort);
      }
    };
    const handleClickOutside = ({ target }) => {
      if (!target || !(target instanceof Node) || iframe.contains(target) || target === iframe) {
        return;
      }
      closePopup(iframe, extensionPort);
    };
    window.addEventListener("keydown", handleEscKeyDown);
    document.addEventListener("click", handleClickOutside);
    const handleWebAppLogout = () => {
      chrome.storage.local.clear();
    };
    window.addEventListener("MR_WEBAPP_LOGOUT", handleWebAppLogout);
    const cleanup = () => {
      window.removeEventListener("keydown", handleEscKeyDown);
      document.removeEventListener("click", handleClickOutside);
      extensionPort.close();
      webappPort.close();
      iframe.parentNode?.removeChild(iframe);
      style.parentNode?.removeChild(style);
      chrome.runtime.onMessage.removeListener(runtimeMsgHandler);
      window.removeEventListener("MR_EXTENSION_RELOAD", cleanup);
      window.removeEventListener("message", windowMsgListener);
      window.removeEventListener("MR_WEBAPP_LOGOUT", handleWebAppLogout);
      floatingIframe.removeEventListener("click", floatingIframeClickListener);
      floatingIframe.removeEventListener(
        "MATTER:MARK_CLICK",
        markCustomClickListener
      );
      window.removeEventListener("click", windowClickListener);
      floatingIframe.remove();
      modalIframe.remove();
      popoverChannel.port1.close();
      popoverChannel.port2.close();
      modalChannel.port1.close();
      modalChannel.port2.close();
    };
    window.addEventListener("MR_EXTENSION_RELOAD", cleanup);
  };
  main();
})();
/*! js-cookie v3.0.1 | MIT */
